unit abcconst;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

resourcestring

  sabcnpMsgCommit = 'Commit all changes in this transaction?';
  sabcnpMsgRollback = 'Undo all changes in this transaction?';
  sabcnpBmksErrMenuStrings = 'Invalid number of strings for menu items - 4 strings expected';
  sabcnpPrimaryKeyText  = '<Primary Key>';
  sabcnpErrItemFormat1  = ''';'' not found in item ''%s''.  Expected format ''ItemText;IndexNumber''';
  sabcnpErrItemFormat2  = 'ItemText not found in item ''%s''.  Expected format ''ItemText;IndexNumber''';
  sabcnpErrItemFormat3  = 'Index number not found in item ''%s''.  Expected format ''ItemText;IndexNumber''';
  sabcnperrTableRequired = 'DataSet of class TTable required';
  sabcnpErrIndexRange = 'Index number ''%d'' not found in DataSet.IndexDefs';
  sabcFilterBMPAll = 'Bitmaps (*.BMP)|*.bmp|All Files (*.*)|*.*';
  sabcFilterICOAll = 'Icons (*.ICO)|*.ico|All Files (*.*)|*.*';
  sabcFilterWMFAll = 'Metafiles (*.WMF)|*.wmf|All Files (*.*)|*.*';
  sabcFilterTXTAll = 'Text Files (*.TXT)|*.txt|All Files (*.*)|*.*';
  sabcFilterAll = 'All Files (*.*)|*.*';
  sabcErrTableRequired = 'Required table parameter is nil';
  sabcErrNoIndexFields = 'Table has no index fields';
  sabcErrTableInactive = 'Table must be active';
  sabcErrQueryRequired = 'Required query parameter is nil';
  sabcErrQueryParams = 'Query has no parameters';
  sabcnpErrReplaceReadOnly = 'Cannot replace records in read only DataSet';
  sabcnpErrReplaceFieldNoModify = 'Current field cannot be modified';
  sabcKeysErrFourExpected = 'Four KeyState strings expected';
  sabcKeysErrLength = 'KeyState strings cannot exceed 255 characters total length';
  sabcErrDataSourceRequired = 'DataSource required';
  sabcErrDataSetRequired = 'DataSet required';
  sabcErrDataSetInactive = 'DataSet is not active';
  sabcErrFilterHandle = 'Invalid filter handle.  Filter must be prepared before use';
  sabcErrFilterExprEmpty = 'Filter expression is empty';
  sabcErrFltExprTermination = 'Filter expression incorrectly terminated';
  sabcErrFltExprNameError = 'Unterminated field name';
  sabcErrFltExprStringError = 'Unterminated string constant';
  sabcErrFltExprInvalidChar = 'Invalid filter expression character: ''%s''';
  sabcErrFltExprNoRParen = ''')'' expected but %s found';
  sabcErrFltExprExpected = 'Expression expected but %s found';
  sabcErrFltExprBadCompare = 'Relational operators require a field and a constant';
  sabcErrFltExprBadField = 'Field ''%s'' cannot be used in a filter expression';
  sabcErrFltExprBadNullTest = 'NULL only allowed with ''='' and ''<>''';
  sabcErrFltExprRangeError = 'Constant out of range';
  sabcErrFltExprNotBoolean = 'Field ''%s'' is not of type Boolean';
  sabcErrFltExprIncorrect = 'Incorrectly formed filter expression';
  sabcErrFltExprNothing = 'nothing';

  sabcErrWaveData = 'Error reading wave data';
  sabcErrWaveFormat = 'Wave image is not a valid wave file format';
  sabcErrResDllLoad = 'Error %d loading DLL ''%s''';
  sabcErrRCDataResNotFound = 'Resource ''%s'' of type RCDATA not found';
  sabcErrResLoad = 'Unable to load resource ''%s''';
  sabcErrResLock = 'Unable to lock resource ''%s''';
  sabcErrFormNameExpected = 'FormName expected';
  sabcErrNoMCIData = 'No MCIData to Open';
  sabcErrPathMustExist = '%s%sThis path does not exist.%sPlease enter a different path.';
  sabcErrPathNotExist = '%s%sThis path already exists.%sPlease enter a different path.';
  sabcConfirmPathCreate = '%s%sThis path does not exist.%sAre you sure you want to create this path?';
  sabcConfirmPathExists = '%s%sThis path already exists.%sAre you sure you want to use this path?';
  sabcErrInvalidDrive = '%s%sDrive does not exist.%sPlease choose a different drive.';
  sabcErrInvalidFileName = '%s%sInvalid Filename.%sPlease enter a different path.';
  sabcPaneIndexError = '%d is an invalid PaneIndex value.  PaneIndex must be between 0 and %d';
  sabcConfirmExcepTerminate = 'Do you want to terminate this program?';

  sabcnpFindBOF = 'First record reached.  Continue searching from last record?';
  sabcnpFindEOF = 'Last record reached.  Continue searching from first record?';
  sabcnpFindNotFound = '''%s'' not found.';
  sabcnpFindNotFoundField = '''%s'' not found in current field.';
  sabcnpFindReplaceCount = '%d values replaced.';

  sabcErrorOwnerSingleComponent = 'An instance of %s is already owned by %s';
  sabcErrorOwnerFormExpected = 'This component must be owned by a TForm';
  sabcErrorOwnerMDIFormExpected = 'This component must be owned by an MDI Main Form';
  sabcErrorOwnerWelcomeTipsExpected = 'This component must be owned by TabcCustomWelcomeTips';

  sabcErrorSingleInstanceIdleTimeout = 'TabcIdleTimeout already exists in this application. Only one instance is needed.';

  sabcErrorCannotDecodeHextoAscii = 'Cannot decode hex to ascii.';

  sabcDBTreeRecursive = 'Cannot add more tree levels below a recursive datasource.';

  sabcErrorBitmapNeeded = 'A bitmap image is needed';

  sabcErrorHintManagerOwner = 'Hint Manager expected as owner';
  sabcHintFormCaption = 'Edit Hint';
  sabcErrorHelpManagerOwner = 'Help Manager expected as owner';
  sabcHelpFormCaption = 'Help - ';
  sabcHelpFormEditCaption = 'Edit Help - ';

  sabcButtonListDelete = 'Are you sure you want to delete ''%s''?';

  sabcRichEditPopupMenuEdit = '&Edit';
  sabcRichEditPopupMenuClear = 'Clea&r';
  sabcRichEditPopupMenuCancel = '&Cancel';
  sabcRichEditPopupMenuLoadTemplate = '&Load Template';
  sabcRichEditPopupMenuFileOpen = '&Open File...';
  sabcRichEditPopupMenuFileSaveAs = '&Save As...';
  sabcRichEditPopupMenuPrint = '&Print';
  sabcRichEditPopupMenuPageSetup = 'Pa&ge Setup';
  sabcRichEditPopupMenuUndo = '&Undo';
  sabcRichEditPopupMenuCut = 'Cut';
  sabcRichEditPopupMenuCopy = 'Copy';
  sabcRichEditPopupMenuPaste = 'Paste';
  sabcRichEditPopupMenuDelete = 'Delete';
  sabcRichEditPopupMenuSelectAll = 'Se&lect All';
  sabcRichEditPopupMenuBold = '&Bold';
  sabcRichEditPopupMenuItalic = '&Italic';
  sabcRichEditPopupMenuUnderline = '&Underline';
  sabcRichEditPopupMenuFont = '&Font...';
  sabcRichEditPopupMenuBullet = 'B&ullet';
  sabcRichEditPopupMenuFind = 'Find...';
  sabcRichEditPopupMenuReplace = 'Replace...';

  sabcRichEditFileDialogFilter = 'Rich Text Format (*.rtf)|*.rtf|All Files (*.*)|*.*';

  sabcRichEditCannotFind = 'Cannot find ''%s''';

  sabcRichEditEditorConfirmation = 'Save changes?';
  sabcRichEditEditorStatusPanel0 = 'Line: %3d   Col: %3d';
  sabcRichEditEditorStatusPanel1 = 'Modified';

  sabcWelcomeCaption = 'Welcome';
  sabcWelcomeCaptionTip = 'Did you know...';
  sabcWelcomeAppTitleMask = '#AppTitle#';
  sabcWelcomeCaptionShowNext = '&Show this Welcome Screen the next time you start #AppTitle#';
  sabcWelcomeCaptionGreeting1 = 'Welcome to #AppTitle#';
  sabcWelcomeCaptionProgress = 'Please wait while #AppTitle# loads ...';
  sabcWelcomeWarningIniNotFound = 'Ini File "%s" was not found.';
  sabcWelcomeWarningSharedIniNotFound = 'Shared Tip File "%s" was not found.';

  sabcWelcomeIniTipSection = 'TIPS';
  sabcWelcomeIniTipTextSection = 'TIP TEXT';
  sabcWelcomeIniTipShow = 'ShowOnStartup';
  sabcWelcomeIniNextTip = 'NextTip';
  sabcWelcomeIniTipPrefix = 'Tip';

  sabcMenuMDIMinBtnHint = 'Minimize Window';
  sabcMenuMDIRestoreBtnHint = 'Restore Window';
  sabcMenuMDICloseBtnHint = 'Close Window';
  sabcMenuToolbarCaption = 'Menu Bar';

  sabcConfirmRemoveButtonBarGroup = 'Are you sure you want to remove the "%S" group?';
  sabcConfirmRemoveButtonListItem = 'Are you sure you want to remove this item?';

  sabcWarningnpCustomDataSourceEditParent =
    'The TabcnpDataSourceEdit button will not operate correctly' + #13#10 +
    'when its parent NavPanel or NavToolbar AutoDataSource property is False.';

implementation

end.
