unit abcdblr;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, Controls, DBCtrls;

type
  TabcLRDBComboBox = class(TDBComboBox)
  private
    FSaveItemIndex: Integer;
  protected
    procedure CreateHandle; override;
    procedure DestroyWnd; override;
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{ TabcLRDBComboBox }

constructor TabcLRDBComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSaveItemIndex := -1;
end;

procedure TabcLRDBComboBox.CreateHandle;
begin
  inherited CreateHandle;
  if FSaveItemIndex <> -1 then
    ItemIndex := FSaveItemIndex;
end;

procedure TabcLRDBComboBox.DestroyWnd;
begin
  FSaveItemIndex := ItemIndex;
  inherited DestroyWnd;
end;

end.
