unit abcdfcol;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Dialogs;

type
  TabcdfColorStringsEditor = class(TForm)
    Label1: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    btnDefault: TButton;
    btnCustom: TButton;
    ColorDialog1: TColorDialog;
    lstColors: TListBox;
    btnClear: TButton;
    procedure btnCustomClick(Sender: TObject);
    procedure btnDefaultClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure lstColorsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lstColorsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lstColorsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure GetColorStr(const S: string);
  end;

function abcExecColorStringsEditor(Strings: TStrings): TModalResult;

implementation

{$R *.DFM}

function abcExecColorStringsEditor(Strings: TStrings): TModalResult;
begin
  with TabcdfColorStringsEditor.Create(nil) do
  try
    lstColors.Items.Assign(Strings);
    Result := ShowModal;
    if Result = mrOk then Strings.Assign(lstColors.Items);
  finally
    Free;
  end;
end;

procedure TabcdfColorStringsEditor.btnCustomClick(Sender: TObject);
begin
  with ColorDialog1 do
    if Execute then
      lstColors.Items.Add(ColorToString(Color));
end;

procedure TabcdfColorStringsEditor.btnDefaultClick(Sender: TObject);
begin
  GetColorValues(GetColorStr);
end;

procedure TabcdfColorStringsEditor.GetColorStr(const S: string);
begin
  with lstColors.Items do
    if IndexOf(S) = -1 then
      Add(S);
end;

procedure TabcdfColorStringsEditor.btnClearClick(Sender: TObject);
begin
  lstColors.Items.Clear;
end;

procedure TabcdfColorStringsEditor.lstColorsDragOver(Sender,
  Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Sender = Source);
end;

procedure TabcdfColorStringsEditor.lstColorsDragDrop(Sender,
  Source: TObject; X, Y: Integer);
var
  dropIndex: integer;
begin
  with lstColors do
  begin
    dropIndex := (Y div ItemHeight);
    if ItemIndex > -1 then
      Items.Move(ItemIndex, dropIndex);
  end;
end;

procedure TabcdfColorStringsEditor.lstColorsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  saveIndex: Integer;
begin
  if (Key = VK_DELETE) then
    with lstColors do
      if ItemIndex > -1 then
      begin
        saveIndex := ItemIndex;
        Items.Delete(ItemIndex);
        if saveIndex < Items.Count then
          ItemIndex := saveIndex
        else
          ItemIndex := Items.Count - 1;
      end;
end;

end.
