unit abcdfstr;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  StdCtrls, ExtCtrls;

type
  TabcdfStringsEditor = class(TForm)
    Bevel1: TBevel;
    memEdit: TMemo;
    lblLines: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    chkTabs: TCheckBox;
    procedure chkTabsClick(Sender: TObject);
    procedure memEditChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  end;

function abcExecStringsEditor(Strings: TStrings): TModalResult;

implementation

{$R *.DFM}

function abcExecStringsEditor(Strings: TStrings): TModalResult;
begin
  with TabcdfStringsEditor.Create(nil) do
  try
    memEdit.Lines.Assign(Strings);
    Result := ShowModal;
    if Result = mrOk then Strings.Assign(memEdit.Lines);
  finally
    Free;
  end;
end;

procedure TabcdfStringsEditor.chkTabsClick(Sender: TObject);
begin
  memEdit.WantTabs := chkTabs.Checked;
end;

procedure TabcdfStringsEditor.memEditChange(Sender: TObject);
begin
  lblLines.Caption := InttoStr(memEdit.Lines.Count) + ' lines';
end;

procedure TabcdfStringsEditor.FormShow(Sender: TObject);
begin
  memEditChange(Self);
end;

end.
