unit abcdfwav;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses SysUtils, Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, abcwav, Dialogs;

type
  TabcdfWaveEdit = class(TForm)
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    Bevel1: TBevel;
    btnLoad: TButton;
    btnSave: TButton;
    btnClear: TButton;
    btnPlay: TButton;
    imgSound: TImage;
    lblStatus: TLabel;
    Wave: TabcWave;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    lblName: TLabel;
    edName: TEdit;
    procedure btnLoadClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnPlayClick(Sender: TObject);
  private
    { Private declarations }
    procedure CheckStatus;
  public
    { Public declarations }
  end;

function ExecabcdfWaveEdit(ASound: TabcWaveImage): Boolean;
function ExecabcdfWaveEditListItem(var AName: string; ASound: TabcWaveImage): Boolean;

implementation

{$R *.DFM}

function ExecabcdfWaveEdit(ASound: TabcWaveImage): Boolean;
begin
  Result := False;
  with TabcdfWaveEdit.Create(nil) do
  try
    Wave.Sound := ASound;
    CheckStatus;
    if (ShowModal = mrOK) then begin
      ASound.Assign(Wave.Sound);
      Result := True;
    end;
  finally
    Free;
  end;
end;

function ExecabcdfWaveEditListItem(var AName: string; ASound: TabcWaveImage): Boolean;
begin
  Result := False;
  with TabcdfWaveEdit.Create(nil) do
  try
    Wave.Sound := ASound;
    edName.Text := AName;
    lblName.Visible := True;
    edName.Visible := True;
    CheckStatus;
    if (ShowModal = mrOK) then begin
      ASound.Assign(Wave.Sound);
      AName := edName.Text;
      Result := True;
    end;
  finally
    Free;
  end;
end;

procedure TabcdfWaveEdit.CheckStatus;
begin
  if Wave.Sound.Empty then begin
    if Visible then btnOK.SetFocus;
    btnSave.Enabled := False;
    btnClear.Enabled := False;
    btnPlay.Enabled := False;
    lblStatus.Visible := False;
    imgSound.Visible := False;
  end
  else begin
    btnSave.Enabled := True;
    btnClear.Enabled := True;
    btnPlay.Enabled := True;
    lblStatus.Caption := InttoStr(Wave.Sound.Size) + ' Bytes';
    lblStatus.Visible := True;
    imgSound.Visible := True;
  end;
end;

procedure TabcdfWaveEdit.btnLoadClick(Sender: TObject);
var
  S: string;
  ExtPos: Integer;
begin
  if OpenDialog.Execute then begin
    Wave.Sound.LoadFromFile(OpenDialog.FileName);
    if edName.Visible then begin
      S := ExtractFileName(OpenDialog.FileName);
      ExtPos := Pos('.', S);
      if ExtPos > 0 then S := Copy(S, 1, ExtPos - 1);
      edName.Text := S;
    end;
    CheckStatus;
  end;
end;

procedure TabcdfWaveEdit.btnSaveClick(Sender: TObject);
begin
  if SaveDialog.Execute then begin
    Wave.Sound.SaveToFile(SaveDialog.FileName);
  end;
end;

procedure TabcdfWaveEdit.btnClearClick(Sender: TObject);
begin
  Wave.Sound.Clear;
  if edName.Visible then
    edName.Text := '[Empty Wave Image]';
  CheckStatus;
end;

procedure TabcdfWaveEdit.btnPlayClick(Sender: TObject);
begin
  Wave.Play;
end;

end.
