unit abcdsncn;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{ABC Design time string constants and resources}

interface

uses Classes, SysUtils;

const
  ABC_DESIGNER_BTN_COUNT = 35;

resourcestring
  sabcdfHintAboutCaption = 'ABC for Delphi 6';
  sabcdsgnRegKey = 'Software\Objective Software Technology\ABC for Delphi\6.0';
  sabcRelease = '6.0.1';
  sabcCopyright = 'Copyright  1995, 2001 Objective Software Technology Pty Limited';

{$IFDEF ABCCOMPANION}
  sabcEdition = 'Companion Edition';
{$ELSE}
  sabcEdition = 'Licensed Version';
{$ENDIF}

  sabcPropCategoryName = 'ABC for Delphi';
  sabcPropCategoryDescription = 'ABC for Delphi Properties';

  sabcnpCapNone = '{no Caption}';
  sabcnpCapFirst = 'First';
  sabcnpCapBack = 'Back';
  sabcnpCapPrev = 'Prev';
  sabcnpCapNext = 'Next';
  sabcnpCapFwd = 'Forward';
  sabcnpCapLast = 'Last';
  sabcnpCapInsert = 'Insert';
  sabcnpCapAppend = 'Append';
  sabcnpCapDup = 'Duplicate';
  sabcnpCapEdit = 'Edit';
  sabcnpCapEditDataSource = 'Edit...';
  sabcnpCapEditBlob = 'Edit Memo/Graphic';
  sabcnpCapFindReplace = 'Find/Replace';
  sabcnpCapDelete = 'Delete';
  sabcnpCapCancel = 'Cancel';
  sabcnpCapPost = 'Post';
  sabcnpCapRefresh = 'Refresh';
  sabcnpCapEmptyTbl = 'Empty';
  sabcnpCapBmk = 'Bookmark';
  sabcnpCapBmks = 'Bookmarks';
  sabcnpCapFindKey = 'Find Key';
  sabcnpCapRange = 'Range';
  sabcnpCapFiltAct = 'Filter Active';
  sabcnpCapFiltExpr = 'Filter Expression';
  sabcnpCapStartTrans = 'Start Trans';
  sabcnpCapCommit = 'Commit';
  sabcnpCapRollback = 'Rollback';
  sabcnpCapQryParms = 'Query Params';
  sabcnpCapDBInfo = 'DB Info';
  sabcnpCapCustom = 'Custom';
  sabcnpCapToggle = 'Up/Down';
  sabcnpHintNone = '{no Hint}';
  sabcnpHintUpDown = '{Requires Up + Down Hints}';
  sabcnpHintFirst = 'First|Move to the first record';
  sabcnpHintBack = 'Jump Back|Move back 10 records (hold down to repeat)';
  sabcnpHintPrev = 'Previous|Move back to previous record (hold down to accelerate)';
  sabcnpHintNext = 'Next|Move forward to next record (hold down to accelerate)';
  sabcnpHintFwd = 'Jump Forward|Move forward 10 records (hold down to repeat)';
  sabcnpHintLast = 'Last|Move to last record';
  sabcnpHintInsert = 'Insert New Record|Add a new record at the current position in the records';
  sabcnpHintAppend = 'Append New Record|Add a new record after the last record';
  sabcnpHintDup = 'Duplicate Record|Copy the current record to a new record and edit the new record';
  sabcnpHintEdit = 'Edit|Edit the current record';
  sabcnpHintEditDataSource = 'Edit %datasource%|Display a form to view or edit %datasource% records';
  sabcnpHintEditBlob = 'Edit Memo/Graphic|Edit the current (Memo), (Graphic) or (Blob) field';
  sabcnpHintFindReplace = 'Find/Replace|Find or replace values in the current record or all records';
  sabcnpHintDelete = 'Delete|Delete the current record';
  sabcnpHintCancel = 'Cancel Changes|Cancel new or changed record updates without saving changes';
  sabcnpHintPost = 'Save Changes|Save new or changed records to the database';
  sabcnpHintRefresh = 'Refresh Records|Refresh the screen display from the database';
  sabcnpHintEmptyTbl = 'Empty Table|Delete all records from the table';
  sabcnpHintBmkUp = 'Set Bookmark|Mark this record position with a bookmark';
  sabcnpHintBmkDown = 'Go To Bookmark|Return to the last bookmarked record';
  sabcnpHintBmks = 'Bookmark Menu|Show bookmark popup menu';
  sabcnpHintFindKey = 'Find Key Value|Search for a record using key field values';
  sabcnpHintIndexCbo = 'Sort by Index|Sort the records by a new index';
  sabcnpHintRange = 'Set/Clear Range Filter|Restrict the range of records by first and last key values';
  sabcnpHintRangeEdit = 'Filter range|Type a range expression for the key field, e.g. 1-100 or a-c';
  sabcnpHintFiltActUp = 'Add Filter on Current Field Value|Show only records with the same value as the active field';
  sabcnpHintFiltActDown = 'Remove Filter|Remove the filter on the active field value';
  sabcnpHintFiltExprUp = 'Apply Filter|Apply a filter expression to the records (or right click to edit the filter expression)';
  sabcnpHintFiltExprDown = 'Remove Filter|Turn off this filter';
  sabcnpHintStartTrans = 'Start Transaction|Start a transaction on the database so you can edit many records before committing or rolling back changes';
  sabcnpHintCommit = 'Commit Transaction|Commit the current transaction on the database (makes all changes since the start permanent)';
  sabcnpHintRollback = 'Rollback Transaction|Undo the current transaction on the database (all changes since the start will be lost)';
  sabcnpHintQryParms = 'Edit Query Params|Edit the parameter values used in the query';
  sabcnpHintDBInfo = 'Show Database Info|Show debugging information about the current datasource';
  sabcnpHintCustom = 'Custom Button|This is a custom button';
  sabcnpHintDownNone = '{no Hint Down}';
  sabcnpHintToggleUp = 'Activate Button|Click to activate button';
  sabcnpHintToggleDown = 'Deactivate Button|Click to deactivate button';
  sabcnpdsgnButtons = 'Choose the navigator buttons you would like to add. Use ''>'' to select a single button or all buttons in a group;  click ''>>'' to select every button.';
  sabcnpdsgnGlyphs = 'Choose a set of button glyphs. Hints and captions can be added if required.';
  sabcnpdsgnHints = 'Edit the hint text for your selected buttons.';
  sabcnpdsgnCaptions = 'Edit the caption text for your selected buttons.';
  sabcnpdsgnCaptionStyle = 'Layout the glyph and caption appearance with the following options.';
  sabcnpdsgnButtonSize = 'Choose a button size and number of button rows for the panel.';
  sabcnpdsgnBtnGlyphs = 'Choose a button glyph. A hint and caption can be added if required.';
  sabcnpdsgnBtnCaptionStyle = 'Layout the glyph and caption appearance with the following options.';
  sabcnpdsgnBtnButtonSize = 'Set the size of the button.';
  sabcnpdsgnBtnCaptionHint = 'Edit the hint text and/or caption text for the button.';
  sabcnpdsgnBtnResFIRST = 'FIRST';
  sabcnpdsgnBtnResJUMPB = 'JUMPB';
  sabcnpdsgnBtnResPREV = 'PREV';
  sabcnpdsgnBtnResNEXT = 'NEXT';
  sabcnpdsgnBtnResJUMPF = 'JUMPF';
  sabcnpdsgnBtnResLAST = 'LAST';
  sabcnpdsgnBtnResINSERT = 'INSERT';
  sabcnpdsgnBtnResAPPEND = 'APPEND';
  sabcnpdsgnBtnResDUPREC = 'DUPREC';
  sabcnpdsgnBtnResEDIT = 'EDIT';
  sabcnpdsgnBtnResDSEDIT = 'DSEDIT';
  sabcnpdsgnBtnResEDACT = 'EDACT';
  sabcnpdsgnBtnResFINDREP = 'FINDREP';
  sabcnpdsgnBtnResDELETE = 'DELETE';
  sabcnpdsgnBtnResCANCEL = 'CANCEL';
  sabcnpdsgnBtnResPOST = 'POST';
  sabcnpdsgnBtnResREFRESH = 'REFRESH';
  sabcnpdsgnBtnResEMPTY = 'EMPTY';
  sabcnpdsgnBtnResBMK = 'BMK';
  sabcnpdsgnBtnResBMKS = 'BMKS';
  sabcnpdsgnBtnResFIND = 'FIND';
  sabcnpdsgnBtnResRANGE = 'RANGE';
  sabcnpdsgnBtnResFILTACT = 'FILTACT';
  sabcnpdsgnBtnResFILTER = 'FILTER';
  sabcnpdsgnBtnResSTARTT = 'STARTT';
  sabcnpdsgnBtnResCOMMIT = 'COMMIT';
  sabcnpdsgnBtnResROLLBK = 'ROLLBK';
  sabcnpdsgnBtnResQRYPARM = 'QRYPARM';
  sabcnpdsgnBtnResDBINFO = 'DBINFO';
  sabcnpdsgnBtnResVFIRST = 'VFIRST';
  sabcnpdsgnBtnResVJUMPB = 'VJUMPB';
  sabcnpdsgnBtnResVPREV = 'VPREV';
  sabcnpdsgnBtnResVNEXT = 'VNEXT';
  sabcnpdsgnBtnResVJUMPF = 'VJUMPF';
  sabcnpdsgnBtnResVLAST = 'VLAST';
  sabcnpdsgnBtnResVAPPEND = 'VAPPEND';
  sabcnpdsgnEdFilter = 'Edit Filter...';
  sabcnpdsgnEdIndexCombo = 'Load Items From DataSet';
  sabcnpdsgnEdNavPanel0 = 'Add Navigator Buttons...';
  sabcnpdsgnEdNavPanel1 = 'Delete All Buttons';
  sabcnpdsgnEdNavPanelDelete = 'All controls on the panel will be permanently deleted.%sAre you sure you want to continue?';
  sabcnpdsgnEdNavButton = 'Edit Button Style...';
  sabcdsgnEdLine = 'Edit Line Style...';
  sabcdsgnIndexResult = '%d indexes added';
  sabcdsgnErrNoIndex = 'Table has no indexes';
  sabcnpdsgnListGroup1 = 'Navigate';
  sabcnpdsgnListGroup2 = 'Edit Records';
  sabcnpdsgnListGroup3 = 'Mark & Locate Records';
  sabcnpdsgnListGroup4 = 'Sort & Filter Records';
  sabcnpdsgnListGroup5 = 'SQL Server Transactions';
  sabcnpdsgnListGroup6 = 'Other';
  sabcnpdsgnListFirst = 'First';
  sabcnpdsgnListJumpBack = 'Jump Back';
  sabcnpdsgnListPrev = 'Previous';
  sabcnpdsgnListNext = 'Next';
  sabcnpdsgnListJumpFwd = 'Jump Forward';
  sabcnpdsgnListLast = 'Last';
  sabcnpdsgnListInsert = 'Insert';
  sabcnpdsgnListAppend = 'Append';
  sabcnpdsgnListDupRec = 'Duplicate Record';
  sabcnpdsgnListEdit = 'Edit';
  sabcnpdsgnListEditDataSource = 'Edit/View DataSource';
  sabcnpdsgnListEditBlob = 'Edit Memo/Picture';
  sabcnpdsgnListFindReplace = 'Find/Replace Text';
  sabcnpdsgnListDelete = 'Delete';
  sabcnpdsgnListCancel = 'Cancel';
  sabcnpdsgnListPost = 'Post';
  sabcnpdsgnListRefresh = 'Refresh';
  sabcnpdsgnListEmptyTbl = 'Empty Table';
  sabcnpdsgnListBmk = 'Single Bookmark';
  sabcnpdsgnListBmks = 'Multiple Bookmark';
  sabcnpdsgnListFindKey = 'Find Key';
  sabcnpdsgnListIndexCombo = 'Index ComboBox';
  sabcnpdsgnListRange = 'Range Filter';
  sabcnpdsgnListRangeEdit = 'Range Edit Box';
  sabcnpdsgnListFilterActive = 'Filter Active Control';
  sabcnpdsgnListFilter = 'Filter Expression';
  sabcnpdsgnListStartTrans = 'Start Transaction';
  sabcnpdsgnListCommit = 'Commit';
  sabcnpdsgnListRollbk = 'Rollback';
  sabcnpdsgnListQryParms = 'Edit Query Params';
  sabcnpdsgnListDBInfo = 'Show DB Info';
  sabcnpdsgnListDBState = 'DB State Label';
  sabcnpdsgnListRecCount = 'DB RecordCount Label';
  sabcnpdsgnListCustom = 'Custom Button';
  sabcnpdsgnListToggle = 'Custom Up/Down Button';
  sabcpropdsgnFileSep = '|';
  sabcpropdsgnLogFiles = 'Log files (*.LOG)|*.LOG';
  sabcpropdsgnErrorFiles = 'Error files (*.ERR)|*.ERR';
  sabcpropdsgnTextFiles = 'Text files(*.TXT)|*.TXT';
  sabcpropdsgnAllFiles = 'All files(*.*)|*.*';
  sabcpropdsgnAppErrLog = 'Application Error Log File';
  sabcpropdsgnDBAppExcMsg = 'DatabaseName, LogTableName, MsgTableName and TableType required.';
  sabcpropdsgnDBAppExcOverwrite = 'If tables already exist they will be overwritten.';
  sabcpropdsgnDBAppExcConfirm = ' Are you sure you want to continue?';
  sabcpropdsgnDBAppExcTables = 'Tables completed.';
  sabcpropdsgnDBAppExcTablesErr = 'Error in Create Tables: ';
  sabcpropdsgnERR_TIME = 'ERR_TIME';
  sabcpropdsgnUSER_NAME = 'USER_NAME';
  sabcpropdsgnERR_CLASS = 'ERR_CLASS';
  sabcpropdsgnERR_MSG = 'ERR_MSG';
  sabcpropdsgnEXE_NAME = 'EXE_NAME';
  sabcpropdsgnAPP_NAME = 'APP_NAME';
  sabcpropdsgnSNDR_CLASS = 'SNDR_CLASS';
  sabcpropdsgnSNDR_NAME = 'SNDR_NAME';
  sabcpropdsgnERR_ADDR = 'ERR_ADDR';
  sabcpropdsgnSYS_CLASS = 'SYS_CLASS';
  sabcpropdsgnSYS_MSG = 'SYS_MSG';
  sabcpropdsgnSYS_ADDR = 'SYS_ADDR';
  sabcpropdsgnPRIMARYKEY = 'PRIMARYKEY';
  sabcpropdsgnLogCreated = 'Log table created.';
  sabcpropdsgnMSG_TYPE = 'MSG_TYPE';
  sabcpropdsgnLOG = 'LOG';
  sabcpropdsgnTERMINATE = 'TERMINATE';
  sabcpropdsgnMsgCreated = 'Message table created.';
  sabcpropdsgnAlterTable = 'ALTER TABLE ';
  sabcpropdsgnAddKey1 = 'ADD PRIMARY KEY (ERR_TIME)';
  sabcpropdsgnKey1Added = 'Log table primary key added.';
  sabcpropdsgnAddKey2 = 'ADD PRIMARY KEY (ERR_CLASS)';
  sabcpropdsgnKey2Added = 'Message table primary key added.';
  sabcpropdsgnCreateTables = 'Create Tables';
  sabcpropdsgnDBNameReqd = 'DatabaseName required.';
  sabcpropdsgnDBFExt = '.DBF';
  sabcpropdsgnDBExt = '.DB';
  sabcpropdsgnERRLOG = 'ERRLOG';
  sabcpropdsgnERRMSG = 'ERRMSG';
  sabcpropdsgndatefmt1 = 'c';
  sabcpropdsgndatefmt2 = 't';
  sabcpropdsgndatefmt3 = 'tt';
  sabcpropdsgndatefmt4 = 'ddddd';
  sabcpropdsgndatefmt5 = 'dddddd';
  sabcpropdsgndatefmt6 = 'ddddd h:mm';
  sabcpropdsgndatefmt7 = 'ddddd h:mm ampm';
  sabcpropdsgndatefmt8 = 'dddddd t';
  sabcpropdsgndatefmt9 = 'dddddd tt';
  sabcpropdsgnActive = 'Active';
  sabcpropdsgnDatabaseName = 'DatabaseName';
  sabcpropdsgnParamFmt = '(%s)';
  sabcpropdsgnSQL = 'SQL';
  sabcpropdsgnTableName = 'TableName';
  sabcpropdsgnDataSource = 'DataSource';
  sabcpropdsgnCOLUMNS = 'COLUMNS';
  sabcpropdsgnPARAMS = 'PARAMS';
  sabcpropdsgnWavExt = 'wav';
  sabcpropdsgnWavFiles = 'Wave files (*.wav)|*.wav';
  sabcpropdsgnSelectWaveFile = 'Select Wave File';

  sabcpropdsgnIniFileFltr = 'INI files (*.INI)|*.INI|All files (*.*)|*.*';
  sabcpropdsgnCreatePanes = 'Create Panes';
  sabcpropdsgnRotatePanes = 'Rotate Panes';
  sabcpropdsgnExchangePanes = 'Exchange Panes';
  sabcpropdsgnAlignPanes = 'Align Panes';
  sabcpropdsgnUnlockSplitBar = 'Unlock Split Bar';
  sabcpropdsgnLockSplitBar = 'Lock Split Bar';
  sabcpropdsgnFlatten = 'Flat Style';
  sabcpropdsgnNewPageWithList = 'New Page with List';
  sabcpropdsgnSelectActivePage = 'Select Active Page';
  sabcpropdsgnNewPage = 'New Page';
  sabcpropdsgnNextPage = 'Next Page';
  sabcpropdsgnPrevPage = 'Previous Page';
  sabcpropdsgnSelFrame = 'Select Parent Frame';
  sabcpropResTypes = ',ACCELERATOR,AVI,BITMAP,CURSOR,DIALOG,FONT,FONTDIR,FRM,GROUP_CURSOR,GROUP CURSOR,GROUP_ICON,GROUP ICON,HTML,ICON,MENU,RCDATA,STRING,STRINGTABLE,TOOLBAR,VERSION,WAVE';
  sabcpropdsgnGridColEditor = 'Co&lumns Editor...';

  sabcdfHintAboutlblCompDescCaption = 'Move the mouse over the ABC component palette icons to view extended hints.';

  sabcdsgnRegExplore = 'Explore';

  function ABCDesignNavBtnListName(Index: integer): string;
  function ABCDesignNavComponentClass(Index: integer): TComponentClass;
  function ABCDesignNavBmpResName(Index: integer): string;
  function ABCDesignNavVertBmpResName(Index: integer): string;
  function ABCDesignNavComponentCaption(Index: integer): string;
  function ABCDesignNavComponentHint(Index: integer): string;
  function ABCDesignNavComponentHintDown(Index: integer): string;

  function abcIDEComponentDescription(const abcClassName: string): string;

implementation

{$R abcnpb32.res}

function ABCDesignNavBtnListName(Index: integer): string;
begin
  case Index of
    0: Result := sabcnpdsgnListFirst;
    1: Result := sabcnpdsgnListJumpBack;
    2: Result := sabcnpdsgnListPrev;
    3: Result := sabcnpdsgnListNext;
    4: Result := sabcnpdsgnListJumpFwd;
    5: Result := sabcnpdsgnListLast;
    6: Result := sabcnpdsgnListInsert;
    7: Result := sabcnpdsgnListAppend;
    8: Result := sabcnpdsgnListDupRec;
    9: Result := sabcnpdsgnListEdit;
    10: Result := sabcnpdsgnListEditDataSource;
    11: Result := sabcnpdsgnListEditBlob;
    12: Result := sabcnpdsgnListFindReplace;
    13: Result := sabcnpdsgnListDelete;
    14: Result := sabcnpdsgnListCancel;
    15: Result := sabcnpdsgnListPost;
    16: Result := sabcnpdsgnListRefresh;
    17: Result := sabcnpdsgnListEmptyTbl;
    18: Result := sabcnpdsgnListBmk;
    19: Result := sabcnpdsgnListBmks;
    20: Result := sabcnpdsgnListFindKey;
    21: Result := sabcnpdsgnListIndexCombo;
    22: Result := sabcnpdsgnListRange;
    23: Result := sabcnpdsgnListRangeEdit;
    24: Result := sabcnpdsgnListFilterActive;
    25: Result := sabcnpdsgnListFilter;
    26: Result := sabcnpdsgnListStartTrans;
    27: Result := sabcnpdsgnListCommit;
    28: Result := sabcnpdsgnListRollbk;
    29: Result := sabcnpdsgnListQryParms;
    30: Result := sabcnpdsgnListDBInfo;
    31: Result := sabcnpdsgnListDBState;
    32: Result := sabcnpdsgnListRecCount;
    33: Result := sabcnpdsgnListCustom;
    34: Result := sabcnpdsgnListToggle;
  else
    Result := sabcnpdsgnListFirst;
  end;
end;

function ABCDesignNavComponentClass(Index: Integer): TComponentClass;
const
  C_NAV_CLASSES: array[0..ABC_DESIGNER_BTN_COUNT-1] of string =
   ('TabcnpFirst',
    'TabcnpJumpBack',
    'TabcnpPrev',
    'TabcnpNext',
    'TabcnpJumpFwd',
    'TabcnpLast',
    'TabcnpInsert',
    'TabcnpAppend',
    'TabcnpDuplicateRec',
    'TabcnpEdit',
    'TabcnpDataSourceEdit',
    'TabcnpBlobEdit',
    'TabcnpFindReplace',
    'TabcnpDelete',
    'TabcnpCancel',
    'TabcnpPost',
    'TabcnpRefresh',
    'TabcnpEmptyTable',
    'TabcnpBookmark',
    'TabcnpBookmarkMenu',
    'TabcnpFindKey',
    'TabcnpIndexCombo',
    'TabcnpRange',
    'TabcnpRangeEdit',
    'TabcnpFilterActive',
    'TabcnpFilterExpression',
    'TabcnpSQLStartTrans',
    'TabcnpSQLCommit',
    'TabcnpSQLRollback',
    'TabcnpQueryParams',
    'TabcnpDBInfo',
    'TabcnpState',
    'TabcnpRecordCount',
    'TabcPicSpeedBtn',
    'TabcToggleBtn'
   );
begin
  if (Index < Low(C_NAV_CLASSES)) or (Index > High(C_NAV_CLASSES)) then
    Result := nil
  else
    Result := TComponentClass(GetClass(C_NAV_CLASSES[Index]));
end;

function ABCDesignNavBmpResName(Index: integer): string;
begin
  case Index of
    0: Result := sabcnpdsgnBtnResFIRST;
    1: Result := sabcnpdsgnBtnResJUMPB;
    2: Result := sabcnpdsgnBtnResPREV;
    3: Result := sabcnpdsgnBtnResNEXT;
    4: Result := sabcnpdsgnBtnResJUMPF;
    5: Result := sabcnpdsgnBtnResLAST;
    6: Result := sabcnpdsgnBtnResINSERT;
    7: Result := sabcnpdsgnBtnResAPPEND;
    8: Result := sabcnpdsgnBtnResDUPREC;
    9: Result := sabcnpdsgnBtnResEDIT;
    10: Result := sabcnpdsgnBtnResDSEDIT;
    11: Result := sabcnpdsgnBtnResEDACT;
    12: Result := sabcnpdsgnBtnResFINDREP;
    13: Result := sabcnpdsgnBtnResDELETE;
    14: Result := sabcnpdsgnBtnResCANCEL;
    15: Result := sabcnpdsgnBtnResPOST;
    16: Result := sabcnpdsgnBtnResREFRESH;
    17: Result := sabcnpdsgnBtnResEMPTY;
    18: Result := sabcnpdsgnBtnResBMK;
    19: Result := sabcnpdsgnBtnResBMKS;
    20: Result := sabcnpdsgnBtnResFIND;
    21: Result := ''; {Index Combo}
    22: Result := sabcnpdsgnBtnResRANGE;
    23: Result := ''; {Range Edit Box}
    24: Result := sabcnpdsgnBtnResFILTACT;
    25: Result := sabcnpdsgnBtnResFILTER;
    26: Result := sabcnpdsgnBtnResSTARTT;
    27: Result := sabcnpdsgnBtnResCOMMIT;
    28: Result := sabcnpdsgnBtnResROLLBK;
    29: Result := sabcnpdsgnBtnResQRYPARM;
    30: Result := sabcnpdsgnBtnResDBINFO;
  else
    Result := '';
  end;
end;

function ABCDesignNavVertBmpResName(Index: integer): string;
begin
  case Index of
    0: Result := sabcnpdsgnBtnResVFIRST;
    1: Result := sabcnpdsgnBtnResVJUMPB;
    2: Result := sabcnpdsgnBtnResVPREV;
    3: Result := sabcnpdsgnBtnResVNEXT;
    4: Result := sabcnpdsgnBtnResVJUMPF;
    5: Result := sabcnpdsgnBtnResVLAST;
    7: Result := sabcnpdsgnBtnResVAPPEND;
  else
    Result := ABCDesignNavBmpResName(Index);
  end;
end;

function ABCDesignNavComponentCaption(Index: integer): string;
begin
  case Index of
    0: Result := sabcnpCapFirst;
    1: Result := sabcnpCapBack;
    2: Result := sabcnpCapPrev;
    3: Result := sabcnpCapNext;
    4: Result := sabcnpCapFwd;
    5: Result := sabcnpCapLast;
    6: Result := sabcnpCapInsert;
    7: Result := sabcnpCapAppend;
    8: Result := sabcnpCapDup;
    9: Result := sabcnpCapEdit;
    10: Result := sabcnpCapEditDataSource;
    11: Result := sabcnpCapEditBlob;
    12: Result := sabcnpCapFindReplace;
    13: Result := sabcnpCapDelete;
    14: Result := sabcnpCapCancel;
    15: Result := sabcnpCapPost;
    16: Result := sabcnpCapRefresh;
    17: Result := sabcnpCapEmptyTbl;
    18: Result := sabcnpCapBmk;
    19: Result := sabcnpCapBmks;
    20: Result := sabcnpCapFindKey;
    21: Result := sabcnpCapNone;
    22: Result := sabcnpCapRange;
    23: Result := sabcnpCapNone;
    24: Result := sabcnpCapFiltAct;
    25: Result := sabcnpCapFiltExpr;
    26: Result := sabcnpCapStartTrans;
    27: Result := sabcnpCapCommit;
    28: Result := sabcnpCapRollback;
    29: Result := sabcnpCapQryParms;
    30: Result := sabcnpCapDBInfo;
    31: Result := sabcnpCapNone;
    32: Result := sabcnpCapNone;
    33: Result := sabcnpCapCustom;
    34: Result := sabcnpCapToggle;
  else
    Result := sabcnpCapNone;
  end;
end;

function ABCDesignNavComponentHint(Index: integer): string;
begin
  case Index of
    0: Result := sabcnpHintFirst;
    1: Result := sabcnpHintBack;
    2: Result := sabcnpHintPrev;
    3: Result := sabcnpHintNext;
    4: Result := sabcnpHintFwd;
    5: Result := sabcnpHintLast;
    6: Result := sabcnpHintInsert;
    7: Result := sabcnpHintAppend;
    8: Result := sabcnpHintDup;
    9: Result := sabcnpHintEdit;
    10: Result := sabcnpHintEditDataSource;
    11: Result := sabcnpHintEditBlob;
    12: Result := sabcnpHintFindReplace;
    13: Result := sabcnpHintDelete;
    14: Result := sabcnpHintCancel;
    15: Result := sabcnpHintPost;
    16: Result := sabcnpHintRefresh;
    17: Result := sabcnpHintEmptyTbl;
    18: Result := sabcnpHintBmkUp;
    19: Result := sabcnpHintBmks;
    20: Result := sabcnpHintFindKey;
    21: Result := sabcnpHintIndexCbo;
    22: Result := sabcnpHintRange;
    23: Result := sabcnpHintRangeEdit;
    24: Result := sabcnpHintFiltActUp;
    25: Result := sabcnpHintFiltExprUp;
    26: Result := sabcnpHintStartTrans;
    27: Result := sabcnpHintCommit;
    28: Result := sabcnpHintRollback;
    29: Result := sabcnpHintQryParms;
    30: Result := sabcnpHintDBInfo;
    31: Result := sabcnpHintNone;
    32: Result := sabcnpHintNone;
    33: Result := sabcnpHintCustom;
    34: Result := sabcnpHintToggleUp;
  else
    Result := sabcnpHintNone;
  end;
end;

function ABCDesignNavComponentHintDown(Index: integer): string;
begin
  case Index of
    18: Result := sabcnpHintBmkDown;
    24: Result := sabcnpHintFiltActDown;
    25: Result := sabcnpHintFiltExprDown;
    34: Result := sabcnpHintToggleDown;
  else
    Result := sabcnpHintDownNone;
  end;
end;

resourcestring
  sabcIDECompNameTabcDock = 'TabcDock';
  sabcIDECompNameTabcToolbar = 'TabcToolbar';
  sabcIDECompNameTabcToolWindow = 'TabcToolWindow';
  sabcIDECompNameTabcToolbarButton = 'TabcToolbarButton';
  sabcIDECompNameTabcToolbarSep = 'TabcToolbarSep';
  sabcIDECompNameTabcToolbarEdit = 'TabcToolbarEdit';
  sabcIDECompNameTabcToolbarMaskEdit = 'TabcToolbarMaskEdit';
  sabcIDECompNameTabcToolbarDBEdit = 'TabcToolbarDBEdit';
  sabcIDECompNameTabcMainMenu = 'TabcMainMenu';
  sabcIDECompNameTabcMenuToolbar = 'TabcMenuToolbar';
  sabcIDECompNameTabcPopupMenu = 'TabcPopupMenu';
  sabcIDECompNameTabcSystemMenu = 'TabcSystemMenu';
  sabcIDECompNameTabcMenuImages = 'TabcMenuImages';
  sabcIDECompNameTabcNavToolbar = 'TabcNavToolbar';
  sabcIDECompNameTabcNavPanel = 'TabcNavPanel';
  sabcIDECompNameTabcNavFormLink = 'TabcNavFormLink';
  sabcIDECompNameTabcnpFirst = 'TabcnpFirst';
  sabcIDECompNameTabcnpJumpBack = 'TabcnpJumpBack';
  sabcIDECompNameTabcnpPrev = 'TabcnpPrev';
  sabcIDECompNameTabcnpNext = 'TabcnpNext';
  sabcIDECompNameTabcnpJumpFwd = 'TabcnpJumpFwd';
  sabcIDECompNameTabcnpLast = 'TabcnpLast';
  sabcIDECompNameTabcnpInsert = 'TabcnpInsert';
  sabcIDECompNameTabcnpAppend = 'TabcnpAppend';
  sabcIDECompNameTabcnpDuplicateRec = 'TabcnpDuplicateRec';
  sabcIDECompNameTabcnpEdit = 'TabcnpEdit';
  sabcIDECompNameTabcnpDataSourceEdit = 'TabcnpDataSourceEdit';
  sabcIDECompNameTabcnpBlobEdit = 'TabcnpBlobEdit';
  sabcIDECompNameTabcnpFindReplace = 'TabcnpFindReplace';
  sabcIDECompNameTabcnpDelete = 'TabcnpDelete';
  sabcIDECompNameTabcnpCancel = 'TabcnpCancel';
  sabcIDECompNameTabcnpPost = 'TabcnpPost';
  sabcIDECompNameTabcnpRefresh = 'TabcnpRefresh';
  sabcIDECompNameTabcnpEmptyTable = 'TabcnpEmptyTable';
  sabcIDECompNameTabcnpBookmark = 'TabcnpBookmark';
  sabcIDECompNameTabcnpBookmarkMenu = 'TabcnpBookmarkMenu';
  sabcIDECompNameTabcnpFindKey = 'TabcnpFindKey';
  sabcIDECompNameTabcnpIndexCombo = 'TabcnpIndexCombo';
  sabcIDECompNameTabcnpRange = 'TabcnpRange';
  sabcIDECompNameTabcnpRangeEdit = 'TabcnpRangeEdit';
  sabcIDECompNameTabcnpFilterActive = 'TabcnpFilterActive';
  sabcIDECompNameTabcnpFilterExpression = 'TabcnpFilterExpression';
  sabcIDECompNameTabcnpSQLStartTrans = 'TabcnpSQLStartTrans';
  sabcIDECompNameTabcnpSQLCommit = 'TabcnpSQLCommit';
  sabcIDECompNameTabcnpSQLRollback = 'TabcnpSQLRollback';
  sabcIDECompNameTabcnpQueryParams = 'TabcnpQueryParams';
  sabcIDECompNameTabcnpDBInfo = 'TabcnpDBInfo';
  sabcIDECompNameTabcnpState = 'TabcnpState';
  sabcIDECompNameTabcnpRecordCount = 'TabcnpRecordCount';
  sabcIDECompNameTabcDBTreeView = 'TabcDBTreeView';
  sabcIDECompNameTabcDBRichEdit = 'TabcDBRichEdit';
  sabcIDECompNameTabcDBSuperNav = 'TabcDBSuperNav';
  sabcIDECompNameTabcDBEditWin = 'TabcDBEditWin';
  sabcIDECompNameTabcHDBGrid = 'TabcHDBGrid';
  sabcIDECompNameTabcDBIndexCombo = 'TabcDBIndexCombo';
  sabcIDECompNameTabcDBFilter = 'TabcDBFilter';
  sabcIDECompNameTabcDBRangeEdit = 'TabcDBRangeEdit';
  sabcIDECompNameTabcDBAutoEdit = 'TabcDBAutoEdit';
  sabcIDECompNameTabcDBFixedGrid = 'TabcDBFixedGrid';
  sabcIDECompNameTabcDBEditLabel = 'TabcDBEditLabel';
  sabcIDECompNameTabcDBRecordCount = 'TabcDBRecordCount';
  sabcIDECompNameTabcDBState = 'TabcDBState';
  sabcIDECompNameTabcDBCurrencyLabel = 'TabcDBCurrencyLabel';
  sabcIDECompNameTabcLRDBComboBox = 'TabcLRDBComboBox';
  sabcIDECompNameTabcAppException = 'TabcAppException';
  sabcIDECompNameTabcDSAppException = 'TabcDSAppException';
  sabcIDECompNameTabcDBHintManager = 'TabcDBHintManager';
  sabcIDECompNameTabcDBHelpManager = 'TabcDBHelpManager';
  sabcIDECompNameTabcAnimationFrame = 'TabcAnimationFrame';
  sabcIDECompNameTabcFormPanel = 'TabcFormPanel';
  sabcIDECompNameTabcButtonBar = 'TabcButtonBar';
  sabcIDECompNameTabcButtonList = 'TabcButtonList';
  sabcIDECompNameTabcPictureGroup = 'TabcPictureGroup';
  sabcIDECompNameTabcMultiSplit = 'TabcMultiSplit';
  sabcIDECompNameTabcQuadSplit = 'TabcQuadSplit';
  sabcIDECompNameTabcTriSplit = 'TabcTriSplit';
  sabcIDECompNameTabcBiSplit = 'TabcBiSplit';
  sabcIDECompNameTabcSplitBar = 'TabcSplitBar';
  sabcIDECompNameTabcSMultiSplit = 'TabcSMultiSplit';
  sabcIDECompNameTabcSQuadSplit = 'TabcSQuadSplit';
  sabcIDECompNameTabcSTriSplit = 'TabcSTriSplit';
  sabcIDECompNameTabcSBiSplit = 'TabcSBiSplit';
  sabcIDECompNameTabcEdgePanel = 'TabcEdgePanel';
  sabcIDECompNameTabcDragPanel = 'TabcDragPanel';
  sabcIDECompNameTabcSpeedPanel = 'TabcSpeedPanel';
  sabcIDECompNameTabcHintBar = 'TabcHintBar';
  sabcIDECompNameTabcShapeForm = 'TabcShapeForm';
  sabcIDECompNameTabcRichEdit = 'TabcRichEdit';
  sabcIDECompNameTabcFormTabbedNoteBook = 'TabcFormTabbedNoteBook';
  sabcIDECompNameTabcFormNoteBook = 'TabcFormNoteBook';
  sabcIDECompNameTabcCheckListBox = 'TabcCheckListBox';
  sabcIDECompNameTabcFontComboBox = 'TabcFontComboBox';
  sabcIDECompNameTabcColorComboBox = 'TabcColorComboBox';
  sabcIDECompNameTabcLine = 'TabcLine';
  sabcIDECompNameTabcButtonEdit = 'TabcButtonEdit';
  sabcIDECompNameTabcCheckBox = 'TabcCheckBox';
  sabcIDECompNameTabcRadioButton = 'TabcRadioButton';
  sabcIDECompNameTabcPopupSelect = 'TabcPopupSelect';
  sabcIDECompNameTabcBackground = 'TabcBackground';
  sabcIDECompNameTabcMDIBackground = 'TabcMDIBackground';
  sabcIDECompNameTabcTiledImage = 'TabcTiledImage';
  sabcIDECompNameTabcMDITiledImage = 'TabcMDITiledImage';
  sabcIDECompNameTabcKeyState = 'TabcKeyState';
  sabcIDECompNameTabcActiveHighlight = 'TabcActiveHighlight';
  sabcIDECompNameTabcShape = 'TabcShape';
  sabcIDECompNameTabcFrame = 'TabcFrame';
  sabcIDECompNameTabcLRNoteBook = 'TabcLRNoteBook';
  sabcIDECompNameTabcLRTabbedNoteBook = 'TabcLRTabbedNoteBook';
  sabcIDECompNameTabcAutoTabSet = 'TabcAutoTabSet';
  sabcIDECompNameTabcLRComboBox = 'TabcLRComboBox';
  sabcIDECompNameTabcLRListBox = 'TabcLRListBox';
  sabcIDECompNameTabcROMemo = 'TabcROMemo';
  sabcIDECompNameTabcTabListBox = 'TabcTabListBox';
  sabcIDECompNameTabcSyncListBox = 'TabcSyncListBox';
  sabcIDECompNameTabcTransImage = 'TabcTransImage';
  sabcIDECompNameTabcSpinEdit = 'TabcSpinEdit';
  sabcIDECompNameTabcBusy = 'TabcBusy';
  sabcIDECompNameTabcSplash = 'TabcSplash';
  sabcIDECompNameTabcWelcomeTips = 'TabcWelcomeTips';
  sabcIDECompNameTabcPageSetupDialog = 'TabcPageSetupDialog';
  sabcIDECompNameTabcFileOpenEdit = 'TabcFileOpenEdit';
  sabcIDECompNameTabcFileSaveEdit = 'TabcFileSaveEdit';
  sabcIDECompNameTabcDirectoryEdit = 'TabcDirectoryEdit';
  sabcIDECompNameTabcDirectoryDialog = 'TabcDirectoryDialog';
  sabcIDECompNameTabcEffectsImage = 'TabcEffectsImage';
  sabcIDECompNameTabcRichEffectsImage = 'TabcRichEffectsImage';
  sabcIDECompNameTabcDBEffectsImage = 'TabcDBEffectsImage';
  sabcIDECompNameTabcWave = 'TabcWave';
  sabcIDECompNameTabcWaveFile = 'TabcWaveFile';
  sabcIDECompNameTabcWaveRes = 'TabcWaveRes';
  sabcIDECompNameTabcWaveList = 'TabcWaveList';
  sabcIDECompNameTabcWaveFileList = 'TabcWaveFileList';
  sabcIDECompNameTabcWaveResList = 'TabcWaveResList';
  sabcIDECompNameTabcMCIFilePlayer = 'TabcMCIFilePlayer';
  sabcIDECompNameTabcMCIStreamPlayer = 'TabcMCIStreamPlayer';
  sabcIDECompNameTabcShapeButton = 'TabcShapeButton';
  sabcIDECompNameTabcPicBtn = 'TabcPicBtn';
  sabcIDECompNameTabcPicSpeedBtn = 'TabcPicSpeedBtn';
  sabcIDECompNameTabcRepSpeedBtn = 'TabcRepSpeedBtn';
  sabcIDECompNameTabcToggleBtn = 'TabcToggleBtn';
  sabcIDECompNameTabcMouseRegion = 'TabcMouseRegion';
  sabcIDECompNameTabcMenuButton = 'TabcMenuButton';
  sabcIDECompNameTabcSizeButton = 'TabcSizeButton';
  sabcIDECompNameTabcWaveBtn = 'TabcWaveBtn';
  sabcIDECompNameTabcWaveFileBtn = 'TabcWaveFileBtn';
  sabcIDECompNameTabcFormButton = 'TabcFormButton';
  sabcIDECompNameTabcFormPicBtn = 'TabcFormPicBtn';
  sabcIDECompNameTabcFormPicSpeedBtn = 'TabcFormPicSpeedBtn';
  sabcIDECompNameTabcPushButton = 'TabcPushButton';
  sabcIDECompNameTabcButton = 'TabcButton';
  sabcIDECompNameTabcRotLabel = 'TabcRotLabel';
  sabcIDECompNameTabcVersionLabel = 'TabcVersionLabel';
  sabcIDECompNameTabcURLLabel = 'TabcURLLabel';
  sabcIDECompNameTabcMultilineLabel = 'TabcMultilineLabel';
  sabcIDECompNameTabcCurrencyLabel = 'TabcCurrencyLabel';
  sabcIDECompNameTabcMouseLabel = 'TabcMouseLabel';
  sabcIDECompNameTabcClockLabel = 'TabcClockLabel';
  sabcIDECompNameTabcSuperLabel = 'TabcSuperLabel';
  sabcIDECompNameTabcAutoLabel = 'TabcAutoLabel';
  sabcIDECompNameTabcEditLabel = 'TabcEditLabel';
  sabcIDECompNameTabcTitleGradient = 'TabcTitleGradient';
  sabcIDECompNameTabcSingleInstance = 'TabcSingleInstance';
  sabcIDECompNameTabcLauncher = 'TabcLauncher';
  sabcIDECompNameTabcFormSaver = 'TabcFormSaver';
  sabcIDECompNameTabcFormSizer = 'TabcFormSizer';
  sabcIDECompNameTabcStopWatch = 'TabcStopWatch';
  sabcIDECompNameTabcMDIScroll = 'TabcMDIScroll';
  sabcIDECompNameTabcFormMessageHook = 'TabcFormMessageHook';
  sabcIDECompNameTabcLEdit = 'TabcLEdit';
  sabcIDECompNameTabcLMaskEdit = 'TabcLMaskEdit';
  sabcIDECompNameTabcLSpinEdit = 'TabcLSpinEdit';
  sabcIDECompNameTabcLMemo = 'TabcLMemo';
  sabcIDECompNameTabcLListBox = 'TabcLListBox';
  sabcIDECompNameTabcLComboBox = 'TabcLComboBox';
  sabcIDECompNameTabcLImage = 'TabcLImage';
  sabcIDECompNameTabcLPanel = 'TabcLPanel';
  sabcIDECompNameTabcLScrollBox = 'TabcLScrollBox';
  sabcIDECompNameTabcLTreeView = 'TabcLTreeView';
  sabcIDECompNameTabcLDBText = 'TabcLDBText';
  sabcIDECompNameTabcLDBEdit = 'TabcLDBEdit';
  sabcIDECompNameTabcLDBAutoEdit = 'TabcLDBAutoEdit';
  sabcIDECompNameTabcLDBMemo = 'TabcLDBMemo';
  sabcIDECompNameTabcLDBImage = 'TabcLDBImage';
  sabcIDECompNameTabcLDBListBox = 'TabcLDBListBox';
  sabcIDECompNameTabcLDBComboBox = 'TabcLDBComboBox';
  sabcIDECompNameTabcLDBCheckBox = 'TabcLDBCheckBox';
  sabcIDECompNameTabcLDBRadioGroup = 'TabcLDBRadioGroup';
  sabcIDECompNameTabcLDBLookupList = 'TabcLDBLookupList';
  sabcIDECompNameTabcLDBLookupCombo = 'TabcLDBLookupCombo';
  sabcIDECompNameTabcLDBLookupListBox = 'TabcLDBLookupListBox';
  sabcIDECompNameTabcLDBLookupComboBox = 'TabcLDBLookupComboBox';
  sabcIDECompNameTabcDBAppException = 'TabcDBAppException';
  sabcIDECompNameTabcDBQryAppException = 'TabcDBQryAppException';
  sabcIDECompNameTabcLocalTable = 'TabcLocalTable';
  sabcIDECompNameTabcLocalQuery = 'TabcLocalQuery';
  sabcIDECompNameTabcLocalDatabase = 'TabcLocalDatabase';
  sabcIDECompNameTabcDBIdleTime = 'TabcDBIdleTime';
  sabcIDECompNameTabcDBQueryGrid = 'TabcDBQueryGrid';
  sabcIDECompNameTabcDBTableGrid = 'TabcDBTableGrid';
  sabcIDECompNameTabcClientAdapterReg = 'TabcClientAdapterReg';
  sabcIDECompNameTabcBDEAdapterReg = 'TabcBDEAdapterReg';
  sabcIDECompNameTabcADOAdapterReg = 'TabcADOAdapterReg';
  sabcIDECompNameTabcIBAdapterReg = 'TabcIBAdapterReg';
  sabcIDECompNameTabcSQLAdapterReg = 'TabcSQLAdapterReg';
  sabcIDECompNameTabcMDITabs = 'TabcMDITabs';
  sabcIDECompNameTabcTrayIcon = 'TabcTrayIcon';
  sabcIDECompNameTabcDBDateTimePicker = 'TabcDBDateTimePicker';
  sabcIDECompNameTabcDBMonthCalendar = 'TabcDBMonthCalendar';
  sabcIDECompNameTabcFormTabControl = 'TabcFormTabControl';
  sabcIDECompNameTabcMessageDlg = 'TabcMessageDlg';
  sabcIDECompNameTabcProgressDlg = 'TabcProgressDlg';
  sabcIDECompNameTabcIdleTimeout = 'TabcIdleTimeout';
  sabcIDECompNameTabcSpriteSurface = 'TabcSpriteSurface';
  sabcIDECompNameTabcSpriteList = 'TabcSpriteList';
  sabcIDECompNameTabcBitmapSpriteFactory = 'TabcBitmapSpriteFactory';
  sabcIDECompNameTabcMailToLabel = 'TabcMailToLabel';

  sabcIDECompDescTabcDock = 'is a container or drop area for toolbars, menu bars and toolwindows.';
  sabcIDECompDescTabcToolbar = 'is a dockable or floating window containing buttons and other controls. When floating it aligns its controls in rows and resizes accordingly.';
  sabcIDECompDescTabcToolWindow = 'is a dockable or floating window container for other controls. Unlike the toolbar it has no resizing constraints when floating.';
  sabcIDECompDescTabcToolbarButton = 'is a graphical popup button with dropdown/combo options.';
  sabcIDECompDescTabcToolbarSep = 'is a spacer for aligning button groups on a toolbar. It adds space between button groups and assists in floating toolbar resizing. Can be drawn invisible or as a vertical break.';
  sabcIDECompDescTabcToolbarEdit = 'is an edit control for toolbars that appears flat until focused.';
  sabcIDECompDescTabcToolbarMaskEdit = 'is a masked edit control for toolbars that appears flat until focused.';
  sabcIDECompDescTabcToolbarDBEdit = 'is a DB edit control for toolbars that appears flat until focused.';
  sabcIDECompDescTabcMainMenu = 'is a TMainMenu descendant for use with the abcMenuToolbar.';
  sabcIDECompDescTabcMenuToolbar = 'is a dockable or floating menu bar. It includes customizable popup menus, MDI and menu merging support.';
  sabcIDECompDescTabcPopupMenu = 'is a customizable popup menu with many display and animation options. See the Options property for details.';
  sabcIDECompDescTabcSystemMenu = 'is a customizable popup menu to replace the standard system menu. You can add extra items and submenus or hide standard items.';
  sabcIDECompDescTabcMenuImages = 'is a link component to allow images to be added to abc menu items.';
  sabcIDECompDescTabcNavToolbar = 'is a dockable toolbar that supports global datasource, field and state detection from the active control. It is a container for other abc data navigation controls which you can add with the component editor.';
  sabcIDECompDescTabcNavPanel = 'is a panel that supports global datasource, field and state detection from the active control. It is a container for other abc data navigation controls which you can add with the component editor.';
  sabcIDECompDescTabcNavFormLink =  'is a link component to register forms on which active datasource and active field changes are detected and notified to TabcNavPanel or TabcNavToolbar buttons.';
  sabcIDECompDescTabcnpFirst = 'is a dataset navigation button to scroll to the first record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpJumpBack = 'is a dataset navigation button to move back n records. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpPrev = 'is a dataset navigation button to scroll to the previous record. It includes an auto-repeat with acceleration feature. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpNext = 'is a dataset navigation button to scroll to the next record. It includes an auto-repeat with acceleration feature. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpJumpFwd = 'is a dataset navigation button to scroll to move forward n records. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpLast = 'is a dataset navigation button to scroll to the last record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpInsert = 'is a dataset edit button to insert a new record at the current position. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpAppend = 'is a dataset edit button to insert a new record at the end of the dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpDuplicateRec = 'is a dataset edit button to insert a new record at the current position and populate it with the contents of the current record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpEdit = 'is a dataset edit button to edit the current record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpDataSourceEdit = 'is a custom button to open a standard view or edit form on a datasource. There are several choices of edit form layout and dialog style available.';
  sabcIDECompDescTabcnpBlobEdit = 'is a datafield view/edit button to pop up a standard or custom edit form on a blob field. It includes a standard bitmap image editor.';
  sabcIDECompDescTabcnpFindReplace = 'is a dataset edit button to find or edit strings contained in records throughout the dataset. It includes typical search and replace options including global search on partial fields.';
  sabcIDECompDescTabcnpDelete = 'is a dataset edit button to delete the current record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpCancel = 'is a dataset edit button to cancel unposted edits to the current record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpPost = 'is a dataset edit button to post edits to the current record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpRefresh = 'is a dataset button to refresh the local copy of a dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpEmptyTable = 'is a dataset edit button to delete all records in a table or custom dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpBookmark = 'is a dataset navigation button to mark the current location in a dataset and allow quick return to that record. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpBookmarkMenu = 'is a dataset navigation button with a popup menu allowing you to add, remove and go to multiple bookmarks in the dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpFindKey = 'is a dataset navigation button with a popup dialog to enter a key value to search for using FindKey or FindNearest methods. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpIndexCombo = 'is a dataset navigation combo box with a dropdown list of index names on a dataset. Selecting an index sorts the dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpRange = 'is a dataset filter button with a popup dialog to enter a key range to filter records in a dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpRangeEdit = 'is an edit control allowing fast entry of a key range, like "A-", "a-e" and so on, to filter a dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpFilterActive = 'is a dataset filter button to automatically filter records on the value in the active field or grid cell. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpFilterExpression = 'is a dataset filter button to popup a filter expression dialog and then apply or remove the filter. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpSQLStartTrans = 'is a dataset edit button to automatically begin a transaction on the database. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpSQLCommit = 'is a dataset edit button to automatically commit a transaction on the database. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpSQLRollback = 'is a dataset edit button to automatically rollback a transaction on the database. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpQueryParams = 'is a query or stored procedure filter button with a popup dialog to enter input parameters and then open the dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpDBInfo = 'is a dataset information button to show or print debug information about the current dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpState = 'is a dataset information label that indicates the edit state and name of the active dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcnpRecordCount = 'is a dataset information label that indicates the record number (if available) and record count of the active dataset. Use this on a TabcNavToolbar or TabcNavPanel.';
  sabcIDECompDescTabcDBTreeView = 'is a data aware tree view that loads itself from multiple master-detail datasources, or recursively from a single dataset.';
  sabcIDECompDescTabcDBRichEdit = 'is a data aware rich edit control with built in popup editor and popup menu edit options.';
  sabcIDECompDescTabcDBSuperNav = 'is a replacement for a standard DBNavigator that includes extra buttons and accelerated scrolling.';
  sabcIDECompDescTabcDBEditWin = 'is a data aware scrollbox that automatically creates labels and edit controls for each field in a datasource. It includes many alignment options for arranging the controls.';
  sabcIDECompDescTabcHDBGrid = 'is a DB grid replacement with reversed row/column orientation.';
  sabcIDECompDescTabcDBIndexCombo = 'is a datasource navigation combo box with a dropdown list of index names on a datasource. Selecting an index name automatically sorts the datasource.dataset.';
  sabcIDECompDescTabcDBFilter = 'is a filter component to store a filter expression and apply it to a dataset.';
  sabcIDECompDescTabcDBRangeEdit = 'is an edit control allowing fast entry of a key range, like "A-", "a-e" and so on, to filter a datasource, where its dataset supports a range filter.';
  sabcIDECompDescTabcDBAutoEdit = 'is a DBEdit control that lets the user double-click to pop up a form to edit memo, graphic or blob fields. Predefined forms are included for editing memo and graphic fields.';
  sabcIDECompDescTabcDBFixedGrid = 'is a DBGrid that lets you change the number of fixed columns.';
  sabcIDECompDescTabcDBEditLabel = 'is a  data bound aggregate component containing a label and DB edit field with shared properties and automatic labelling from the dataset.';
  sabcIDECompDescTabcDBRecordCount = 'is a data bound label that shows dataset record count and position (if supported), with an editable mask.';
  sabcIDECompDescTabcDBState = 'is a data bound label that shows dataset name and state information, with an editable mask.';
  sabcIDECompDescTabcDBCurrencyLabel = 'is a data bound label that shows numeric fields as amounts in words. It includes options to change the formatting and currency strings.';
  sabcIDECompDescTabcLRDBComboBox = 'is a DB Combo Box that retains the selected index information when its window handle is destroyed.';
  sabcIDECompDescTabcAppException = 'is an automatic application exception handler to report exceptions to the user and log them to a disk file.';
  sabcIDECompDescTabcDSAppException = 'is an automatic application exception handler to show error messages from a dataset and log exceptions to a second dataset.';
  sabcIDECompDescTabcDBHintManager = 'is a data bound hint display and editor component. It can automatically read/write hint text keyed by form and control name.';
  sabcIDECompDescTabcDBHelpManager = 'is a data bound help display and editor component. It shows and stores help as rich text using an optional template RTF. Note: Requires a non-zero help context on the form to allow Delphi help events to occur.';
  sabcIDECompDescTabcAnimationFrame = 'is a notebook style frame with panel borders, containing pages. The frame or each page can have a flicker-free transition when changing pages. Each page can contain controls or another form.';
  sabcIDECompDescTabcFormPanel = 'is a panel that can contain other forms. A flicker-free transition effect can be shown when loading a form.';
  sabcIDECompDescTabcButtonBar = 'is multi page notebook container with vertically aligned buttons for page selection. Use with the TabcButtonList to build an Outlook-style bar.';
  sabcIDECompDescTabcButtonList = 'is single column icon list view with icon selection and dragging. It can also be aligned in small icon view.';
  sabcIDECompDescTabcPictureGroup = 'is a custom panel for grouping components with built in picture and caption presentation style.';
  sabcIDECompDescTabcMultiSplit = 'is multi-way splitter control that lets you show 2,3, or 4 panes at any time. Each splitter pane is a separate control owned by the form. Use the component editor to add panes.';
  sabcIDECompDescTabcQuadSplit = 'is a four way splitter control. Each splitter pane is a separate control owned by the form. Use the component editor to add panes.';
  sabcIDECompDescTabcTriSplit = 'is a three way splitter. Each pane is a separate control owned by the form. Layouts include all combinations of 3 windows and panes can be swapped or rotated at runtime. Use the component editor to add panes.';
  sabcIDECompDescTabcBiSplit = 'is a two way splitter. You can align horizontally or vertically and set scaling, min, max and other layout options.Each pane is a separate control owned by the form.  Panes can be swapped at runtime. Use the component editor to add panes.';
  sabcIDECompDescTabcSplitBar = 'is a lightweight splitter control that requires a parent and two other windows to be dragged for resizing within the parent.';
  sabcIDECompDescTabcSMultiSplit = 'is multi-way splitter control that lets you show 2,3, or 4 panes at any time. Each splitter pane is a separate control owned by the form and includes automatic synchronised scrollbars. Use the component editor to add panes.';
  sabcIDECompDescTabcSQuadSplit = 'is four-way splitter control. Each splitter pane is a separate control owned by the form and includes automatic synchronised scrollbars. Use the component editor to add panes.';
  sabcIDECompDescTabcSTriSplit = 'is a three way splitter. Layouts include all combinations of 3 panes and panes can be swapped or rotated at runtime. Each pane is owned by the form and includes automatic synchronised scrollbars. Use the component editor to add panes.';
  sabcIDECompDescTabcSBiSplit = 'is a two way splitter. You can align horizontally or vertically and set scaling, min, max and other layout options. Each pane is owned by the form and includes automatic synchronised scrollbars. Use the component editor to add panes.';
  sabcIDECompDescTabcEdgePanel = 'is a panel with a BevelEdges property to let you only draw selected edges of the panel. Ideal for building flat profile applications. All of the ABC panel components descend from this ancestor.';
  sabcIDECompDescTabcDragPanel = 'is an edge panel descendant that can be moved or sized under user control, with properties to control allowed mouse actions.';
  sabcIDECompDescTabcSpeedPanel = 'is a panel that lets you automatically arrange and size a set of same sized controls, like speedbuttons.';
  sabcIDECompDescTabcHintBar = 'is a low profile panel that automatically aligns to the bottom of the form and captures the Application Hint property for display.';
  sabcIDECompDescTabcShapeForm = 'is a graphic control to automatically shape a form to an outline image using a transparent color range.';
  sabcIDECompDescTabcRichEdit = 'is a rich edit control with built in edit popup menu and a modal document editor dialog. It can also have a page loaded at design time.';
  sabcIDECompDescTabcFormTabbedNoteBook = 'is a tabbed notebook that automatically loads forms into pages of the notebook.';
  sabcIDECompDescTabcFormNoteBook = 'is a notebook that automatically loads forms into each page of the notebook.';
  sabcIDECompDescTabcCheckListBox = 'is a multiselect listbox with bitmaps for selecting items, includes standard and custom bitmaps for check styles, text wordwrap and columns';
  sabcIDECompDescTabcFontComboBox = 'is a dropdown combo box for selecting fonts. Includes the font name and a glyph in the dropdown showing TrueType and Printer fonts. Allows filtering of particulartypes of fonts.';
  sabcIDECompDescTabcColorComboBox = 'is a dropdown combo box for color selection. This paints a sample of each color value in the dropdown. Allows population of default colors using a component editor.';
  sabcIDECompDescTabcLine = 'is a control drawing a horizontal, vertical or diagonal line with optional arrow heads. It can also detect mouse clicks only on the line surface.';
  sabcIDECompDescTabcButtonEdit = 'is an edit control with an ellipsis button for extended functionality.';
  sabcIDECompDescTabcCheckBox = 'is a checkbox with wordwrap and other caption alignment extensions.';
  sabcIDECompDescTabcRadioButton = 'is a radio button with wordwrap and other caption alignment extensions.';
  sabcIDECompDescTabcPopupSelect = 'is an edit control with popup menu to select from a value list. This can be used as an alternative to a combo box.';
  sabcIDECompDescTabcBackground = 'is a gradient fill control allowing you to set color range and direction effects.';
  sabcIDECompDescTabcMDIBackground = 'is a gradient fill control allowing you to set color range and direction effects. This is used as the background on an MDI main form.';
  sabcIDECompDescTabcTiledImage = 'is an Image control with several layout options, including tiling and stretch fit alternatives.';
  sabcIDECompDescTabcMDITiledImage = 'is an Image control with several layout options, including tiling and stretch fit alternatives. This is used as the background on an MDI main form.';
  sabcIDECompDescTabcKeyState = 'is a label control to show and change the keystate, for use in status panels';
  sabcIDECompDescTabcActiveHighlight = 'is a control to automatically highlight the active control when the user tabs around the form. It can also make the mouse automatically follow the keyboard cursor. You only need a single instance of this control on your main form.';
  sabcIDECompDescTabcShape = 'is a Shape control allowing borders, wrapped text and corner sizing.';
  sabcIDECompDescTabcFrame = 'is a frame control like a TBevel but with more border sizing options.';
  sabcIDECompDescTabcLRNoteBook = 'is a low resource notebook that frees window control handles when moving between pages. Conserves Windows User resources in large applications.';
  sabcIDECompDescTabcLRTabbedNoteBook = 'is a low resource tabbed notebook that frees window control handles when moving between pages. Conserves Windows User resources in large applications. ';
  sabcIDECompDescTabcAutoTabSet = 'is a tabset that automatically sets its tabs from the pages of a notebook, and then coordinates clicks with page changes.';
  sabcIDECompDescTabcLRComboBox = 'is a combo box that restores its state properly when used with the low resource notebooks';
  sabcIDECompDescTabcLRListBox = 'is a listbox that restores its state properly when used with the low resource notebooks';
  sabcIDECompDescTabcROMemo = 'is a truly read only memo that disables text selection. It also includes easy printing methods, and synchronised scrolling with another memo.';
  sabcIDECompDescTabcTabListBox = 'is a listbox that can automatically set horizontal scrolling and tabstops using property values. Can be used to align data in columns.';
  sabcIDECompDescTabcSyncListBox = 'is a synchronised listbox. Two of these can be linked to coordinate their scroll movement.';
  sabcIDECompDescTabcTransImage = 'is a transparent image component. Lets you set a transparent color for the image as well as tiling, etc.';
  sabcIDECompDescTabcSpinEdit = 'is a spin edit component for numeric ranged input. This is based on the Delphi Samples spin edit.';
  sabcIDECompDescTabcBusy = 'is used when you need a popup progress bar. It encapsulates a dialog to display an AVI resource as well as messages and optional progress bar in a single stay on top form. Use the Show and Hide methods to control popup display.';
  sabcIDECompDescTabcSplash = 'is an automatic splash screen is launched from this component on application startup. You just need to provide the bitmap image. Includes a designtime preview.';
  sabcIDECompDescTabcWelcomeTips = 'is a component that encapsulates a runtime welcome or tip of the day dialog. Includes designtime tip editing and preview features.';
  sabcIDECompDescTabcPageSetupDialog = 'is a component to encapsulate the win32 page setup dialog. For setting margins and page orientation.';
  sabcIDECompDescTabcFileOpenEdit = 'is a component that encapsulates a TEdit control and a popup file open dialog.';
  sabcIDECompDescTabcFileSaveEdit = 'is a component that encapsulates a TEdit control and a popup file save dialog.';
  sabcIDECompDescTabcDirectoryEdit = 'is a component that encapsulates a TEdit control and a popup directory selection dialog.';
  sabcIDECompDescTabcDirectoryDialog = 'is a component that displays a modal dialog to select a directory. Includes properties like the Delphi Dialogs; also lets you choose "Folder" or "Directory" terminology, button styles, right or bottom button position and various editing options. ';
  sabcIDECompDescTabcEffectsImage = 'is an image control with 140 special transition effects when displaying a new picture. Includes some amazing effects never before seen in Delphi. With full control over transition effect, size and speed.';
  sabcIDECompDescTabcRichEffectsImage = 'is an effects image control with an additional Rich Text caption.';
  sabcIDECompDescTabcDBEffectsImage = 'is a data bound image control with 140 special transition effects when displaying a new picture. Includes some amazing effects never seen in Delphi.';
  sabcIDECompDescTabcWave = 'is a non-visual component to embed wave data in a property, with methods for playing the sound.';
  sabcIDECompDescTabcWaveFile = 'is a non-visual component to play wave data from a filename property, with methods for playing the sound. ';
  sabcIDECompDescTabcWaveRes = 'is a non-visual component to play wave data from an external resource, e.g. in a DLL, with methods for playing the sound. ';
  sabcIDECompDescTabcWaveList = 'is a non-visual component to embed a list of sounds in a property, with methods for playing one or more sounds in the list. ';
  sabcIDECompDescTabcWaveFileList = 'is a non-visual component to play a list of sound files, with methods for playing one or more sounds in the list. ';
  sabcIDECompDescTabcWaveResList = 'is a non-visual component to play a list of sound resources, with methods for playing one or more sounds in the list. ';
  sabcIDECompDescTabcMCIFilePlayer = 'is a non-visual control for MCI file playing and recording under program control. ';
  sabcIDECompDescTabcMCIStreamPlayer = 'is a non-visual control for MCI file playing and recording under program control. MCI data can be embedded in the control and recorded played using a temp file. ';
  sabcIDECompDescTabcShapeButton = 'is a shaped button for free form irregular shaped buttons using bitmap images. Use the component editor for edge detection and edge enhancement of bitmaps.';
  sabcIDECompDescTabcPicBtn = 'is a bit button style window control that allow glyphs of all picture types. Also allows glyph tiling and setting the button color.';
  sabcIDECompDescTabcPicSpeedBtn = 'is a speed button style graphic control that allow glyphs of all picture types. Also allows glyph tiling and setting the button color. ';
  sabcIDECompDescTabcRepSpeedBtn = 'is a repeating version of TabcPicSpeedBtn that includes a timer for events while the mouse is held down.';
  sabcIDECompDescTabcToggleBtn = 'is a two state toggle button of type TabcPicSpeedBtn that includes OnClickDown and OnClickUp events.';
  sabcIDECompDescTabcMouseRegion = 'is an invisible control to detect mouse movement over rectangular regions.';
  sabcIDECompDescTabcMenuButton = 'is a toolbar button that can be automatically linked with a menu item to share properties such as enabled, onclick etc.';
  sabcIDECompDescTabcSizeButton = 'is a button that automatically sizes to fit its caption.';
  sabcIDECompDescTabcWaveBtn = 'is a button that automatically plays a wave sound when clicked. The sound is stored in the button properties.';
  sabcIDECompDescTabcWaveFileBtn = 'is a button that automatically plays a wave sound when clicked. The sound is played from an external file name.';
  sabcIDECompDescTabcFormButton = 'is a button that automatically loads another form when clicked. Needs only simple properties to set this up.';
  sabcIDECompDescTabcFormPicBtn = 'is a picture button that automatically loads another form when clicked. Needs only simple properties to set this up.';
  sabcIDECompDescTabcFormPicSpeedBtn = 'is a picture speed button that automatically loads another form when clicked. Needs only simple properties to set this up.';
  sabcIDECompDescTabcPushButton = 'is a radio button descendant that draws as a two state rectangular framed up/down push button. With additional wordwrap and other caption alignment options.';
  sabcIDECompDescTabcButton = 'is a standard button descendant with wordwrap and other caption alignment options.';
  sabcIDECompDescTabcRotLabel = 'is a label that rotates text in degrees, including raised or shadowed text effects and borders, and automatic resizing.';
  sabcIDECompDescTabcVersionLabel = 'is a label that automatically displays information from a program version resource, including flexible configuration of display options. Also allows runtime access to individual version item values.';
  sabcIDECompDescTabcURLLabel = 'is a highighting mouse label that adds the ability to launch a specified web URL using the default internet browser application.';
  sabcIDECompDescTabcMultilineLabel = 'is a label with an Items property for easy manipulation and drawing of multiple lines of text.';
  sabcIDECompDescTabcCurrencyLabel = 'is a label that shows numeric fields as amounts in words. It includes options to change the formatting and currency strings.';
  sabcIDECompDescTabcMouseLabel = 'is a label with color, shadow, underline and sound highlight effects for mouse over and mouse down events.';
  sabcIDECompDescTabcClockLabel = 'is a label that shows formatted date and time as a string with a built in timer and format options.';
  sabcIDECompDescTabcSuperLabel = 'is a label with various border and style options.';
  sabcIDECompDescTabcAutoLabel = 'is a label with various border and style options.';
  sabcIDECompDescTabcEditLabel = 'is a label and edit control contained in a parent window, includes shared properties and various alignment options.';
  sabcIDECompDescTabcTitleGradient = 'is an automatic component to apply gradient color and font effects to window title bars. It supports all form styles and border icon options, with Italic font options for MDI forms.';
  sabcIDECompDescTabcSingleInstance = 'is a component to restrict program execution to a single instance. It can cause other launches to activate the original instance and display an optional message.';
  sabcIDECompDescTabcLauncher = 'is a component to launch other programs and wait for their return, including launch detection by time, day of the week, day of the month, etc. ';
  sabcIDECompDescTabcFormSaver = 'is a component to automatically save and restore form properties such as size, position, state, fonts and color, using and INI file. ';
  sabcIDECompDescTabcFormSizer = 'is a component that limits the form size and position.';
  sabcIDECompDescTabcStopWatch = 'is a stopwatch component for recording and reporting program execution times. ';
  sabcIDECompDescTabcMDIScroll = 'is a component to enable or disable scroll bars on the main form of an MDI application. ';
  sabcIDECompDescTabcFormMessageHook = 'is a component for testing windows hooks. It lets you subclass the window (intercept the form wndProc) to inspect or override Windows messages. Message overrides are implemented in an event of the component. ';
  sabcIDECompDescTabcLEdit = 'is an edit control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLMaskEdit = 'is a masked edit control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLSpinEdit = 'is a spin edit control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLMemo = 'is a memo control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLListBox = 'is a listbox control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLComboBox = 'is a combo box with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLImage = 'is an image control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLPanel = 'is a panel control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLScrollBox = 'is a scrollbox with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLTreeView = 'is a tree view control with attached label. There is no parent window and both components are owned by the form. It automatically synchronises label location and properties with the main control and also synchronises IDE cut/copy/paste and destruction.';
  sabcIDECompDescTabcLDBText = 'is a db text control with attached label. There is no parent window and both components are owned by the form. The label caption can be set automatically from the data field. Label location and properties are synchronised with the main control.';
  sabcIDECompDescTabcLDBEdit = 'is a db edit control with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBAutoEdit = 'is a db edit control with attached label. The label caption can be set automatically from the data field. It also supports automatic popup dialogs to edit memo, graphic and blob fields by double clicking the control. ';
  sabcIDECompDescTabcLDBMemo = 'is a db memo with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBImage = 'is a db image with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBListBox = 'is a db listbox with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBComboBox = 'is a db combobox with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBCheckBox = 'is a db checkbox control that automatically sets its caption from the data field displaylabel. ';
  sabcIDECompDescTabcLDBRadioGroup = 'is a db radio group control that automatically sets its caption from the data field displaylabel';
  sabcIDECompDescTabcLDBLookupList = 'is a db lookup list with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBLookupCombo = 'is a db lookup combo with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBLookupListBox = 'is a db lookup listbox with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcLDBLookupComboBox = 'is a db lookup combobox with attached label. There is no parent window and both components are owned by the form. Label location, caption and other properties, and IDE cut/copy/paste are synchronised with the main control.';
  sabcIDECompDescTabcDBAppException = 'is an automatic application exception handler to show error messages from a BDE Table and log exceptions to a second Table.';
  sabcIDECompDescTabcDBQryAppException = 'is an automatic application exception handler to show error messages from a BDE Query and log exceptions to a second Query.';
  sabcIDECompDescTabcLocalTable = 'is a Table component for Paradox databases that automatically sets the database to the current project or executable directory.';
  sabcIDECompDescTabcLocalQuery = 'is a Query component for Paradox databases that automatically sets the database to the current project or executable directory.';
  sabcIDECompDescTabcLocalDatabase = 'is a TDatabase descendant for Paradox databases that automatically sets the database to the current project or executable directory.';
  sabcIDECompDescTabcDBIdleTime = 'is a component which executes at Application.OnIdle to flush BDE updates cached in memory to disk.';
  sabcIDECompDescTabcDBQueryGrid = 'is an aggregate component containing a TQuery, DBGrid and Navigator.';
  sabcIDECompDescTabcDBTableGrid = 'is an aggregate component containing a TTable, DBGrid and Navigator.';
  sabcIDECompDescTabcClientAdapterReg = 'is a component to ensure the registration of ABC client dataset adapter classes. Use a single instance of this component in your application when using TClientDataset with ABC data controls.';
  sabcIDECompDescTabcBDEAdapterReg = 'is a component to ensure the registration of ABC BDE dataset adapter classes. Use a single instance of this component in your application when using TTable, TQuery or TStoredProc with ABC data controls.';
  sabcIDECompDescTabcADOAdapterReg = 'is a component to ensure the registration of ABC ADO dataset adapter classes. Use a single instance of this component in your application when using ADO datasets with ABC data controls.';
  sabcIDECompDescTabcIBAdapterReg = 'is a component to ensure the registration of ABC InterBase dataset adapter classes. Use a single instance of this component in your application when using the InterBase dataset classes with ABC data controls.';
  sabcIDECompDescTabcSQLAdapterReg = 'is a component to ensure the registration of ABC DBExpress SQL dataset adapter classes. Use a single instance of this component in your application when using the DBExpress dataset classes with ABC data controls.';
  sabcIDECompDescTabcMDITabs = 'is a tab set and form navigation aid for MDI applications.  It automatically creates tab buttons with glyphs and captions for each child form.  Selecting a tab activates the child form.';
  sabcIDECompDescTabcTrayIcon = 'is a component to create a system tray icon and link the icon to a form and menu.';
  sabcIDECompDescTabcDBDateTimePicker = 'is a db date time picker with date/time and checkbox data fields. If the DataFieldCheckBox property is set the control will display a checkbox to indicate valid date selection.';
  sabcIDECompDescTabcDBMonthCalendar = 'is a db month calendar with date and end date data fields. If the DataFieldEndDate is set, the control will allow range selection, otherwise just a single date can be selected.';
  sabcIDECompDescTabcFormTabControl = 'is a custom tab control with an embedded subform for each tab. It includes tab change transition effects, docking support, design or runtime form links and custom tab drawing.';
  sabcIDECompDescTabcMessageDlg = 'shows a modal dialog for custom messages. It is similar to MessageDlg function, with extra message, icon, checkbox and button formatting.';
  sabcIDECompDescTabcProgressDlg = 'shows a modal message dialog and progress bar with timer counting up or down.';
  sabcIDECompDescTabcIdleTimeout = 'is a component to detect no user or process activity and optionally terminate the application.';
  sabcIDECompDescTabcSpriteSurface = 'is a graphic control that draws animated 2D sprite components using optimized multithreading animation.';
  sabcIDECompDescTabcSpriteList = 'is a component that contains a list of sprites to draw onto a SpriteSurface.';
  sabcIDECompDescTabcBitmapSpriteFactory = 'is a sprite creation component allowing many sprites to be created sharing the same image.';
  sabcIDECompDescTabcMailToLabel = 'is a highighting mouse label that creates an email (with address, subject and body text); then loads it into the default email application.';

const
  ABC_COMPONENTCOUNT = 216;

function abcIDEComponentDescription(const abcClassName: string): string;
const
  ABC_COMPNAMES: array [0..ABC_COMPONENTCOUNT-1] of string = (
    sabcIDECompNameTabcDock,
    sabcIDECompNameTabcToolbar,
    sabcIDECompNameTabcToolWindow,
    sabcIDECompNameTabcToolbarButton,
    sabcIDECompNameTabcToolbarSep,
    sabcIDECompNameTabcToolbarEdit,
    sabcIDECompNameTabcToolbarMaskEdit,
    sabcIDECompNameTabcToolbarDBEdit,
    sabcIDECompNameTabcMainMenu,
    sabcIDECompNameTabcMenuToolbar,
    sabcIDECompNameTabcPopupMenu,
    sabcIDECompNameTabcSystemMenu,
    sabcIDECompNameTabcMenuImages,
    sabcIDECompNameTabcNavToolbar,
    sabcIDECompNameTabcNavPanel,
    sabcIDECompNameTabcNavFormLink,
    sabcIDECompNameTabcnpFirst,
    sabcIDECompNameTabcnpJumpBack,
    sabcIDECompNameTabcnpPrev,
    sabcIDECompNameTabcnpNext,
    sabcIDECompNameTabcnpJumpFwd,
    sabcIDECompNameTabcnpLast,
    sabcIDECompNameTabcnpInsert,
    sabcIDECompNameTabcnpAppend,
    sabcIDECompNameTabcnpDuplicateRec,
    sabcIDECompNameTabcnpEdit,
    sabcIDECompNameTabcnpDataSourceEdit,
    sabcIDECompNameTabcnpBlobEdit,
    sabcIDECompNameTabcnpFindReplace,
    sabcIDECompNameTabcnpDelete,
    sabcIDECompNameTabcnpCancel,
    sabcIDECompNameTabcnpPost,
    sabcIDECompNameTabcnpRefresh,
    sabcIDECompNameTabcnpEmptyTable,
    sabcIDECompNameTabcnpBookmark,
    sabcIDECompNameTabcnpBookmarkMenu,
    sabcIDECompNameTabcnpFindKey,
    sabcIDECompNameTabcnpIndexCombo,
    sabcIDECompNameTabcnpRange,
    sabcIDECompNameTabcnpRangeEdit,
    sabcIDECompNameTabcnpFilterActive,
    sabcIDECompNameTabcnpFilterExpression,
    sabcIDECompNameTabcnpSQLStartTrans,
    sabcIDECompNameTabcnpSQLCommit,
    sabcIDECompNameTabcnpSQLRollback,
    sabcIDECompNameTabcnpQueryParams,
    sabcIDECompNameTabcnpDBInfo,
    sabcIDECompNameTabcnpState,
    sabcIDECompNameTabcnpRecordCount,
    sabcIDECompNameTabcDBTreeView,
    sabcIDECompNameTabcDBRichEdit,
    sabcIDECompNameTabcDBSuperNav,
    sabcIDECompNameTabcDBEditWin,
    sabcIDECompNameTabcHDBGrid,
    sabcIDECompNameTabcDBIndexCombo,
    sabcIDECompNameTabcDBFilter,
    sabcIDECompNameTabcDBRangeEdit,
    sabcIDECompNameTabcDBAutoEdit,
    sabcIDECompNameTabcDBFixedGrid,
    sabcIDECompNameTabcDBEditLabel,
    sabcIDECompNameTabcDBRecordCount,
    sabcIDECompNameTabcDBState,
    sabcIDECompNameTabcDBCurrencyLabel,
    sabcIDECompNameTabcLRDBComboBox,
    sabcIDECompNameTabcAppException,
    sabcIDECompNameTabcDSAppException,
    sabcIDECompNameTabcDBHintManager,
    sabcIDECompNameTabcDBHelpManager,
    sabcIDECompNameTabcAnimationFrame,
    sabcIDECompNameTabcFormPanel,
    sabcIDECompNameTabcButtonBar,
    sabcIDECompNameTabcButtonList,
    sabcIDECompNameTabcPictureGroup,
    sabcIDECompNameTabcMultiSplit,
    sabcIDECompNameTabcQuadSplit,
    sabcIDECompNameTabcTriSplit,
    sabcIDECompNameTabcBiSplit,
    sabcIDECompNameTabcSplitBar,
    sabcIDECompNameTabcSMultiSplit,
    sabcIDECompNameTabcSQuadSplit,
    sabcIDECompNameTabcSTriSplit,
    sabcIDECompNameTabcSBiSplit,
    sabcIDECompNameTabcEdgePanel,
    sabcIDECompNameTabcDragPanel,
    sabcIDECompNameTabcSpeedPanel,
    sabcIDECompNameTabcHintBar,
    sabcIDECompNameTabcShapeForm,
    sabcIDECompNameTabcRichEdit,
    sabcIDECompNameTabcFormTabbedNoteBook,
    sabcIDECompNameTabcFormNoteBook,
    sabcIDECompNameTabcCheckListBox,
    sabcIDECompNameTabcFontComboBox,
    sabcIDECompNameTabcColorComboBox,
    sabcIDECompNameTabcLine,
    sabcIDECompNameTabcButtonEdit,
    sabcIDECompNameTabcCheckBox,
    sabcIDECompNameTabcRadioButton,
    sabcIDECompNameTabcPopupSelect,
    sabcIDECompNameTabcBackground,
    sabcIDECompNameTabcMDIBackground,
    sabcIDECompNameTabcTiledImage,
    sabcIDECompNameTabcMDITiledImage,
    sabcIDECompNameTabcKeyState,
    sabcIDECompNameTabcActiveHighlight,
    sabcIDECompNameTabcShape,
    sabcIDECompNameTabcFrame,
    sabcIDECompNameTabcLRNoteBook,
    sabcIDECompNameTabcLRTabbedNoteBook,
    sabcIDECompNameTabcAutoTabSet,
    sabcIDECompNameTabcLRComboBox,
    sabcIDECompNameTabcLRListBox,
    sabcIDECompNameTabcROMemo,
    sabcIDECompNameTabcTabListBox,
    sabcIDECompNameTabcSyncListBox,
    sabcIDECompNameTabcTransImage,
    sabcIDECompNameTabcSpinEdit,
    sabcIDECompNameTabcBusy,
    sabcIDECompNameTabcSplash,
    sabcIDECompNameTabcWelcomeTips,
    sabcIDECompNameTabcPageSetupDialog,
    sabcIDECompNameTabcFileOpenEdit,
    sabcIDECompNameTabcFileSaveEdit,
    sabcIDECompNameTabcDirectoryEdit,
    sabcIDECompNameTabcDirectoryDialog,
    sabcIDECompNameTabcEffectsImage,
    sabcIDECompNameTabcRichEffectsImage,
    sabcIDECompNameTabcDBEffectsImage,
    sabcIDECompNameTabcWave,
    sabcIDECompNameTabcWaveFile,
    sabcIDECompNameTabcWaveRes,
    sabcIDECompNameTabcWaveList,
    sabcIDECompNameTabcWaveFileList,
    sabcIDECompNameTabcWaveResList,
    sabcIDECompNameTabcMCIFilePlayer,
    sabcIDECompNameTabcMCIStreamPlayer,
    sabcIDECompNameTabcShapeButton,
    sabcIDECompNameTabcPicBtn,
    sabcIDECompNameTabcPicSpeedBtn,
    sabcIDECompNameTabcRepSpeedBtn,
    sabcIDECompNameTabcToggleBtn,
    sabcIDECompNameTabcMouseRegion,
    sabcIDECompNameTabcMenuButton,
    sabcIDECompNameTabcSizeButton,
    sabcIDECompNameTabcWaveBtn,
    sabcIDECompNameTabcWaveFileBtn,
    sabcIDECompNameTabcFormButton,
    sabcIDECompNameTabcFormPicBtn,
    sabcIDECompNameTabcFormPicSpeedBtn,
    sabcIDECompNameTabcPushButton,
    sabcIDECompNameTabcButton,
    sabcIDECompNameTabcRotLabel,
    sabcIDECompNameTabcVersionLabel,
    sabcIDECompNameTabcURLLabel,
    sabcIDECompNameTabcMultilineLabel,
    sabcIDECompNameTabcCurrencyLabel,
    sabcIDECompNameTabcMouseLabel,
    sabcIDECompNameTabcClockLabel,
    sabcIDECompNameTabcSuperLabel,
    sabcIDECompNameTabcAutoLabel,
    sabcIDECompNameTabcEditLabel,
    sabcIDECompNameTabcTitleGradient,
    sabcIDECompNameTabcSingleInstance,
    sabcIDECompNameTabcLauncher,
    sabcIDECompNameTabcFormSaver,
    sabcIDECompNameTabcFormSizer,
    sabcIDECompNameTabcStopWatch,
    sabcIDECompNameTabcMDIScroll,
    sabcIDECompNameTabcFormMessageHook,
    sabcIDECompNameTabcLEdit,
    sabcIDECompNameTabcLMaskEdit,
    sabcIDECompNameTabcLSpinEdit,
    sabcIDECompNameTabcLMemo,
    sabcIDECompNameTabcLListBox,
    sabcIDECompNameTabcLComboBox,
    sabcIDECompNameTabcLImage,
    sabcIDECompNameTabcLPanel,
    sabcIDECompNameTabcLScrollBox,
    sabcIDECompNameTabcLTreeView,
    sabcIDECompNameTabcLDBText,
    sabcIDECompNameTabcLDBEdit,
    sabcIDECompNameTabcLDBAutoEdit,
    sabcIDECompNameTabcLDBMemo,
    sabcIDECompNameTabcLDBImage,
    sabcIDECompNameTabcLDBListBox,
    sabcIDECompNameTabcLDBComboBox,
    sabcIDECompNameTabcLDBCheckBox,
    sabcIDECompNameTabcLDBRadioGroup,
    sabcIDECompNameTabcLDBLookupList,
    sabcIDECompNameTabcLDBLookupCombo,
    sabcIDECompNameTabcLDBLookupListBox,
    sabcIDECompNameTabcLDBLookupComboBox,
    sabcIDECompNameTabcDBAppException,
    sabcIDECompNameTabcDBQryAppException,
    sabcIDECompNameTabcLocalTable,
    sabcIDECompNameTabcLocalQuery,
    sabcIDECompNameTabcLocalDatabase,
    sabcIDECompNameTabcDBIdleTime,
    sabcIDECompNameTabcDBQueryGrid,
    sabcIDECompNameTabcDBTableGrid,
    sabcIDECompNameTabcClientAdapterReg,
    sabcIDECompNameTabcBDEAdapterReg,
    sabcIDECompNameTabcADOAdapterReg,
    sabcIDECompNameTabcIBAdapterReg,
    sabcIDECompNameTabcSQLAdapterReg,
    sabcIDECompNameTabcMDITabs,
    sabcIDECompNameTabcTrayIcon,
    sabcIDECompNameTabcDBDateTimePicker,
    sabcIDECompNameTabcDBMonthCalendar,
    sabcIDECompNameTabcFormTabControl,
    sabcIDECompNameTabcMessageDlg,
    sabcIDECompNameTabcProgressDlg,
    sabcIDECompNameTabcIdleTimeout,
    sabcIDECompNameTabcSpriteSurface,
    sabcIDECompNameTabcSpriteList,
    sabcIDECompNameTabcBitmapSpriteFactory,
    sabcIDECompNameTabcMailToLabel

   );

  ABC_COMPDESCS: array [0..ABC_COMPONENTCOUNT-1] of string = (
    sabcIDECompDescTabcDock,
    sabcIDECompDescTabcToolbar,
    sabcIDECompDescTabcToolWindow,
    sabcIDECompDescTabcToolbarButton,
    sabcIDECompDescTabcToolbarSep,
    sabcIDECompDescTabcToolbarEdit,
    sabcIDECompDescTabcToolbarMaskEdit,
    sabcIDECompDescTabcToolbarDBEdit,
    sabcIDECompDescTabcMainMenu,
    sabcIDECompDescTabcMenuToolbar,
    sabcIDECompDescTabcPopupMenu,
    sabcIDECompDescTabcSystemMenu,
    sabcIDECompDescTabcMenuImages,
    sabcIDECompDescTabcNavToolbar,
    sabcIDECompDescTabcNavPanel,
    sabcIDECompDescTabcNavFormLink,
    sabcIDECompDescTabcnpFirst,
    sabcIDECompDescTabcnpJumpBack,
    sabcIDECompDescTabcnpPrev,
    sabcIDECompDescTabcnpNext,
    sabcIDECompDescTabcnpJumpFwd,
    sabcIDECompDescTabcnpLast,
    sabcIDECompDescTabcnpInsert,
    sabcIDECompDescTabcnpAppend,
    sabcIDECompDescTabcnpDuplicateRec,
    sabcIDECompDescTabcnpEdit,
    sabcIDECompDescTabcnpDataSourceEdit,
    sabcIDECompDescTabcnpBlobEdit,
    sabcIDECompDescTabcnpFindReplace,
    sabcIDECompDescTabcnpDelete,
    sabcIDECompDescTabcnpCancel,
    sabcIDECompDescTabcnpPost,
    sabcIDECompDescTabcnpRefresh,
    sabcIDECompDescTabcnpEmptyTable,
    sabcIDECompDescTabcnpBookmark,
    sabcIDECompDescTabcnpBookmarkMenu,
    sabcIDECompDescTabcnpFindKey,
    sabcIDECompDescTabcnpIndexCombo,
    sabcIDECompDescTabcnpRange,
    sabcIDECompDescTabcnpRangeEdit,
    sabcIDECompDescTabcnpFilterActive,
    sabcIDECompDescTabcnpFilterExpression,
    sabcIDECompDescTabcnpSQLStartTrans,
    sabcIDECompDescTabcnpSQLCommit,
    sabcIDECompDescTabcnpSQLRollback,
    sabcIDECompDescTabcnpQueryParams,
    sabcIDECompDescTabcnpDBInfo,
    sabcIDECompDescTabcnpState,
    sabcIDECompDescTabcnpRecordCount,
    sabcIDECompDescTabcDBTreeView,
    sabcIDECompDescTabcDBRichEdit,
    sabcIDECompDescTabcDBSuperNav,
    sabcIDECompDescTabcDBEditWin,
    sabcIDECompDescTabcHDBGrid,
    sabcIDECompDescTabcDBIndexCombo,
    sabcIDECompDescTabcDBFilter,
    sabcIDECompDescTabcDBRangeEdit,
    sabcIDECompDescTabcDBAutoEdit,
    sabcIDECompDescTabcDBFixedGrid,
    sabcIDECompDescTabcDBEditLabel,
    sabcIDECompDescTabcDBRecordCount,
    sabcIDECompDescTabcDBState,
    sabcIDECompDescTabcDBCurrencyLabel,
    sabcIDECompDescTabcLRDBComboBox,
    sabcIDECompDescTabcAppException,
    sabcIDECompDescTabcDSAppException,
    sabcIDECompDescTabcDBHintManager,
    sabcIDECompDescTabcDBHelpManager,
    sabcIDECompDescTabcAnimationFrame,
    sabcIDECompDescTabcFormPanel,
    sabcIDECompDescTabcButtonBar,
    sabcIDECompDescTabcButtonList,
    sabcIDECompDescTabcPictureGroup,
    sabcIDECompDescTabcMultiSplit,
    sabcIDECompDescTabcQuadSplit,
    sabcIDECompDescTabcTriSplit,
    sabcIDECompDescTabcBiSplit,
    sabcIDECompDescTabcSplitBar,
    sabcIDECompDescTabcSMultiSplit,
    sabcIDECompDescTabcSQuadSplit,
    sabcIDECompDescTabcSTriSplit,
    sabcIDECompDescTabcSBiSplit,
    sabcIDECompDescTabcEdgePanel,
    sabcIDECompDescTabcDragPanel,
    sabcIDECompDescTabcSpeedPanel,
    sabcIDECompDescTabcHintBar,
    sabcIDECompDescTabcShapeForm,
    sabcIDECompDescTabcRichEdit,
    sabcIDECompDescTabcFormTabbedNoteBook,
    sabcIDECompDescTabcFormNoteBook,
    sabcIDECompDescTabcCheckListBox,
    sabcIDECompDescTabcFontComboBox,
    sabcIDECompDescTabcColorComboBox,
    sabcIDECompDescTabcLine,
    sabcIDECompDescTabcButtonEdit,
    sabcIDECompDescTabcCheckBox,
    sabcIDECompDescTabcRadioButton,
    sabcIDECompDescTabcPopupSelect,
    sabcIDECompDescTabcBackground,
    sabcIDECompDescTabcMDIBackground,
    sabcIDECompDescTabcTiledImage,
    sabcIDECompDescTabcMDITiledImage,
    sabcIDECompDescTabcKeyState,
    sabcIDECompDescTabcActiveHighlight,
    sabcIDECompDescTabcShape,
    sabcIDECompDescTabcFrame,
    sabcIDECompDescTabcLRNoteBook,
    sabcIDECompDescTabcLRTabbedNoteBook,
    sabcIDECompDescTabcAutoTabSet,
    sabcIDECompDescTabcLRComboBox,
    sabcIDECompDescTabcLRListBox,
    sabcIDECompDescTabcROMemo,
    sabcIDECompDescTabcTabListBox,
    sabcIDECompDescTabcSyncListBox,
    sabcIDECompDescTabcTransImage,
    sabcIDECompDescTabcSpinEdit,
    sabcIDECompDescTabcBusy,
    sabcIDECompDescTabcSplash,
    sabcIDECompDescTabcWelcomeTips,
    sabcIDECompDescTabcPageSetupDialog,
    sabcIDECompDescTabcFileOpenEdit,
    sabcIDECompDescTabcFileSaveEdit,
    sabcIDECompDescTabcDirectoryEdit,
    sabcIDECompDescTabcDirectoryDialog,
    sabcIDECompDescTabcEffectsImage,
    sabcIDECompDescTabcRichEffectsImage,
    sabcIDECompDescTabcDBEffectsImage,
    sabcIDECompDescTabcWave,
    sabcIDECompDescTabcWaveFile,
    sabcIDECompDescTabcWaveRes,
    sabcIDECompDescTabcWaveList,
    sabcIDECompDescTabcWaveFileList,
    sabcIDECompDescTabcWaveResList,
    sabcIDECompDescTabcMCIFilePlayer,
    sabcIDECompDescTabcMCIStreamPlayer,
    sabcIDECompDescTabcShapeButton,
    sabcIDECompDescTabcPicBtn,
    sabcIDECompDescTabcPicSpeedBtn,
    sabcIDECompDescTabcRepSpeedBtn,
    sabcIDECompDescTabcToggleBtn,
    sabcIDECompDescTabcMouseRegion,
    sabcIDECompDescTabcMenuButton,
    sabcIDECompDescTabcSizeButton,
    sabcIDECompDescTabcWaveBtn,
    sabcIDECompDescTabcWaveFileBtn,
    sabcIDECompDescTabcFormButton,
    sabcIDECompDescTabcFormPicBtn,
    sabcIDECompDescTabcFormPicSpeedBtn,
    sabcIDECompDescTabcPushButton,
    sabcIDECompDescTabcButton,
    sabcIDECompDescTabcRotLabel,
    sabcIDECompDescTabcVersionLabel,
    sabcIDECompDescTabcURLLabel,
    sabcIDECompDescTabcMultilineLabel,
    sabcIDECompDescTabcCurrencyLabel,
    sabcIDECompDescTabcMouseLabel,
    sabcIDECompDescTabcClockLabel,
    sabcIDECompDescTabcSuperLabel,
    sabcIDECompDescTabcAutoLabel,
    sabcIDECompDescTabcEditLabel,
    sabcIDECompDescTabcTitleGradient,
    sabcIDECompDescTabcSingleInstance,
    sabcIDECompDescTabcLauncher,
    sabcIDECompDescTabcFormSaver,
    sabcIDECompDescTabcFormSizer,
    sabcIDECompDescTabcStopWatch,
    sabcIDECompDescTabcMDIScroll,
    sabcIDECompDescTabcFormMessageHook,
    sabcIDECompDescTabcLEdit,
    sabcIDECompDescTabcLMaskEdit,
    sabcIDECompDescTabcLSpinEdit,
    sabcIDECompDescTabcLMemo,
    sabcIDECompDescTabcLListBox,
    sabcIDECompDescTabcLComboBox,
    sabcIDECompDescTabcLImage,
    sabcIDECompDescTabcLPanel,
    sabcIDECompDescTabcLScrollBox,
    sabcIDECompDescTabcLTreeView,
    sabcIDECompDescTabcLDBText,
    sabcIDECompDescTabcLDBEdit,
    sabcIDECompDescTabcLDBAutoEdit,
    sabcIDECompDescTabcLDBMemo,
    sabcIDECompDescTabcLDBImage,
    sabcIDECompDescTabcLDBListBox,
    sabcIDECompDescTabcLDBComboBox,
    sabcIDECompDescTabcLDBCheckBox,
    sabcIDECompDescTabcLDBRadioGroup,
    sabcIDECompDescTabcLDBLookupList,
    sabcIDECompDescTabcLDBLookupCombo,
    sabcIDECompDescTabcLDBLookupListBox,
    sabcIDECompDescTabcLDBLookupComboBox,
    sabcIDECompDescTabcDBAppException,
    sabcIDECompDescTabcDBQryAppException,
    sabcIDECompDescTabcLocalTable,
    sabcIDECompDescTabcLocalQuery,
    sabcIDECompDescTabcLocalDatabase,
    sabcIDECompDescTabcDBIdleTime,
    sabcIDECompDescTabcDBQueryGrid,
    sabcIDECompDescTabcDBTableGrid,
    sabcIDECompDescTabcClientAdapterReg,
    sabcIDECompDescTabcBDEAdapterReg,
    sabcIDECompDescTabcADOAdapterReg,
    sabcIDECompDescTabcIBAdapterReg,
    sabcIDECompDescTabcSQLAdapterReg,
    sabcIDECompDescTabcMDITabs,
    sabcIDECompDescTabcTrayIcon,
    sabcIDECompDescTabcDBDateTimePicker,
    sabcIDECompDescTabcDBMonthCalendar,
    sabcIDECompDescTabcFormTabControl,
    sabcIDECompDescTabcMessageDlg,
    sabcIDECompDescTabcProgressDlg,
    sabcIDECompDescTabcIdleTimeout,
    sabcIDECompDescTabcSpriteSurface,
    sabcIDECompDescTabcSpriteList,
    sabcIDECompDescTabcBitmapSpriteFactory,
    sabcIDECompDescTabcMailToLabel

   );

var
  i: integer;
begin
  Result := '';
  for i := Low(ABC_COMPNAMES) to High(ABC_COMPNAMES) do
    if ABC_COMPNAMES[i] = abcClassName then
    begin
      Result := ABC_COMPDESCS[i];
      if Copy(Result, 1, 2) = 'is' then
        Result := ABC_COMPNAMES[i] + ' ' + Result;
      Break;
    end;
end;

end.
