unit abcfinfo;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Dialogs, TabNotBk, ComCtrls,
  abcforms, abcnpbtn, abcnp, abcmemo, abcfact;

type

  TabcsfDSInfo = class(TabcSystemForm)
    Panel1: TPanel;
    btnOK: TBitBtn;
    btnPrint: TBitBtn;
    btnSaveAll: TBitBtn;
    SaveDialog: TSaveDialog;
    btnPrintAll: TBitBtn;
    nbkInfo: TTabbedNotebook;
    memComp: TabcROMemo;
    memDataSet: TabcROMemo;
    memFields: TabcROMemo;
    memIndexes: TabcROMemo;
    memParams: TabcROMemo;
    memDatabase: TabcROMemo;
    memSession: TabcROMemo;
    memEngine: TabcROMemo;
    procedure Panel1Resize(Sender: TObject);
    procedure btnSaveAllClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnPrintAllClick(Sender: TObject);
  private
    procedure CopyAllToList(Strings: TStringList);
  public
  end;

implementation

uses abcutilf, SysUtils;

{$R *.DFM}

procedure TabcsfDSInfo.Panel1Resize(Sender: TObject);
const
  Offset = 5;
var
  LastPos: Integer;
begin
  LastPos := Panel1.Width - Offset;
  with btnOK do
    if Visible then begin
      Left := LastPos - Width;
      LastPos := LastPos - Width - Offset;
    end;
  with btnSaveAll do
    if Visible then begin
      Left := LastPos - Width;
      LastPos := LastPos - Width - Offset;
    end;
  with btnPrintAll do
    if Visible then begin
      Left := LastPos - Width;
      LastPos := LastPos - Width - Offset;
    end;
  with btnPrint do
    if Visible then
      Left := LastPos - Width;
end;

procedure TabcsfDSInfo.btnSaveAllClick(Sender: TObject);
var
  TempLines: TStringList;
begin
  with SaveDialog do
    if Execute then begin
      TempLines := TStringList.Create;
      try
        CopyAllToList(TempLines);
        TempLines.SaveToFile(FileName);
      finally
        TempLines.Free;
      end;
    end;
end;

procedure TabcsfDSInfo.btnPrintClick(Sender: TObject);
begin
  case nbkInfo.PageIndex of
    0:  abcPrintStrings(memComp.Lines);
    1:  abcPrintStrings(memDataSet.Lines);
    2:  abcPrintStrings(memFields.Lines);
    3:  abcPrintStrings(memIndexes.Lines);
    4:  abcPrintStrings(memParams.Lines);
    5:  abcPrintStrings(memDataBase.Lines);
    6:  abcPrintStrings(memSession.Lines);
    7:  abcPrintStrings(memEngine.Lines);
  end;
end;

procedure TabcsfDSInfo.btnPrintAllClick(Sender: TObject);
var
  TempLines: TStringList;
begin
  TempLines := TStringList.Create;
  try
    CopyAllToList(TempLines);
    abcPrintStrings(TempLines);
  finally
    TempLines.Free;
  end;
end;

procedure TabcsfDSInfo.CopyAllToList(Strings: TStringList);
begin
  with Strings do begin
    AddStrings(memComp.Lines);
    AddStrings(memDataSet.Lines);
    AddStrings(memFields.Lines);
    AddStrings(memIndexes.Lines);
    AddStrings(memParams.Lines);
    AddStrings(memDataBase.Lines);
    AddStrings(memSession.Lines);
    AddStrings(memEngine.Lines);
  end;
end;

initialization
  abcFormFactory.RegisterBaseFormClass(TabcsfDSInfo);

end.
