unit abcfnpds;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{DataSource autoedit form with fields as controls}

interface

uses Classes, DB, DBGrids, Controls, Forms, Grids,
  StdCtrls, Buttons, ExtCtrls, abcnp, abcnpedt, abcedwin, Graphics, abcforms, abcnpfac,
  abcscrol;

type
  TabcnfDataSourceEditRec = class(TabcnpAutoForm)
    pnlButtons: TPanel;
    btnHelp: TBitBtn;
    btnClose: TBitBtn;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    DBEditWin1: TabcDBEditWin;
    procedure btnHelpClick(Sender: TObject);
    procedure pnlButtonsResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure InitFormStyle;
  public
    constructor CreateAutoForm(AOwner: TComponent; ANavPanel: TabcNavPanel;
      ADataSource: TDataSource; APopupStyle: TabcPopupFormStyle;
      AReadOnly: Boolean; AModalAutoPost: Boolean;
      AHelpContext: THelpContext; AfterFormCreate: TabcnpAfterFormCreateEvent); override;
    constructor CreateAutoFormTB(AOwner: TComponent; ANavToolbar: TabcNavToolbar;
      ADataSource: TDataSource; APopupStyle: TabcPopupFormStyle;
      AReadOnly: Boolean; AModalAutoPost: Boolean;
      AHelpContext: THelpContext; AfterFormCreate: TabcnpAfterFormCreateEvent); override;
  end;

implementation

{$R *.DFM}

constructor TabcnfDataSourceEditRec.CreateAutoForm(AOwner: TComponent; ANavPanel: TabcNavPanel;
  ADataSource: TDataSource; APopupStyle: TabcPopupFormStyle;
  AReadOnly: Boolean; AModalAutoPost: Boolean; AHelpContext: THelpContext;
  AfterFormCreate: TabcnpAfterFormCreateEvent);
begin
  inherited CreateAutoForm(AOwner, ANavPanel, ADataSource, APopupStyle, AReadOnly,
    AModalAutoPost,AHelpContext,AfterFormCreate);
  DBEditWin1.DataSource := ADataSource;
  DBEditWin1.EditColor := clWindow;
  DBEditWin1.ReadOnly := ReadOnly;
  if AHelpContext <> 0 then btnHelp.Visible := True;
  InitFormStyle;
  if Assigned(AfterFormCreate) then AfterFormCreate(Self);
end;

constructor TabcnfDataSourceEditRec.CreateAutoFormTB(AOwner: TComponent; ANavToolbar: TabcNavToolbar;
  ADataSource: TDataSource; APopupStyle: TabcPopupFormStyle;
  AReadOnly: Boolean; AModalAutoPost: Boolean; AHelpContext: THelpContext;
  AfterFormCreate: TabcnpAfterFormCreateEvent);
begin
  inherited CreateAutoFormTB(AOwner, ANavToolbar, ADataSource, APopupStyle, AReadOnly,
    AModalAutoPost,AHelpContext,AfterFormCreate);
  DBEditWin1.DataSource := ADataSource;
  DBEditWin1.EditColor := clWindow;
  DBEditWin1.ReadOnly := ReadOnly;
  if AHelpContext <> 0 then btnHelp.Visible := True;
  InitFormStyle;
  if Assigned(AfterFormCreate) then AfterFormCreate(Self);
end;

procedure TabcnfDataSourceEditRec.InitFormStyle;
begin
  case PopupStyle of
    pfsNormal, pfsStayOnTop:
      btnClose.Visible := True;
    pfsModal:
      if ReadOnly then
        btnClose.Visible := True
      else begin
        btnOK.Visible := True;
        btnCancel.Visible := True;
      end;
    pfsMDIChild:
      pnlButtons.Visible := False;
  end;
  DBEditWin1.PopupFormStyle := PopupStyle;
end;

procedure TabcnfDataSourceEditRec.btnHelpClick(Sender: TObject);
begin
  Application.HelpContext(HelpContext);
end;

procedure TabcnfDataSourceEditRec.pnlButtonsResize(Sender: TObject);
const
  Offset = 5;
var
  LastPos: Integer;
begin
  LastPos := pnlButtons.Width - Offset;
  with btnHelp do
    if Visible then begin
      Left := LastPos - Width;
      LastPos := LastPos - Width - Offset;
    end;
  with btnClose do
    if Visible then begin
      Left := LastPos - Width;
      LastPos := LastPos - Width - Offset;
    end;
  with btnCancel do
    if Visible then begin
      Left := LastPos - Width;
      LastPos := LastPos - Width - Offset;
    end;
  with btnOK do
    if Visible then
      Left := LastPos - Width;
end;

procedure TabcnfDataSourceEditRec.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ActiveControl := nil;
  Action := caFree;
end;

initialization
  abcnpFormFactory.RegisterBaseFormClass(TabcnfDataSourceEditRec);

end.
