unit abcforms;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses
  Classes, Graphics, Forms, abcfact;

type

  {------------------------- General Purpose Types ----------------------------}

  TabcPopupFormStyle = (pfsNormal, pfsModal, pfsMDIChild, pfsStayOnTop);

  TabcModalDialogEvent = procedure(Sender: TObject; Form: TForm) of object;

  {---------------------- General Purpose Form Classes ------------------------}

  { TabcForm - reserved for future use}

  TabcForm = class(TForm);

  { TabcSystemForm - Forces Font MS Sans Serif, 8, Bold for WIN16 or plain for WIN32 }

  TabcSystemForm = class(TabcForm)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  { TabcApplicationForm - Forces Font Arial, 10 }

  TabcApplicationForm = class(TabcForm)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  {------------------------- Nav Panel Form Classes ---------------------------}

  { TabcnpForm - class allows autodetection of NavPanel forms and datasources }

  TabcnpForm = class(TabcForm);

  { TabcnpApplicationForm  - Forces Font Arial, 10 }

  TabcnpApplicationForm = class(TabcnpForm)
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation

{ TabcSystemForm }

constructor TabcSystemForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Font.Name := 'MS Sans Serif';
  Font.Size := 8;
  Font.Style := [];
end;

{ TabcApplicationForm }

constructor TabcApplicationForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Font.Name := 'Arial';
  Font.Size := 10;
  Font.Style := [];
end;

{ TabcnpApplicationForm }

constructor TabcnpApplicationForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Font.Name := 'Arial';
  Font.Size := 10;
  Font.Style := [];
end;

end.
