unit abcfrch;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

This form is based on the Delphi 3 Demo Sample RichEdit.DPR
Adapted for integrated editing with richedit and dbrichedit controls,
plus extended functionality with toolbars, margin and tab enhancements.

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{ NOT IMPLEMENTED:
  - defaults for dbrichedit
  - TParaAttributes has bugs.
    - tabstops need to use twips to pixels conversion
    - need to set all tabs at one time and the
      tab array needs to be sorted in increasing position
  - exact printer measurements
  - accurate tab stop settings and indent adjustments (in 1/4 inches or 5 mm?)
}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, ClipBrd,
  abcrched, abctoolb, abctlbr, abctctls, abcspin, abccombo, abcbtn, abcfact, abcforms, abcapp;

type
  TabcsfRichEditDialog = class(TabcForm)
    MainMenu: TMainMenu;
    miFileNew: TMenuItem;
    miFileOpen: TMenuItem;
    miFileSave: TMenuItem;
    miFileSaveAs: TMenuItem;
    miFilePrint: TMenuItem;
    miFileClose: TMenuItem;
    miEditUndo: TMenuItem;
    miEditCut: TMenuItem;
    miEditCopy: TMenuItem;
    miEditPaste: TMenuItem;
    Ruler: TPanel;
    FirstInd: TLabel;
    LeftInd: TLabel;
    RulerLine: TBevel;
    RightInd: TLabel;
    StatusBar: TStatusBar;
    Editor: TabcRichEdit;
    abcDock1: TabcDock;
    tbrFile: TabcToolbar;
    tbrEdit: TabcToolbar;
    btnFilePrint: TabcPicSpeedBtn;
    btnFileOpen: TabcPicSpeedBtn;
    btnFileSave: TabcPicSpeedBtn;
    btnFilePageSetup: TabcPicSpeedBtn;
    btnFileLoadTemplate: TabcPicSpeedBtn;
    btnFileNew: TabcPicSpeedBtn;
    btnEditSelectAll: TabcPicSpeedBtn;
    btnEditUndo: TabcPicSpeedBtn;
    btnEditDelete: TabcPicSpeedBtn;
    btnEditPaste: TabcPicSpeedBtn;
    btnEditCopy: TabcPicSpeedBtn;
    btnEditCut: TabcPicSpeedBtn;
    tbrFont: TabcToolbar;
    tbrFormat: TabcToolbar;
    tbrFind: TabcToolbar;
    cboFontName: TabcFontComboBox;
    abcToolbarSep1: TabcToolbarSep;
    abcToolbarSep2: TabcToolbarSep;
    btnFontUnderline: TabcPicSpeedBtn;
    btnFontItalic: TabcPicSpeedBtn;
    btnFontBold: TabcPicSpeedBtn;
    btnParaBullet: TabcPicSpeedBtn;
    btnParaAlignRight: TabcPicSpeedBtn;
    btnParaAlignCenter: TabcPicSpeedBtn;
    btnParaAlignLeft: TabcPicSpeedBtn;
    abcToolbarSep3: TabcToolbarSep;
    btnEditDateTime: TabcPicSpeedBtn;
    btnEditFind: TabcPicSpeedBtn;
    btnEditReplace: TabcPicSpeedBtn;
    btnParaOutdent: TabcPicSpeedBtn;
    btnParaIndent: TabcPicSpeedBtn;
    abcToolbarSep4: TabcToolbarSep;
    cboColor: TabcColorComboBox;
    cboFontSize: TComboBox;
    abcToolbarSep6: TabcToolbarSep;
    btnEditFindNext: TabcPicSpeedBtn;
    abcToolbarSep7: TabcToolbarSep;
    abcToolbarSep8: TabcToolbarSep;
    btnFileClose: TabcPicSpeedBtn;
    abcToolbarSep9: TabcToolbarSep;
    abcToolbarSep10: TabcToolbarSep;
    miEditDelete: TMenuItem;
    miEditSelectAll: TMenuItem;
    mnuFormat: TMenuItem;
    miFormatFont: TMenuItem;
    miFilePageSetup: TMenuItem;
    miFileLoadTemplate: TMenuItem;
    mnuSearch: TMenuItem;
    miSearchFind: TMenuItem;
    miSearchReplace: TMenuItem;
    miSearchAgain: TMenuItem;
    mnuFile: TMenuItem;
    mnuEdit: TMenuItem;
    miSep1: TMenuItem;
    miSep2: TMenuItem;
    lblTab: TLabel;
    miFormatBullet: TMenuItem;
    miFormatAlign: TMenuItem;
    miFormatAlignLeft: TMenuItem;
    miFormatAlignCenter: TMenuItem;
    miFormatAlignRight: TMenuItem;
    N1: TMenuItem;
    miFormatIndent: TMenuItem;
    miFormatUnindent: TMenuItem;

    procedure SelectionChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FileClose(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure EditDelete(Sender: TObject);
    procedure EditSelectAll(Sender: TObject);
    procedure SelectFont(Sender: TObject);
    procedure RulerResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure btnFontBoldClick(Sender: TObject);
    procedure btnFontItalicClick(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure btnAlignClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure btnFontUnderlineClick(Sender: TObject);
    procedure btnParaBulletClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RulerItemMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RulerItemMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RightIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure RichEditChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cboFontSizeKeyPress(Sender: TObject; var Key: Char);
    procedure cboColorChange(Sender: TObject);
    procedure FilePageSetup(Sender: TObject);
    procedure FileLoadTemplate(Sender: TObject);
    procedure SearchFind(Sender: TObject);
    procedure SearchReplace(Sender: TObject);
    procedure SearchFindNext(Sender: TObject);
    procedure btnEditDateTimeClick(Sender: TObject);
    procedure btnParaIndentClick(Sender: TObject);
    procedure btnParaOutdentClick(Sender: TObject);
    procedure TabMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RulerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditorCancel(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
  private
    FUpdating: Boolean;
    FDragOfs: Integer;
    FDragging: Boolean;
    FClipboardOwner: HWnd;
    FRightMax: Integer;

    FFirstLastMove: Boolean;
    FDrawing: Boolean;
    FLastMovePos: Integer;

    FTabList: TList;

    FShowing: Boolean;

    procedure AppShowHint(Sender: TObject);
    procedure SetupRuler;
    procedure SetEditRect;
    procedure UpdateCursorPos;
    procedure ClipboardChanged;
    function RoundIndentPos(i: integer): integer;
    procedure WMChangeCBChain(var Msg: TWMChangeCBChain); message WM_CHANGECBCHAIN;
    procedure WMDrawClipboard(var Msg: TWMDrawClipboard); message WM_DRAWCLIPBOARD;
    procedure SetModified(Value: Boolean);
    procedure DrawDragLine(DC: HDC; CRect: TRect; X: Integer);
    procedure MoveDragLine(X: Integer);

    function CreateTabLabelAt(TabStop: Integer): TLabel;
    procedure RemoveTab(ALabel: TLabel);
    procedure MoveTabTo(ALabel: TLabel; NewTabStop: Integer);
    function CalcTabPos(Sender: TObject): Integer;
    procedure CheckCreateTabAt(X: Integer);
    procedure UpdateAlignments(Alignment: TAlignment);
    procedure LeftAlignToolbars;
  public
    procedure SetEditorOptions(Value: TabcREEditorOptions);
  end;

var
  abcsfRichEditDialog: TabcsfRichEditDialog;

implementation

uses RichEdit, abcfrcdt, abcutilf, abcconst;

const
  RulerAdj = 4/3;
  GutterWid = 6;

{$R *.DFM}

procedure TabcsfRichEditDialog.SetEditorOptions(Value: TabcREEditorOptions);
begin
  miFileNew.Visible  := areFileNew in Value;
  btnFileNew.Visible := areFileNew in Value;

  miFileLoadTemplate.Visible  := areFileLoadTemplate in Value;
  btnFileLoadTemplate.Visible := areFileLoadTemplate in Value;

  miFileOpen.Visible  := areFileOpen in Value;
  btnFileOpen.Visible := areFileOpen in Value;

  miFileSave.Visible   := areFileSave in Value;
  miFileSaveAs.Visible := areFileSave in Value;
  btnFileSave.Visible  := areFileSave in Value;

  if (Value * [areFileNew, areFileLoadTemplate, areFileOpen, areFileSave]) = [] then
    miSep1.Visible := False;

  miFilePrint.Visible  := areFilePrint in Value;
  btnFilePrint.Visible := areFilePrint in Value;

  miFilePageSetup.Visible  := areFilePageSetup in Value;
  btnFilePageSetup.Visible := areFilePageSetup in Value;

  if (Value * [areFilePrint, areFilePageSetup]) = [] then
    miSep2.Visible := False;

  mnuEdit.Visible := areEditMenu in Value;
  mnuSearch.Visible := areSearchMenu in Value;
  mnuFormat.Visible := areFormatMenu in Value;


  tbrFile.Visible := areFileToolbar in Value;
  tbrEdit.Visible := areEditToolbar in Value;
  tbrFind.Visible := areFindToolbar in Value;

  tbrFont.Visible := areFontToolbar in Value;
  tbrFormat.Visible := areFormatToolbar in Value;

  StatusBar.Visible := areStatusBar in Value;
end;

procedure TabcsfRichEditDialog.LeftAlignToolbars;
var
  nextLeft, WidthsRow0, WidthsRow1: integer;
begin
  //arrange visible toolbars to the left

  with tbrFile do
    if Visible then
    begin
      nextLeft := DockPos + 1;
      WidthsRow0 := Width;
    end
    else
    begin
      nextLeft := 0;
      WidthsRow0 := 0;
    end;

  with tbrEdit do
    if Visible then
    begin
      DockPos := nextLeft;
      nextLeft := DockPos + 1;
      WidthsRow0 := WidthsRow0 + Width;
    end;

  with tbrFind do
    if Visible then
    begin
      DockPos := nextLeft;
      nextLeft := DockPos + 1;
      WidthsRow0 := WidthsRow0 + Width;
    end;

  if tbrFont.Visible then
    WidthsRow1 := tbrFont.Width
  else
    WidthsRow1 := 0;

  if tbrFormat.Visible then
    WidthsRow1 := WidthsRow1 + tbrFormat.Width;

  if (WidthsRow0 + WidthsRow1) < abcDock1.Width then
  //can reduce to one row
  begin
    with tbrFont do
      if Visible then
      begin
        DockPos := nextLeft;
        DockRow := 0;
        nextLeft := DockPos + 1;
      end;
    with tbrFormat do
      if Visible then
      begin
        DockPos := nextLeft;
        DockRow := 0;
      end;
  end
  else
    with tbrFormat do
      if Visible and not tbrFont.Visible then
        DockPos := 0;
end;

procedure TabcsfRichEditDialog.SelectionChange(Sender: TObject);
begin
  with Editor.Paragraph do
  try
    FUpdating := True;
    FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
    LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
    FRightMax := Ruler.ClientWidth - 6 - Trunc(GutterWid * RulerAdj);
    RightInd.Left := Ruler.ClientWidth-6-Trunc((RightIndent+GutterWid)*RulerAdj);
    btnFontBold.Down := fsBold in Editor.SelAttributes.Style;
    btnFontItalic.Down := fsItalic in Editor.SelAttributes.Style;
    btnFontUnderline.Down := fsUnderline in Editor.SelAttributes.Style;
    btnParaBullet.Down := Boolean(Numbering);
    miFormatBullet.Checked := Boolean(Numbering);
    cboFontSize.Text := IntToStr(Editor.SelAttributes.Size);
    cboFontName.ItemIndex := cboFontName.Items.IndexOf(Editor.SelAttributes.Name);
    cboColor.SelectedColor := Editor.SelAttributes.Color;
    UpdateAlignments(Alignment);
    UpdateCursorPos;
  finally
    FUpdating := False;
  end;
end;

procedure TabcsfRichEditDialog.UpdateAlignments(Alignment: TAlignment);
begin
  case Ord(Alignment) of
    0:
    begin
      btnParaAlignLeft.Down := True;
      miFormatAlignLeft.Checked := True;
    end;
    1:
    begin
      btnParaAlignRight.Down := True;
      miFormatAlignRight.Checked := True;
    end;
    2:
    begin
      btnParaAlignCenter.Down := True;
      miFormatAlignCenter.Checked := True;
    end;
  end;
end;

procedure TabcsfRichEditDialog.SetupRuler;
{var
  I: Integer;
  S: String; }
begin
 { SetLength(S, 201);
  I := 1;
  while I < 200 do
  begin
    S[I] := #9;
    S[I+1] := '|';
    Inc(I, 2);
  end;
  Ruler.Caption := S;  }
end;

procedure TabcsfRichEditDialog.SetEditRect;
var
  R: TRect;
begin
  with Editor do
  begin
    R := Rect(GutterWid, 0, ClientWidth-GutterWid, ClientHeight);
    SendMessage(Handle, EM_SETRECT, 0, Longint(@R));
  end;
end;

{ Event Handlers }

procedure TabcsfRichEditDialog.FormCreate(Sender: TObject);
begin
  abcApplicationEvents.RegisterOnHint(AppShowHint);
  SetupRuler;
  SelectionChange(Self);
  FClipboardOwner := SetClipboardViewer(Handle);
  FTabList := TList.Create;
  FTabList.Add(lblTab);
end;

procedure TabcsfRichEditDialog.AppShowHint(Sender: TObject);
begin
  if Length(Application.Hint) > 0 then
  begin
    StatusBar.SimplePanel := True;
    StatusBar.SimpleText := Application.Hint;
  end
  else StatusBar.SimplePanel := False;
end;

procedure TabcsfRichEditDialog.FileNew(Sender: TObject);
begin
  Editor.Filename := '';
  Editor.Lines.Clear;
  Editor.Modified := False;
  SetModified(False);
end;

procedure TabcsfRichEditDialog.FileOpen(Sender: TObject);
begin
  Editor.ShowOpenDialog;
  Editor.SetFocus;
end;

procedure TabcsfRichEditDialog.FileSave(Sender: TObject);
begin
  Editor.Save;
end;

procedure TabcsfRichEditDialog.FileSaveAs(Sender: TObject);
begin
  Editor.ShowSaveDialog;
end;

procedure TabcsfRichEditDialog.FilePrint(Sender: TObject);
begin
  Editor.ShowPrintDialog;
end;

procedure TabcsfRichEditDialog.FileClose(Sender: TObject);
begin
  Close;
end;

procedure TabcsfRichEditDialog.EditUndo(Sender: TObject);
begin
  with Editor do
    if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);
end;

procedure TabcsfRichEditDialog.EditCut(Sender: TObject);
begin
  Editor.CutToClipboard;
end;

procedure TabcsfRichEditDialog.EditCopy(Sender: TObject);
begin
  Editor.CopyToClipboard;
end;

procedure TabcsfRichEditDialog.EditPaste(Sender: TObject);
begin
  Editor.PasteFromClipboard;
end;

procedure TabcsfRichEditDialog.EditDelete(Sender: TObject);
begin
  Editor.ClearSelection;
end;

procedure TabcsfRichEditDialog.EditSelectAll(Sender: TObject);
begin
  Editor.SelectAll;
end;

procedure TabcsfRichEditDialog.SelectFont(Sender: TObject);
begin
  Editor.ShowFontDialog;
  Editor.SetFocus;
end;

procedure TabcsfRichEditDialog.RulerResize(Sender: TObject);
begin
  RulerLine.Width := Ruler.ClientWidth - (RulerLine.Left*2);
end;

procedure TabcsfRichEditDialog.FormResize(Sender: TObject);
begin
  if not FShowing then //reduce flicker when loading
  begin
    SetEditRect;
    SelectionChange(Sender);
  end;
end;

procedure TabcsfRichEditDialog.FormPaint(Sender: TObject);
begin
//  SetEditRect;
end;

procedure TabcsfRichEditDialog.btnFontBoldClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if btnFontBold.Down then
    Editor.SelAttributes.Style := Editor.SelAttributes.Style + [fsBold]
  else
    Editor.SelAttributes.Style := Editor.SelAttributes.Style - [fsBold];
end;

procedure TabcsfRichEditDialog.btnFontItalicClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if btnFontItalic.Down then
    Editor.SelAttributes.Style := Editor.SelAttributes.Style + [fsItalic]
  else
    Editor.SelAttributes.Style := Editor.SelAttributes.Style - [fsItalic];
end;

procedure TabcsfRichEditDialog.FontSizeChange(Sender: TObject);
var
  i: integer;
begin
  if FUpdating then Exit;
  i := StrToIntDef(cboFontSize.Text, -1);
  if i <> -1 then
    Editor.SelAttributes.Size := i;
end;

procedure TabcsfRichEditDialog.btnAlignClick(Sender: TObject);
begin
  if FUpdating then Exit;
  Editor.Paragraph.Alignment := TAlignment(TControl(Sender).Tag);
  UpdateAlignments(Editor.Paragraph.Alignment);
end;

procedure TabcsfRichEditDialog.FontNameChange(Sender: TObject);
begin
  if FUpdating then Exit;
  Editor.SelAttributes.Name := cboFontName.Items[cboFontName.ItemIndex];
end;

procedure TabcsfRichEditDialog.btnFontUnderlineClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if btnFontUnderline.Down then
    Editor.SelAttributes.Style := Editor.SelAttributes.Style + [fsUnderline]
  else
    Editor.SelAttributes.Style := Editor.SelAttributes.Style - [fsUnderline];
end;

procedure TabcsfRichEditDialog.btnParaBulletClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if Sender is TMenuItem then
    btnParaBullet.Down := not btnParaBullet.Down;
  miFormatBullet.Checked := btnParaBullet.Down;
  Editor.Paragraph.Numbering := TNumberingStyle(btnParaBullet.Down);
end;

procedure TabcsfRichEditDialog.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  CanSave: Word;
begin
  if Editor.Modified then
    if (areConfirmSaveOnClose in Editor.EditorOptions) then
      CanSave := MessageDlg(sabcRichEditEditorConfirmation, mtConfirmation, mbYesNoCancel, 0)
    else
      CanSave := mrYes
  else
    CanSave := mrNo       ;
  CanClose := (CanSave <> mrCancel);
  if CanSave = mrYes then
    ModalResult    := mrOk
  else
    ModalResult := mrCancel;
end;

{ Ruler Indent Dragging }

function TabcsfRichEditDialog.RoundIndentPos(i: integer): integer;
{fix to every 24 pixels}
const
  INDENT_STEP = 24;
begin
  if i < 0 then
    Result := 0
  else
  begin
    Result := Round( i / INDENT_STEP ) * INDENT_STEP;
{    if Result > Ruler.Width then
      Result := Ruler.Width  }
  end;
end;

procedure TabcsfRichEditDialog.RulerItemMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragOfs := (TLabel(Sender).Width div 2);
  TLabel(Sender).Left := TLabel(Sender).Left+X-FDragOfs;
  FDragging := True;
  FFirstLastMove := True;
end;

procedure TabcsfRichEditDialog.RulerItemMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  newPos: integer;
begin
  if FDrawing then Exit;
  if FDragging then
  begin
    newPos := RoundIndentPos(TLabel(Sender).Left+X-FDragOfs);
    if newPos > FRightMax then
      newPos := FRightMax;
    TLabel(Sender).Left := newPos;
    MoveDragLine(newPos);
    FLastMovePos := newPos;
  end;
end;

procedure TabcsfRichEditDialog.FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i: integer;
begin
  FDragging := False;
  i := Trunc((FirstInd.Left+FDragOfs-GutterWid) / RulerAdj);
  if i < 0 then i := 0;
  Editor.Paragraph.FirstIndent := i;
  LeftIndMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TabcsfRichEditDialog.MoveDragLine(X: Integer);
var
  DrawDC: HDC;
  ARect: TRect;
begin
  DrawDC := GetDC(0);
  try
    GetWindowRect(Editor.Handle, ARect);
    FDrawing := True;
    if FFirstLastMove then
      FFirstLastMove := False
    else
      DrawDragLine(DrawDC, ARect, FLastMovePos);
    DrawDragLine(DrawDC, ARect, X);
  finally
    ReleaseDC(0, DrawDC);
    FDrawing := False;
  end;
end;

procedure TabcsfRichEditDialog.DrawDragLine(DC: HDC; CRect: TRect; X: Integer);
var
  DrawRect: TRect;
  ScrPos: TPoint;
begin
  {adjust Pos in Parent to Screen Pos}
  ScrPos := Point(X + FDragOfs, 0);
  ScrPos := ClientToScreen(ScrPos);
  with ScrPos, CRect do begin
    DrawRect := Rect(X, Top, X+1, Bottom);
    InvertRect(DC, DrawRect);
  end;
end;

procedure TabcsfRichEditDialog.LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i: integer;
begin
  FDragging := False;
  if not FFirstLastMove then begin
    FFirstLastMove := True;
    MoveDragLine(FLastMovePos);
  end;
  i := Trunc((LeftInd.Left+FDragOfs-GutterWid) / RulerAdj)-Editor.Paragraph.FirstIndent;
  if i < 0 then i := 0;
  Editor.Paragraph.LeftIndent := i;
  SelectionChange(Sender);
end;

procedure TabcsfRichEditDialog.RightIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i: integer;
begin
  FDragging := False;
  if not FFirstLastMove then begin
    FFirstLastMove := True;
    MoveDragLine(FLastMovePos);
  end;
  i := Trunc((Ruler.ClientWidth-RightInd.Left+FDragOfs-2) / RulerAdj)-2*GutterWid;
  if i < 0 then i := 0;
  Editor.Paragraph.RightIndent := i;
  SelectionChange(Sender);
end;

procedure TabcsfRichEditDialog.UpdateCursorPos;
var
  CharPos: TPoint;
begin
  CharPos.Y := SendMessage(Editor.Handle, EM_EXLINEFROMCHAR, 0,
    Editor.SelStart);
  CharPos.X := (Editor.SelStart -
    SendMessage(Editor.Handle, EM_LINEINDEX, CharPos.Y, 0));
  Inc(CharPos.Y);
  Inc(CharPos.X);
  StatusBar.Panels[0].Text := Format(sabcRichEditEditorStatusPanel0, [CharPos.Y, CharPos.X]);

  // update the status of the cut and copy command
  btnEditCopy.Enabled := Editor.SelLength > 0;
  miEditCopy.Enabled := btnEditCopy.Enabled;
  btnEditCut.Enabled := btnEditCopy.Enabled;
  miEditCut.Enabled := btnEditCopy.Enabled;
  btnEditDelete.Enabled := btnEditCopy.Enabled;
  miEditDelete.Enabled := btnEditCopy.Enabled;
end;

procedure TabcsfRichEditDialog.FormShow(Sender: TObject);
begin
  FShowing := True;
  UpdateCursorPos;
  RichEditChange(nil);
  Editor.SetFocus;
  ClipboardChanged;
  Editor.Modified := False;
  SetModified(False);
  LeftAlignToolbars;
end;

procedure TabcsfRichEditDialog.RichEditChange(Sender: TObject);
begin
  SetModified(Editor.Modified);
  btnEditUndo.Enabled := SendMessage(Editor.Handle, EM_CANUNDO, 0, 0) <> 0;
  miEditUndo.Enabled := btnEditUndo.Enabled;
end;

procedure TabcsfRichEditDialog.SetModified(Value: Boolean);
begin
  if Value then
    StatusBar.Panels[1].Text := sabcRichEditEditorStatusPanel1
  else
    StatusBar.Panels[1].Text := '';
end;

procedure TabcsfRichEditDialog.WMChangeCBChain(var Msg: TWMChangeCBChain);
begin
  if Msg.Remove = FClipboardOwner then
    FClipboardOwner := Msg.Next
  else
    SendMessage(FClipboardOwner, WM_CHANGECBCHAIN, Msg.Remove, Msg.Next);
  Msg.Result := 0;
end;

procedure TabcsfRichEditDialog.ClipboardChanged;
begin
  btnEditPaste.Enabled := (SendMessage(Editor.Handle, EM_CANPASTE, 0, 0) <> 0);
  miEditPaste.Enabled := btnEditPaste.Enabled;
end;

procedure TabcsfRichEditDialog.WMDrawClipboard(var Msg: TWMDrawClipboard);
begin
  SendMessage(FClipboardOwner, WM_DRAWCLIPBOARD, 0, 0);
  Msg.Result := 0;
  ClipboardChanged;
end;

procedure TabcsfRichEditDialog.FormDestroy(Sender: TObject);
begin
  // remove from the viewer chain
  ChangeClipboardChain(Handle, FClipboardOwner);
  abcApplicationEvents.UnRegisterOnHint(AppShowHint);
  FTabList.Free;
end;

procedure TabcsfRichEditDialog.cboFontSizeKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (Key in [#8, #33..#40, #46, '0'..'9']) then
    Key := #0;
end;

procedure TabcsfRichEditDialog.cboColorChange(Sender: TObject);
begin
  Editor.SelAttributes.Color := cboColor.SelectedColor;
end;

procedure TabcsfRichEditDialog.FilePageSetup(Sender: TObject);
begin
  Editor.ShowPageSetupDialog;
end;

procedure TabcsfRichEditDialog.FileLoadTemplate(Sender: TObject);
begin
  Editor.LoadTemplate;
end;

procedure TabcsfRichEditDialog.SearchFind(Sender: TObject);
begin
  Editor.ShowFindDialog;
end;

procedure TabcsfRichEditDialog.SearchReplace(Sender: TObject);
begin
  Editor.ShowReplaceDialog;
end;

procedure TabcsfRichEditDialog.SearchFindNext(Sender: TObject);
begin
  Editor.FindNext;
end;

procedure TabcsfRichEditDialog.btnEditDateTimeClick(Sender: TObject);
var
  Dialog: TabcsfPasteDateTimeDialog;
  sDate: string;
begin
  Dialog := TabcsfPasteDateTimeDialog(
    abcFormFactory.CreateFormOfClass(TabcsfPasteDateTimeDialog, Self));
  with Dialog do
  try
    if ShowModal = mrOk then
    begin
      sDate := lstFormats.Items[lstFormats.ItemIndex];
      abcStrToClip(lstFormats.Items[lstFormats.ItemIndex]);
      Editor.PasteFromClipboard;
    end
  finally
    Free;
  end;
end;

procedure TabcsfRichEditDialog.btnParaIndentClick(Sender: TObject);
begin
  with Editor.Paragraph do
  try                                                               //need logpixels conversion
    FUpdating := True;                                              //either 1/4 inch or 5mm movement.
    FirstIndent := FirstIndent + 24;                                //depends on screen or printer device
    FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
    LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
    UpdateCursorPos;
  finally
    FUpdating := False;
  end;
end;

procedure TabcsfRichEditDialog.btnParaOutdentClick(Sender: TObject);
begin
  with Editor.Paragraph do
  try
    FUpdating := True;
    FirstIndent := FirstIndent - 24;                                   //need logpixels conversion
    FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
    LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
    UpdateCursorPos;
  finally
    FUpdating := False;
  end;
end;

procedure TabcsfRichEditDialog.TabMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  // moves or remove a tab
{var
  i: integer;  }
begin
  FDragging := False;
  if not FFirstLastMove then begin
    FFirstLastMove := True;
    MoveDragLine(FLastMovePos);
  end;
  if (Y > Ruler.Height) or (Y < 0) then
    RemoveTab(TLabel(Sender))
  else
    MoveTabTo(TLabel(Sender), CalcTabPos(Sender));
end;

procedure TabcsfRichEditDialog.RemoveTab(ALabel: TLabel);
begin
end;

procedure TabcsfRichEditDialog.MoveTabTo(ALabel: TLabel; NewTabStop: Integer);
begin
end;

function TabcsfRichEditDialog.CalcTabPos(Sender: TObject): Integer;
begin
  Result := Trunc((TLabel(Sender).Left+FDragOfs-GutterWid){ / RulerAdj});
  if Result < 0 then
    Result := 0
  else if Result > FRightMax then
    Result := FRightMax;
end;

procedure TabcsfRichEditDialog.RulerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //create a tab unless we already have one, if clicked in bottom half of ruler.
  if (Y > RulerLine.Top) and (Y < Ruler.Height) then
    CheckCreateTabAt(X);
//    CheckCreateTabAt(Trunc((X+FDragOfs-GutterWid) / RulerAdj));
end;

procedure TabcsfRichEditDialog.CheckCreateTabAt(X: Integer);
var
  i: integer;
  AdjustedTabPos: integer;
begin

  Exit;    //removed - not yet implemented

  AdjustedTabPos := Trunc((X+FDragOfs-GutterWid) / RulerAdj);
  with Editor.Paragraph do
  begin
    for i := 0 to TabCount - 1 do
      if Tab[i] = AdjustedTabPos then
        Exit;
    // need a new tab
    CreateTabLabelAt(X);
//    Tab[TabCount] := AdjustedTabPos;
    Tab[TabCount+1] := AdjustedTabPos;
    Tab[TabCount+1] := AdjustedTabPos;
//    UpdateCursorPos;
    //selection change?
  end;
end;

function TabcsfRichEditDialog.CreateTabLabelAt(TabStop: Integer): TLabel;
var
  newLeft: integer;
begin
  Result := TLabel.Create(Self);
  with Result do
  begin
    Visible := False;
    Parent := Ruler;
    Font := lblTab.Font;
    Caption := lblTab.Caption;
    OnMouseDown := RulerItemMouseDown;
    OnMouseUp := TabMouseUp;
    OnMouseMove := RulerItemMouseMove;
    newLeft := TabStop; //plus adjustment
    SetBounds(newLeft, lblTab.Top, Width, Height);
    Transparent := True;
    Visible := True;
    FTabList.Add(Result);
  end;
end;

procedure TabcsfRichEditDialog.EditorCancel(Sender: TObject);
begin
  Editor.Modified := False;
  ModalResult := mrCancel;
end;

procedure TabcsfRichEditDialog.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) and (areCancelOnEsc in Editor.EditorOptions) then
    Editor.CancelChanges;
end;

procedure TabcsfRichEditDialog.FormActivate(Sender: TObject);
begin
  FShowing := False;
end;

initialization
  abcFormFactory.RegisterBaseFormClass(TabcsfRichEditDialog);

end.