unit abcfspla;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, abcforms, abcfact, abcshapf;

type

  TabcsfSplash = class(TabcForm)
    pnlSplash: TPanel;
    imgSplash: TImage;
    tmrClose: TTimer;
    abcShapeForm1: TabcShapeForm;
    procedure tmrCloseTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure imgSplashClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure abcShapeForm1Click(Sender: TObject);
  private
    { Private declarations }
    FCloseOnClick: Boolean;
{$IFDEF DELPHI6}
    procedure WMNCLButtonDown(var Message: TWMNCLButtonDown); message WM_NCLBUTTONDOWN;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure WMPrint(var Message: TMessage); message WM_PRINT;
{$ENDIF}
  protected
{$IFDEF DELPHI6}
    procedure CreateParams(var Params: TCreateParams); override;
{$ENDIF}
  public
    { Public declarations }
    property CloseOnClick: Boolean read FCloseOnClick write FCloseOnClick;
  end;

var
  frmabcSplash: TabcsfSplash;

implementation

{$R *.DFM}

{$IFDEF DELPHI6}

procedure TabcsfSplash.CreateParams(var Params: TCreateParams);
begin
  inherited;
  with Params do
  begin
    Style := WS_POPUP;
    WindowClass.Style := WindowClass.Style or CS_SAVEBITS;
  end;
end;

procedure TabcsfSplash.WMNCHitTest(var Message: TWMNCHitTest);
begin
  Message.Result := HTCAPTION;
end;

procedure TabcsfSplash.WMNCLButtonDown(var Message: TWMNCLButtonDown);
begin
  if CloseOnClick then Close;
end;

procedure TabcsfSplash.WMPrint(var Message: TMessage);
begin
  PaintTo(Message.WParam, 0, 0);
end;

{$ENDIF}

procedure TabcsfSplash.tmrCloseTimer(Sender: TObject);
begin
  Close;
end;

procedure TabcsfSplash.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TabcsfSplash.imgSplashClick(Sender: TObject);
begin
  if CloseOnClick then Close;
end;

procedure TabcsfSplash.FormActivate(Sender: TObject);
begin
  tmrClose.Enabled := (tmrClose.Interval <> 0);
end;

procedure TabcsfSplash.abcShapeForm1Click(Sender: TObject);
begin
  if CloseOnClick then Close;
end;

initialization
  abcFormFactory.RegisterBaseFormClass(TabcsfSplash);

end.
