unit abcnpcon;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses classes, db;

resourcestring

  sabcnpiMask = 'Record #R of #N';
  sabcnpiDisabled = 'Disabled';
  sabcnpiRecMarker = '#R';
  sabcnpiCountMarker = '#N';
  sabcnpiInactive = 'Inactive';
  sabcnpiBrowse = 'Browse';
  sabcnpiEdit = 'Edit';
  sabcnpiInsert = 'Insert';
  sabcnpiSetKey = 'Set Key';
  sabcnpiCalcFields = 'Calculating Fields';
  sabcnpiDSMask = '#D #S';
  sabcnpiDSNameMarker = '#D';
  sabcnpiDSStateMarker = '#S';
  sabcnpiBooleanFalse = 'False';
  sabcnpiBooleanTrue = 'True';
  sabcnpiDSStatesInactive = 'dsInactive';
  sabcnpiDSStatesBrowse = 'dsBrowse';
  sabcnpiDSStatesEdit = 'dsEdit';
  sabcnpiDSStatesInsert = 'dsInsert';
  sabcnpiDSStatesSetKey = 'dsSetKey';
  sabcnpiDSStatesCalcFields = 'dsCalcFields';
  sabcnpiDSStatesFilter = 'dsFilter';
  sabcnpiDSStatesNewValue = 'dsNewValue';
  sabcnpiDSStatesOldValue = 'dsOldValue';
  sabcnpiDSStatesCurValue = 'dsCurValue';
  sabcnpiDSStatesBlockRead = 'dsBlockRead';
  sabcnpiDSStatesInternalCalc = 'dsInternalCalc';
  sabcnpiDSStatesOpening = 'dsOpening';
  sabcnpiDirtyRead = 'tiDirtyRead';
  sabcnpiReadCommitted = 'tiReadCommitted';
  sabcnpiRepeatableRead = 'tiRepeatableRead';
  sabcnpittDefault = 'ttDefault';
  sabcnpittParadox = 'ttParadox';
  sabcnpittDBase = 'ttDBase';
  sabcnpittASCII = 'ttASCII';
  sabcnpittFoxPro = 'ttFoxPro';
  sabcnpiupWhereAll = 'upWhereAll';
  sabcnpiupWhereChanged = 'upWhereChanged';
  sabcnpiupWhereKeyOnly = 'upWhereKeyOnly';
  sabcnpipbByName = 'pbByName';
  sabcnpipbByNumber = 'pbByNumber';
  sabcnpiftUnknown = 'ftUnknown';
  sabcnpiftString = 'ftString';
  sabcnpiftSmallint = 'ftSmallint';
  sabcnpiftInteger = 'ftInteger';
  sabcnpiftWord = 'ftWord';
  sabcnpiftBoolean = 'ftBoolean';
  sabcnpiftFloat = 'ftFloat';
  sabcnpiftCurrency = 'ftCurrency';
  sabcnpiftBCD = 'ftBCD';
  sabcnpiftDate = 'ftDate';
  sabcnpiftTime = 'ftTime';
  sabcnpiftDateTime = 'ftDateTime';
  sabcnpiftBytes = 'ftBytes';
  sabcnpiftVarBytes = 'ftVarBytes';
  sabcnpiftAutoInc = 'ftAutoInc';
  sabcnpiftBlob = 'ftBlob';
  sabcnpiftMemo = 'ftMemo';
  sabcnpiftGraphic = 'ftGraphic';
  sabcnpiftFmtMemo = 'ftFmtMemo';
  sabcnpiftParadoxOle = 'ftParadoxOle';
  sabcnpiftDBaseOle = 'ftDBaseOle';
  sabcnpiftTypedBinary = 'ftTypedBinary';
  sabcnpiftCursor = 'ftCursor';
  sabcnpiftFixedChar = 'ftFixedChar';
  sabcnpiftWideString = 'ftWideString';
  sabcnpiftLargeint = 'ftLargeint';
  sabcnpiftADT = 'ftADT';
  sabcnpiftArray = 'ftArray';
  sabcnpiftReference = 'ftReference';
  sabcnpiftDataSet = 'ftDataSet';
  sabcnpiftOraBlob = 'ftOraBlob';
  sabcnpiftOraClob = 'ftOraClob';
  sabcnpiftVariant = 'ftVariant';
  sabcnpiftInterface = 'ftInterface';
  sabcnpiftIDispatch = 'ftIDispatch';
  sabcnpiftGuid = 'ftGuid';
  sabcnpiftTimeStamp = 'ftTimeStamp';
  sabcnpiftFMTBcd = 'ftFMTBcd';

  sabcnpifftUnknown = 'Unknown    ';
  sabcnpifftString = 'String     ';
  sabcnpifftSmallint = 'Smallint   ';
  sabcnpifftInteger = 'Integer    ';
  sabcnpifftWord = 'Word       ';
  sabcnpifftBoolean = 'Boolean    ';
  sabcnpifftFloat = 'Float      ';
  sabcnpifftCurrency = 'Currency   ';
  sabcnpifftBCD = 'BCD        ';
  sabcnpifftDate = 'Date       ';
  sabcnpifftTime = 'Time       ';
  sabcnpifftDateTime = 'DateTime   ';
  sabcnpifftBytes = 'Bytes      ';
  sabcnpifftVarBytes = 'VarBytes   ';
  sabcnpifftAutoInc = 'AutoInc    ';
  sabcnpifftBlob = 'Blob       ';
  sabcnpifftMemo = 'Memo       ';
  sabcnpifftGraphic = 'Graphic    ';
  sabcnpifftFmtMemo = 'FmtMemo    ';
  sabcnpifftParadoxOle = 'ParadoxOle ';
  sabcnpifftDBaseOle = 'DBaseOle   ';
  sabcnpifftTypedBinary = 'TypedBinary';
  sabcnpifftCursor = 'Cursor     ';
  sabcnpifftFixedChar = 'FixedChar  ';
  sabcnpifftWideString = 'WideString ';
  sabcnpifftLargeint = 'Largeint   ';
  sabcnpifftADT = 'ADT        ';
  sabcnpifftArray = 'Array      ';
  sabcnpifftReference = 'Reference  ';
  sabcnpifftDataSet = 'DataSet    ';
  sabcnpifftOraBlob = 'OraBlob    ';
  sabcnpifftOraClob = 'OraClob    ';
  sabcnpifftVariant = 'Variant    ';
  sabcnpifftInterface = 'Interface  ';
  sabcnpifftIDispatch = 'IDispatch  ';
  sabcnpifftGuid = 'Guid       ';
  sabcnpifftTimeStamp = 'TimeStamp  ';
  sabcnpifftFMTBcd = 'FMT BCD    ';

  sabcnpitaLeftJustify = 'taLeftJustify';
  sabcnpitaRightJustify = 'taRightJustify';
  sabcnpitaCenter = 'taCenter';
  sabcnpiptUnknown = 'ptUnknown';
  sabcnpiptInput = 'ptInput';
  sabcnpiptOutput = 'ptOutput';
  sabcnpiptInputOutput = 'ptInputOutput';
  sabcnpiptResult = 'ptResult';
  sabcnpiIndent = '  ';
  sabcnpiComp = 'Component:';
  sabcnpiNameEq = 'Name = ';
  sabcnpiOCNameEq = 'Owner.ClassName = ';
  sabcnpiParentEq = 'Parent = ';
  sabcnpiParentClassEq = 'Parent.ClassName = ';
  sabcnpiParentDSNil = 'Parent.DataSource = nil';
  sabcnpiParentDSEq = 'Parent.DataSource = ';
  sabcnpiParentDSAuto = 'Parent.DataSource.AutoEdit = ';
  sabcnpiParentDSEnabled = 'Parent.DataSource.Enabled = ';
  sabcnpiParentDSState = 'Parent.DataSource.State = ';
  sabcnpiParentDSDSNil = 'Parent.DataSource.DataSet = nil';
  sabcnpiParentDSDSEq = 'Parent.DataSource.DataSet.Name = ';
  sabcnpiNull = '';
  sabcnpiDatabase = 'Database';
  sabcnpiDBCompName = 'TDatabase Component Name = ';
  sabcnpiDBName = 'DatabaseName = ';
  sabcnpiAlias = 'AliasName = ';
  sabcnpiConnected = 'Connected = ';
  sabcnpiDSCount = 'DatasetCount = ';
  sabcnpiDriver = 'DriverName = ';
  sabcnpiSQLBased = 'IsSQLBased = ';
  sabcnpiKeepConn = 'KeepConnection = ';
  sabcnpiLogin = 'LoginPrompt = ';
  sabcnpiTemp = 'Temporary = ';
  sabcnpiTransIsol = 'TransIsolation = ';
  sabcnpiParams = 'Params:';
  sabcnpiParamsEmpty = 'List is empty.';
  sabcnpiTBNames = 'Table Names:';
  sabcnpiSPNames = 'Stored Procedure Names:';
  sabcnpiNotSupported = 'Capability not supported';
  sabcnpiAliasParams = 'Alias Params:';
  sabcnpiException = 'Exception: ';
  sabcnpiDriverParams = 'Driver Params:';
  sabcnpiDBNil = 'Database is nil.';
  sabcnpiDS = 'Dataset:';
  sabcnpiClassNameEq = 'ClassName = ';
  sabcnpiActive = 'Active = ';
  sabcnpiAutoCalc = 'AutoCalcFields = ';
  sabcnpiBOF = 'BOF = ';
  sabcnpiEOF = 'EOF = ';
  sabcnpiCanModify = 'CanModify = ';
  sabcnpiDSNil = 'DataSource = nil';
  sabcnpiDSEq = 'DataSource = ';
  sabcnpiDefaultFields = 'DefaultFields = ';
  sabcnpiFieldCount = 'FieldCount = ';
  sabcnpiModified = 'Modified = ';
  sabcnpiRecordCount = 'RecordCount = ';
  sabcnpiRecordSize = 'RecordSize = ';
  sabcnpiState = 'State = ';
  sabcnpiFieldSummary = 'Field Summary:';
  sabcnpiSpace = ' ';
  sabcnpiReqd = ' REQD';
  sabcnpiNotReqd = '     ';
  sabcnpiRO = ' RO';
  sabcnpiNotRO = '   ';
  sabcnpiIndexed = ' Indexed';
  sabcnpiTableProps = 'Table Properties:';
  sabcnpiTBName = 'TableName = ';
  sabcnpiTBType = 'TableType = ';
  sabcnpiIxFieldCount = 'IndexFieldCount = ';
  sabcnpiKeyExcl = 'KeyExclusive = ';
  sabcnpiKeyFieldCount = 'KeyFieldCount = ';
  sabcnpiNoKeyExcl = 'KeyExclusive  cannot be read in current State.';
  sabcnpiNoKeyFieldCount = 'KeyFieldCount cannot be read in current State.';
  sabcnpiExcl = 'Exclusive = ';
  sabcnpiIndexFieldNames = 'IndexFieldNames = ';
  sabcnpiIndexName = 'IndexName = ';
  sabcnpiMasterFields = 'MasterFields = ';
  sabcnpiMasterSourceNil = 'MasterSource = nil';
  sabcnpiMasterSource = 'MasterSource = ';
  sabcnpiReadOnly = 'ReadOnly = ';
  sabcnpiUpdateMode = 'UpdateMode = ';
  sabcnpiQueryProps = 'Query Properties:';
  sabcnpiSQL = 'SQL:';
  sabcnpiSQLText = 'Text property, actual SQL passed to BDE:';
  sabcnpiTextEmpty = 'Text is empty.';
  sabcnpiLocal = 'Local = ';
  sabcnpiParamCount = 'ParamCount = ';
  sabcnpiPrepared = 'Prepared = ';
  sabcnpiRequestLive = 'RequestLive = ';
  sabcnpiUniDirectional = 'UniDirectional = ';
  sabcnpiTableInfo = 'Table information';
  sabcnpiSPProps = 'Stored Procedure Properties:';
  sabcnpiSPName = 'StoredProcName = ';
  sabcnpiDescAvail = 'DescriptionsAvailable = ';
  sabcnpiOverload = 'Overload = ';
  sabcnpiParamBindMode = 'ParamBindMode = ';
  sabcnpiBDE = 'BDE Engine:';
  sabcnpiSysInfo = 'System Info:';
  sabcnpiBufferSpace = 'BufferSpace = ';
  sabcnpiHeapSpace = 'HeapSpace = ';
  sabcnpiDrivers = 'Drivers = ';
  sabcnpiClients = 'Clients = ';
  sabcnpiSessions = 'Sessions = ';
  sabcnpiDatabases = 'Databases = ';
  sabcnpiCursors = 'Cursors = ';
  sabcnpiDBIErrStatus = 'Error retrieving system status.  DBIERR = ';
  sabcnpiClientInfo = 'Client Info:';
  sabcnpiQueryInfo = 'Query information';
  sabcnpiWorkDir = 'WorkDir = ';
  sabcnpiLang = 'Lang = ';
  sabcnpiDBIErrClientStatus = 'Error retrieving client status.  DBIERR = ';
  sabcnpiConfigInfo = 'Config Info:';
  sabcnpiLocalShare = 'LocalShare = ';
  sabcnpiNetProtocol = 'NetProtocol = ';
  sabcnpiNetShare = 'NetShare = ';
  sabcnpiNetType = 'NetType = ';
  sabcnpiUserName = 'UserName = ';
  sabcnpiIniFile = 'IniFile = ';
  sabcnpiLangDriver = 'LangDriver = ';
  sabcnpiDBIErrConfig = 'Error retrieving system config.  DBIERR = ';
  sabcnpiVersionInfo = 'Version Info:';
  sabcnpiEngineversion = 'Engine version = ';
  sabcnpiClientInterfacelevel = 'Client Interface level = ';
  sabcnpiVersiondate = 'Version date = ';
  sabcnpiVersiontime = 'Version time = ';
  sabcnpiDBIErrSysVersion = 'Error retrieving system version.  DBIERR = ';
  sabcnpiFields = 'Fields:';
  sabcnpiAsterisk = '*';
  sabcnpiAsFieldName = '* FieldName = ';
  sabcnpiAsFieldNo = '* FieldNo = ';
  sabcnpiAsDataType = '* DataType = ';
  sabcnpiAsClass = '* ClassName = ';
  sabcnpiAsSize = '* Size = ';
  sabcnpiAlignment = 'Alignment = ';
  sabcnpiCalculated = 'Calculated = ';
  sabcnpiSPInfo = 'Stored Procedure information';
  sabcnpiDataSize = 'DataSize = ';
  sabcnpiDisplayLabel = 'DisplayLabel = ';
  sabcnpiDisplayName = 'DisplayName = ';
  sabcnpiDisplayText = 'DisplayText = ';
  sabcnpiDisplayWidth = 'DisplayWidth = ';
  sabcnpiEditMask = 'EditMask = ';
  sabcnpiIndex = 'Index = ';
  sabcnpiIsIndexField = 'IsIndexField = ';
  sabcnpiDSInfo = 'Dataset information';
  sabcnpiRequired = 'Required = ';
  sabcnpiVisible = 'Visible = ';
  sabcnpiIndexes = 'Indexes';
  sabcnpiCurrentIndexName = 'Current IndexName = ';
  sabcnpiCurrentIndexFieldNames = 'Current IndexFieldNames = ';
  sabcnpiCurrentIndexDefs = 'Current IndexDefs:';
  sabcnpiExpression = 'Expression = ';
  sabcnpiFieldsEq = 'Fields = ';
  sabcnpiSep = ', ';
  sabcnpiixPrimary = 'ixPrimary';
  sabcnpiixUnique = 'ixUnique';
  sabcnpiixDescending = 'ixDescending';
  sabcnpiixCaseInsensitive = 'ixCaseInsensitive';
  sabcnpiixExpression = 'ixExpression';
  sabcnpiLeftBr = '[';
  sabcnpiRightBr = ']';
  sabcnpiOptions = 'Options = ';
  sabcnpiNoIndexDefs = 'no indexdefs available.';
  sabcnpiNotTable = 'Dataset is not TTable.';
  sabcnpiDataType = 'DataType = ';
  sabcnpiBound = 'Bound = ';
  sabcnpiIsNull = 'IsNull = ';
  sabcnpiParamType = 'ParamType = ';
  sabcnpiText = 'Text = ';
  sabcnpifor = ' for ';
  sabcnpiNoTableParams = 'Params not available for TTable.';
  sabcnpiSession = 'Session:';
  sabcnpiDatabaseCount = 'DatabaseCount = ';
  sabcnpiDatabaseNames = 'Database Names:';
  sabcnpiKeepConnections = 'KeepConnections = ';
  sabcnpiNetFileDir = 'NetFileDir = ';
  sabcnpiPrivateDir = 'PrivateDir = ';
  sabcnpiBDEDriverNames = 'BDE Driver Names:';
  sabcnpiDataSetNil = 'DataSet is nil.';
  sabcnpDataSourceNil = 'datasource nil';
  sabcnpDataSetNil = 'dataset nil';
  sabcnpDataSetInactive = 'dataset inactive';
  sabcnpInvalidReadOnly = 'Invalid action for read only view of dataset';
  sabcnpOnColEnter = 'OnColEnter';
  sabcnpGridHookOnColEnter = 'GridHookOnColEnter';
  sabcnpOnRowEnter = 'OnRowEnter';
  sabcnpDataSource = 'DataSource';
  sabcnpDataField = 'DataField';
  sabcnpCapDSSep = ' - ';
  sabcnpCapDSNil = 'Nil DataSource';
  sabcnpWarnEmptyTable = 'This will delete all records from %t. Are you sure you want to continue?';
  sabcnpTableMask = '%t';
  sabcnpNotAutoForm = 'FormClass is not TabcnpAutoForm';
  sabcnpClassPrefix = 'T';
  sabcnpSearch = 'Searching: %d';
  sabcnpSearching = 'Searching: ';
  sabcnpBmkGoTo = 'Go To';
  sabcnpBmkAdd = 'Add';
  sabcnpBmkRemove = 'Remove';
  sabcnpBmkRemoveAll = 'Remove All';
  sabcnpBmk = 'Bookmark ';
  sabcnpBmkSep = ';';
  sabcnpBmkDummy1 = 'DummyItem1';
  sabcnpBmkDummy2 = 'DummyItem2';
  sabcnpBmkSub = 'miGotoBmkSubMenu';
  sabcnpBmkSubAdd = 'miAddBmk';
  sabcnpBmkSubRemove = 'miRemoveBmkSubMenu';
  sabcnpBmkSubRemoveAll = 'miRemoveAll';
  sabcnpBmkPopup = 'Popup';
  sabcnpIdxSep1 = ';';
  sabcnpIdxSep2 = ';0';
  sabcnpRangeSep = '-';
  sabcnpFltEquals = ' = ';
  sabcnpFltNot = 'NOT ';

const
  ABC_BOOLEANS: array[Boolean] of string = (sabcnpiBooleanFalse, sabcnpiBooleanTrue);
  ABC_ALIGNMENTS: array[TAlignment] of string =
    (sabcnpitaLeftJustify, sabcnpitaRightJustify, sabcnpitaCenter);
  ABC_DATASETSTATES: array[TDataSetState] of string =
    (sabcnpiDSStatesInactive, sabcnpiDSStatesBrowse, sabcnpiDSStatesEdit,
     sabcnpiDSStatesInsert, sabcnpiDSStatesSetKey, sabcnpiDSStatesCalcFields,
     sabcnpiDSStatesFilter, sabcnpiDSStatesNewValue, sabcnpiDSStatesOldValue,
     sabcnpiDSStatesCurValue, sabcnpiDSStatesBlockRead, sabcnpiDSStatesInternalCalc
{$IFDEF DELPHI5}
     , sabcnpiDSStatesOpening
{$ENDIF}
     );

  ABC_FIELDTYPES: array[TFieldType] of string =
    (sabcnpiftUnknown, sabcnpiftString, sabcnpiftSmallint, sabcnpiftInteger,
     sabcnpiftWord, sabcnpiftBoolean, sabcnpiftFloat, sabcnpiftCurrency,
     sabcnpiftBCD, sabcnpiftDate, sabcnpiftTime, sabcnpiftDateTime,
     sabcnpiftBytes, sabcnpiftVarBytes,  sabcnpiftAutoInc, sabcnpiftBlob,
     sabcnpiftMemo, sabcnpiftGraphic, sabcnpiftFmtMemo, sabcnpiftParadoxOle,
     sabcnpiftDBaseOle, sabcnpiftTypedBinary, sabcnpiftCursor, sabcnpiftFixedChar,
     sabcnpiftWideString, sabcnpiftLargeint, sabcnpiftADT, sabcnpiftArray,
     sabcnpiftReference, sabcnpiftDataSet
{$IFDEF DELPHI5}
    , sabcnpiftOraBlob, sabcnpiftOraClob, sabcnpiftVariant, sabcnpiftInterface,
    sabcnpiftIDispatch, sabcnpiftGuid
{$ENDIF}
{$IFDEF DELPHI6}
    , sabcnpiftTimeStamp, sabcnpiftFMTBcd
{$ENDIF}
     );

  ABC_FMTFIELDTYPES: array[TFieldType] of string =
    (sabcnpifftUnknown, sabcnpifftString, sabcnpifftSmallint, sabcnpifftInteger,
     sabcnpifftWord, sabcnpifftBoolean, sabcnpifftFloat, sabcnpifftCurrency,
     sabcnpifftBCD, sabcnpifftDate, sabcnpifftTime, sabcnpifftDateTime,
     sabcnpifftBytes, sabcnpifftVarBytes,  sabcnpifftAutoInc, sabcnpifftBlob,
     sabcnpifftMemo, sabcnpifftGraphic, sabcnpifftFmtMemo, sabcnpifftParadoxOle,
     sabcnpifftDBaseOle, sabcnpifftTypedBinary, sabcnpifftCursor, sabcnpifftFixedChar,
     sabcnpifftWideString, sabcnpifftLargeint, sabcnpifftADT, sabcnpifftArray,
     sabcnpifftReference, sabcnpifftDataSet
{$IFDEF DELPHI5}
    , sabcnpifftOraBlob, sabcnpifftOraClob, sabcnpifftVariant, sabcnpifftInterface,
    sabcnpifftIDispatch, sabcnpifftGuid
{$ENDIF}
{$IFDEF DELPHI6}
    , sabcnpifftTimeStamp, sabcnpifftFMTBcd
{$ENDIF}
     );

implementation

end.
