unit abcpbtns;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{
  Component Editors for TabcShapeButton

  - Test Previewer
  - Image Edge Enhancer for Up/Down Shading
}

interface

uses Classes, Forms, Dialogs, abcbtns,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcShapeButtonEditor }

  TabcShapeButtonEditor = class(TDefaultEditor)
  private
    procedure MakeEdgeBitmaps;
    procedure Preview;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

uses abcdfsbp, abcdfsbd;

{ TabcShapeButtonEditor }

function TabcShapeButtonEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

function TabcShapeButtonEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Load Bitmap';
    1: Result := '&Preview';
  else
    Result := '';
  end;
end;

procedure TabcShapeButtonEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: MakeEdgeBitmaps;
    1: Preview;
  else
  end;
end;

procedure TabcShapeButtonEditor.MakeEdgeBitmaps;
begin
  abcDesignEdgeBitmaps(TabcShapeButton(Component));
  Designer.Modified;
end;

procedure TabcShapeButtonEditor.Preview;
begin
  with TabcdfShapeButtonPreview.Create(nil) do
    try
      abcShapeButton1.Assign(TabcShapeButton(Component));
      ShowModal;
    finally
      Free;
    end;
end;

end.
