unit abcpbusy;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Windows, Classes, Controls, Forms, Dialogs, abcbusy, abcmem, abcprop,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  TabcAVIDataProperty = class(TabcPersistentMemoryProperty)
  protected
    function GetTitle: string; override;
    function GetFilter: string; override;
  end;

  TabcAVIFilenameProperty = class(TabcFileNameProperty)
  protected
    function GetTitle: string; override;
    function GetFilter: string; override;
  end;

  { TabcBusyEditor }

  TabcBusyEditor = class(TComponentEditor)
  private
    procedure Preview;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

{ TabcAVIFilenameProperty }

function TabcAVIFilenameProperty.GetTitle: string;
begin
  Result := 'Select AVI File';
end;

function TabcAVIFilenameProperty.GetFilter: string;
begin
  Result := 'AVI Files (*.avi)|*.avi|All Files (*.*)|*.*';
end;

{ TabcAVIDataProperty }

function TabcAVIDataProperty.GetFilter: string;
begin
  Result := 'AVI Files (*.avi)|*.avi|All Files (*.*)|*.*';
end;

function TabcAVIDataProperty.GetTitle: string;
begin
  Result := 'Load AVI File';
end;

{ TabcBusyEditor }

procedure TabcBusyEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Preview;
  else
  end;
end;

function TabcBusyEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Preview Dialog';
  else
    Result := '';
  end;
end;

function TabcBusyEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TabcBusyEditor.Preview;
var
  i: Integer;
  waitUntil: DWORD;
begin
  with TabcBusy(Component) do
  begin
    Show;
    if abdShowProgress in Options then
      for i := 1 to 10 do
      begin
        StepIt;
        Application.ProcessMessages;
        waitUntil := GetTickCount + 200;
        while GetTickCount < waitUntil do
        begin
          Application.ProcessMessages;
          if Cancelled then Exit;
        end;
      end;
    Hide;
  end;
end;

end.
