unit abcpedtd;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{property & component editors for File Save Edit component}

interface

uses Classes, Forms, Dialogs, abcfdir, abcedtdr,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcDirectoryEditEditor }

  TabcDirectoryEditEditor = class(TComponentEditor)
  private
    procedure Preview;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

{ TabcDirectoryProperty
  Property editor for filenames.  Displays an File Save Dialog
  for the name of the file.
}

  TabcDirectoryProperty = class(TStringProperty)
  protected
    function GetHelpContext: THelpContext; virtual;
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

implementation

{ TabcDirectoryEditEditor }

function TabcDirectoryEditEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TabcDirectoryEditEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Preview Dialog';
  else
    Result := '';
  end;
end;

procedure TabcDirectoryEditEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Preview;
  else
  end;
end;

procedure TabcDirectoryEditEditor.Preview;
begin
  TabcDirectoryEdit(Component).DirDialog.Dialog.Execute;
end;

{ TabcDirectoryProperty }

procedure TabcDirectoryProperty.Edit;
begin
  with TabcDirectoryDialog.Create(nil) do
    try
      Directory := GetValue;
      HelpContext := GetHelpContext;
      if HelpContext = 0 then
        Options := Options + [adrPathMustExist]
      else
        Options := Options + [adrShowHelp, adrPathMustExist];
      if Execute then SetValue(Directory);
    finally
      Free;
    end;
end;

function TabcDirectoryProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

function TabcDirectoryProperty.GetHelpContext: THelpContext;
begin
  Result := 0;
end;

end.
