unit abcpfx;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{
  Component Editors for TabcEffectsImage

  - Effect Preview
}

interface

uses Classes, Forms, abcfx,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcEffectSelectionProperty }

  TabcEffectSelectionProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  { TabcTransitionProperty }

  TabcTransitionProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcEffectsImageEditor }

  TabcEffectsImageEditor = class(TComponentEditor)
  private
    procedure Preview;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

uses Dialogs, SysUtils, abcdffxp,
     abcdfx32;

{ TabcEffectSelectionProperty }

function TabcEffectSelectionProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable, paReadOnly];
end;

function TabcEffectSelectionProperty.GetValue: string;
begin
  FmtStr(Result, '(%s)', [GetPropType^.Name]);
end;

procedure TabcEffectSelectionProperty.Edit;
var
  list: TList;
begin
  list := TList(GetOrdValue);
  if abcDlgEditTransitionEffectList(list) then Modified;
end;

{ TabcTransitionProperty }

function TabcTransitionProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paSubProperties, paDialog, paReadOnly];
end;

procedure TabcTransitionProperty.Edit;
var
  Transition: TabcTransition;
begin
  Transition := TabcTransition(GetOrdValue);
  if abcDlgChooseTransition(Transition) then
    SetOrdValue(Longint(Transition));
end;

{ TabcEffectsImageEditor }

function TabcEffectsImageEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TabcEffectsImageEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Choose Effect';
  else
    Result := '';
  end;
end;

procedure TabcEffectsImageEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Preview;
  else
  end;
end;

procedure TabcEffectsImageEditor.Preview;
begin
  if abcDlgChooseTransitionEffect(TabcEffectsImage(Component)) then
    Designer.Modified;
end;

end.
