unit abcpfxr;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{
  Component Editors for TabcRichEffectsImage
}

interface

uses Classes, abcfxrch,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcRichTextProperty }

  TabcRichTextProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure SetValue(const Value: string); override;
  end;

implementation


uses {$IFDEF DELPHI5} DesignConst {$ELSE} Consts{$ENDIF};


{ TabcRichTextProperty }

function TabcRichTextProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

procedure TabcRichTextProperty.Edit;
begin
  if TabcRichText(GetOrdValue).Edit then
    Modified;
end;

function TabcRichTextProperty.GetValue: string;
var
  RichText: TabcRichText;
begin
  RichText := TabcRichText(GetOrdValue);
  if RichText.Empty then
    Result := srNone else
    Result := '(TabcRichText)';
end;

procedure TabcRichTextProperty.SetValue(const Value: string);
begin
  if Value = '' then
    TabcRichText(GetOrdValue).Clear;
end;

end.
