unit abcprch;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{property & component editors for rich edit component}

interface

uses Classes, Forms, Dialogs, abcrched,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcRichEditComponentEditor }

  TabcRichEditComponentEditor = class(TComponentEditor)
  private
    procedure EditLines;
    procedure LoadFromFile;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcRichEditLinesProperty }

  TabcRichEditLinesProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

implementation

{ TabcRichEditComponentEditor }

function TabcRichEditComponentEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

function TabcRichEditComponentEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Edit';
    1: Result := '&Open File';
  else
    Result := '';
  end;
end;

procedure TabcRichEditComponentEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: EditLines;
    1: LoadFromFile;
  else
  end;
end;

procedure TabcRichEditComponentEditor.EditLines;
begin
  if TabcRichEdit(Component).Edit then
    Designer.Modified;
end;

procedure TabcRichEditComponentEditor.LoadFromFile;
begin
  with TOpenDialog.Create(nil) do
  try
    Filename := TabcRichEdit(Component).FileName;
    Filter := 'RTF files (*.RTF)|*.RTF'
      + '|Text files(*.TXT)|*.TXT'
      + '|All files(*.*)|*.*';
    HelpContext := 0;
    Options := Options + [ofPathMustExist];
    Title := 'Open Rich Text File';
    if Execute then
    begin
      TabcRichEdit(Component).OpenFile(Filename);
      Designer.Modified;
    end;
  finally
    Free;
  end;
end;

{ TabcRichEditLinesProperty }

procedure TabcRichEditLinesProperty.Edit;
begin
  if TabcRichEdit(GetComponent(0)).Edit then
    Modified;
end;

function TabcRichEditLinesProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

end.
