unit abcprop;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

This file contains property editors used by ABCREG.PAS

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

{$IFDEF VER150}
uses Classes, Contnrs, DesignIntf, DesignEditors, Vcleditors, SysUtils, Graphics, colnedit,
     Dsndbcst, DBConsts, DB, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbctl, abcdbgrf, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcsplit, abcsubfm, abcmenu;
{$ENDIF}

{$IFDEF VER140}
uses Classes, Contnrs, DesignIntf, DesignEditors, Vcleditors, SysUtils, Graphics, colnedit,
     Dsndbcst, DBConsts, DB, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbctl, abcdbgrf, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcsplit, abcsubfm, abcmenu;
{$ENDIF}

{$IFDEF VER130}
uses Classes, Contnrs, DsgnIntf, SysUtils, Graphics, colnedit,
     Dsndbcst, DBConsts, DB, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbctl, abcdbgrf, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcsplit, abcsubfm, abcmenu;
{$ENDIF}

{$IFDEF VER125}
uses Classes, DsgnIntf, SysUtils, Graphics, {Dbxplor,} {colnedit,}
     {GqeDelph,} DBConsts, DB, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbctl, abcdbgrf, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcsplit, abcsubfm, abcmenu;
{$ENDIF}

{$IFDEF VER120}
uses Classes, DsgnIntf, SysUtils, Graphics, Dbxplor, colnedit,
     GqeDelph, DBConsts, DB, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbctl, abcdbgrf, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcsplit, abcsubfm, abcmenu;
{$ENDIF}

type

  { Exception Log FileName Property Editor }

  TabcExcepLogFileNameProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{ TabcDateTimeFormatProperty }

  TabcDateTimeFormatProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcDBStringProperty }

  TabcDBStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual; abstract;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcStringListProperty }

  TabcStringListProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcColorStringsProperty }

  TabcColorStringsProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{ TabcDataSourceProperty }
  TabcDataSourceProperty = class(TComponentProperty)
  private
    FCheckProc: TGetStrProc;
    procedure CheckComponent(const Value: string);
  public
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcDataFieldProperty }

  TabcDataFieldProperty = class(TabcDBStringProperty)
  public
    function GetDataSourcePropName: string; virtual;
    procedure GetValueList(List: TStrings); override;
  end;

  { TabcAutoLabelEditor }

  TabcAutoLabelEditor = class(TDefaultEditor)
  public
    procedure Edit; override;
  end;

  { TabcDBGridEditor }

  TabcDBGridEditor = class(TComponentEditor)
  private
{$IFDEF DELPHI6}
    FColumnsEditor: IProperty;
    procedure GetColumnsEditor(const Prop: IProperty);
{$ELSE}
    FColumnsEditor: TPropertyEditor;
    procedure GetColumnsEditor(PropertyEditor: TPropertyEditor);
{$ENDIF}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcNavPanelEditor }

  TabcNavPanelEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcNavToolbarEditor }

  TabcNavToolbarEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;


  { TabcnpButtonEditor }

  TabcnpButtonEditor = class(TDefaultEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;


  { TabcnpIndexComboEditor }

  TabcnpIndexComboEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcnpFilterExprButtonEditor }

  TabcnpFilterExprButtonEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcTrueTypeFontProperty }

  TabcTrueTypeFontProperty = class(TFontProperty)
  public
    procedure Edit; override;
  end;

  { TabcDBIndexComboEditor }

  TabcDBIndexComboEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcDBFilterCompEditor }

  TabcDBFilterCompEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcWaveImageProperty - Property Editor for TabcWaveImage }

  TabcWaveImageProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcWaveListImagesProperty - Property Editor for stringlist of TabcWaveImage }

  TabcWaveListImagesProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcWaveFileProperty - Property Editor for WAV filenames }

  TabcWaveFileProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcComponentExceptSelfProperty - Property Editor used by TabcSyncListBox }

  TabcComponentExceptSelfProperty = class(TComponentProperty)
  public
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcMCIDataProperty - Property Editor for TabcMCIStreamPlayer.MCIData Property }

  TabcMCIDataProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcLineCompEditor }

  TabcLineCompEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcIniFilenameProperty
    Property editor for the TabcFormSaver.  Displays a File Open Dialog
    for the name of the INI file.}

  TabcIniFilenameProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcSplitBarWindowAProperty - Property Editor used by TabcSplitBar }

  TabcSplitBarWindowAProperty = class(TComponentProperty)
  public
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcSplitBarWindowBProperty - Property Editor used by TabcSplitBar }

  TabcSplitBarWindowBProperty = class(TComponentProperty)
  public
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcSplitPaneEditor }

  TabcSplitPaneEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  { TabcReadOnlyProperty }

  TabcReadOnlyProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TabcFileNameProperty = class(TStringProperty)
  protected
    FFileName: string;
    function GetHelpContext: THelpContext; virtual;
    function GetTitle: string; virtual;
    function GetDefaultFileName: string; virtual;
    function GetFilter: string; virtual;
    procedure AfterExecute; virtual;
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TabcPersistentMemoryProperty = class(TClassProperty)
  protected
    FFileName: string;
    function GetHelpContext: THelpContext; virtual;
    function GetTitle: string; virtual;
    function GetDefaultFileName: string; virtual;
    function GetFilter: string; virtual;
    procedure AfterExecute; virtual;
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  { TabcResTypeStringProperty }

  TabcResTypeStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TabcNotebookFormNameProperty }

  TabcNotebookFormNameProperty = class(TPropertyEditor)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    function GetValue: string; override;
    procedure SetValue(const AValue: string); override;
  end;

  { TabcTabbedNotebookFormNameProperty }

  TabcTabbedNotebookFormNameProperty = class(TPropertyEditor)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    function GetValue: string; override;
    procedure SetValue(const AValue: string); override;
  end;

  { TabcShellVerbProperty }

  TabcShellVerbProperty = class(TPropertyEditor)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    function GetValue: string; override;
    procedure SetValue(const AValue: string); override;
  end;

  { TabcNPFilterStringProperty - Property Editor for TabcnpFilterExpression.Filter}

  TabcnpFilterStringProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  { TabcTrayIconPopupMenuProperty - property editor for TabcTrayIcon.PopupMenu }

  TabcTrayIconPopupMenuProperty = class(TComponentProperty)
  public
    procedure SetValue(const Value: string); override;
  end;

procedure Register;

{$IFDEF DELPHI6}
function abcDesignerUniqueName(Designer: IDesigner; AClassName: string): string;
{$ELSE}
function abcDesignerUniqueName(Designer: IFormDesigner; AClassName: string): string;
{$ENDIF}

{$IFDEF DELPHI6}
function abcFormDesignerUniqueName(Designer: IDesignerHook; AClassName: string): string;
{$ENDIF}

implementation

uses Consts, ExptIntf, abcapp, abcutild, abcdfspl, abcdsncn, abcphint
     {$IFDEF DELPHI6}, RTLConsts {$ENDIF}
     ;

procedure Register;
begin
  RegisterLibraryExpert(TabcBrowseCompsExpert.Create);
end;

{$IFDEF DELPHI6}
function abcDesignerUniqueName(Designer: IDesigner; AClassName: string): string;
{$ELSE}
function abcDesignerUniqueName(Designer: IFormDesigner; AClassName: string): string;
{$ENDIF}
begin
  Result := Designer.UniqueName(AClassName);
end;

{$IFDEF DELPHI6}
function abcFormDesignerUniqueName(Designer: IDesignerHook; AClassName: string): string;
begin
  Result := Designer.UniqueName(AClassName);
end;
{$ENDIF}

{FileName Property Editor for TabcExcepLogFileNameProperty}

procedure TabcExcepLogFileNameProperty.Edit;
var
  sTemp: string;
begin
  with TOpenDialog.Create(nil) do
  try
    Filename := GetValue;
    sTemp := '';
    sTemp := sTemp + sabcpropdsgnLogFiles;
    sTemp := sTemp + sabcpropdsgnFileSep;
    sTemp := sTemp + sabcpropdsgnErrorFiles;
    sTemp := sTemp + sabcpropdsgnFileSep;
    sTemp := sTemp + sabcpropdsgnTextFiles;
    sTemp := sTemp + sabcpropdsgnFileSep;
    sTemp := sTemp + sabcpropdsgnAllFiles;
    Filter := sTemp;
    HelpContext := 0;
    Options := Options + [ofPathMustExist, ofHideReadOnly];
    Title := sabcpropdsgnAppErrLog;
    if Execute then SetValue(Filename);
  finally
    Free;
  end;
end;

function TabcExcepLogFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcDateTimeFormatProperty }

function TabcDateTimeFormatProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paMultiSelect];
end;

procedure TabcDateTimeFormatProperty.GetValues(Proc: TGetStrProc);
begin
  Proc(sabcpropdsgndatefmt1);
  Proc(sabcpropdsgndatefmt2);
  Proc(sabcpropdsgndatefmt3);
  Proc(sabcpropdsgndatefmt4);
  Proc(sabcpropdsgndatefmt5);
  Proc(sabcpropdsgndatefmt6);
  Proc(sabcpropdsgndatefmt7);
  Proc(sabcpropdsgndatefmt8);
  Proc(sabcpropdsgndatefmt9);
end;

{ TabcDBStringProperty }

function TabcDBStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TabcDBStringProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

{ TabcStringListProperty }
procedure TabcStringListProperty.Edit;
begin
  if (abcExecStringsEditor(TStrings(GetOrdValue)) = mrOK)  and
    (Designer <> nil) then Designer.Modified;
end;

function TabcStringListProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paReadOnly];
end;

{ TabcColorStringsProperty }
procedure TabcColorStringsProperty.Edit;
begin
  if (abcExecColorStringsEditor(TStrings(GetOrdValue)) = mrOK)  and
    (Designer <> nil) then Designer.Modified;
end;

function TabcColorStringsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paReadOnly];
end;

{ TabcDataSourceProperty }

procedure TabcDataSourceProperty.CheckComponent(const Value: string);
var
  J: Integer;
  DataSource: TDataSource;
begin
  DataSource := TDataSource(Designer.GetComponent(Value));
  for J := 0 to PropCount - 1 do
    if TDataSet(GetComponent(J)).IsLinkedTo(DataSource) then
      Exit;
  FCheckProc(Value);
end;

procedure TabcDataSourceProperty.GetValues(Proc: TGetStrProc);
begin
  FCheckProc := Proc;
  inherited GetValues(CheckComponent);
end;

{ TabcDataFieldProperty }

function TabcDataFieldProperty.GetDataSourcePropName: string;
begin
  Result := sabcpropdsgnDataSource;
end;

procedure TabcDataFieldProperty.GetValueList(List: TStrings);
var
  Instance: TPersistent;
  PropInfo: PPropInfo;
  DataSource: TDataSource;
begin
  Instance := GetComponent(0);
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo, GetDataSourcePropName);
  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
  begin
    DataSource := TObject(GetOrdProp(Instance, PropInfo)) as TDataSource;
    if (DataSource <> nil) and (DataSource.DataSet <> nil) then
      DataSource.DataSet.GetFieldNames(List);
  end;
end;

{ TabcAutoLabelEditor }

procedure TabcAutoLabelEditor.Edit;
begin
  with Component as TabcAutoLabel do begin
    AutoSize := not AutoSize;
    AutoSize := not AutoSize;
  end;
end;

{$IFDEF DELPHI6}
procedure TabcDBGridEditor.GetColumnsEditor(const Prop: IProperty);
var
  PropName: string;
begin
  if FColumnsEditor = nil then
  begin
    PropName := Prop.GetName;
    if CompareText(PropName, sabcpropdsgnCOLUMNS) = 0 then FColumnsEditor := Prop;
  end;
end;
{$ELSE}
procedure TabcDBGridEditor.GetColumnsEditor(PropertyEditor: TPropertyEditor);
var
  PropName: string;
begin
  if FColumnsEditor = nil then
  begin
    PropName := PropertyEditor.GetName;
    if CompareText(PropName, sabcpropdsgnCOLUMNS) = 0 then FColumnsEditor := PropertyEditor;
  end;
end;
{$ENDIF}

procedure TabcDBGridEditor.ExecuteVerb(Index: Integer);
{returns the TDBGridColumns property editor on the Columns property
 and executes its Edit method}
var
{$IFDEF DELPHI6}
  Components: IDesignerSelections;
{$ELSE}
{$IFDEF DELPHI5}
  Components: TDesignerSelectionList;
{$ELSE}
  Components: TComponentList;
{$ENDIF}
{$ENDIF}
begin
{$IFDEF DELPHI6}
  Components := CreateSelectionList;
{$ELSE}
{$IFDEF DELPHI5}
  Components := TDesignerSelectionList.Create;
{$ELSE}
  Components := TComponentList.Create;
{$ENDIF}
{$ENDIF}
  try
    Components.Add(Component);
    FColumnsEditor := nil;
    GetComponentProperties(Components, [tkClass], Designer, GetColumnsEditor);
    if Assigned(FColumnsEditor) then FColumnsEditor.Edit;
  finally
{$IFDEF DELPHI6}
    Components := nil;
{$ELSE}
    Components.Free;
{$ENDIF}
  end;
end;

function TabcDBGridEditor.GetVerb(Index: Integer): string;
begin
  Result := sabcpropdsgnGridColEditor;
end;

function TabcDBGridEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcnpIndexComboEditor }

procedure TabcnpIndexComboEditor.ExecuteVerb(Index: Integer);
var
  ItemsAdded: Integer;
begin
  ItemsAdded := TabcnpIndexCombo(Component).LoadItemsFromDataSet;
  if ItemsAdded > 0 then begin
    Designer.Modified;
    ShowMessage(Format(sabcdsgnIndexResult, [ItemsAdded]));
  end
  else
    ShowMessage(sabcdsgnErrNoIndex);
end;

function TabcnpIndexComboEditor.GetVerb(Index: Integer): string;
begin
  Result := sabcnpdsgnEdIndexCombo;
end;

function TabcnpIndexComboEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcNavPanelEditor }

procedure TabcNavPanelEditor.ExecuteVerb(Index: Integer);
var
  I: integer;
begin
  if Index = 0 then begin
    if ExecabcdfNavPanelEdit(TWinControl(Component)) then
      Designer.Modified;
  end
  else begin
    {Delete controls}
    if MessageDlg(Format(sabcnpdsgnEdNavPanelDelete, [#13#10]),
                  mtWarning, [mbYes, mbNo], 0) = mrYes then begin
      with TabcNavPanel(Component) do
        for I := ControlCount - 1 downto 0 do
          Controls[I].Free;
      Designer.Modified;
    end;
  end;
end;

function TabcNavPanelEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then
    Result := sabcnpdsgnEdNavPanel0
  else
    Result := sabcnpdsgnEdNavPanel1;
end;

function TabcNavPanelEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

{ TabcNavToolbarEditor }

procedure TabcNavToolbarEditor.ExecuteVerb(Index: Integer);
var
  I: integer;
begin
  if Index = 0 then begin
    if ExecabcdfNavPanelEdit(TWinControl(Component)) then
      Designer.Modified;
  end
  else begin
    {Delete controls}
    if MessageDlg(Format(sabcnpdsgnEdNavPanelDelete, [#13#10]),
                  mtWarning, [mbYes, mbNo], 0) = mrYes then begin
      with TabcNavToolbar(Component) do
        for I := ControlCount - 1 downto 0 do
          Controls[I].Free;
      Designer.Modified;
    end;
  end;
end;

function TabcNavToolbarEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then
    Result := sabcnpdsgnEdNavPanel0
  else
    Result := sabcnpdsgnEdNavPanel1;
end;

function TabcNavToolbarEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

{ TabcnpButtonEditor }

procedure TabcnpButtonEditor.ExecuteVerb(Index: Integer);
begin
  if ExecabcdfNavBtnEdit(TabcCustomPicSpeedBtn(Component)) then
    Designer.Modified;
end;

function TabcnpButtonEditor.GetVerb(Index: Integer): string;
begin
  Result := sabcnpdsgnEdNavButton;
end;

function TabcnpButtonEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcnpFilterExprButtonEditor }

procedure TabcnpFilterExprButtonEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0:
      begin
        TabcnpFilterExpression(Component).Edit;
        Designer.Modified;
      end;
    1:
      if ExecabcdfNavBtnEdit(TabcCustomnpBtn(Component)) then
        Designer.Modified;
  end;
end;

function TabcnpFilterExprButtonEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := sabcnpdsgnEdFilter;
    1: Result := sabcnpdsgnEdNavButton;
  end;
end;

function TabcnpFilterExprButtonEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

{ TabcTrueTypeFontProperty }

const
  hcDFontEditor       = 25000;

procedure TabcTrueTypeFontProperty.Edit;
begin
  with TFontDialog.Create(nil) do
  try
    Font := TFont(GetOrdValue);
    HelpContext := hcDFontEditor;
    Options := Options + [fdShowHelp, fdForceFontExist, fdTrueTypeOnly];
    if Execute then SetOrdValue(Longint(Font));
  finally
    Free;
  end;
end;

{ TabcDBIndexComboEditor }

procedure TabcDBIndexComboEditor.ExecuteVerb(Index: Integer);
var
  ItemsAdded: Integer;
begin
  ItemsAdded := TabcDBIndexCombo(Component).LoadItemsFromDataSet;
  if ItemsAdded > 0 then begin
    Designer.Modified;
    ShowMessage(Format(sabcdsgnIndexResult, [ItemsAdded]));
  end
  else
    ShowMessage(sabcdsgnErrNoIndex);
end;

function TabcDBIndexComboEditor.GetVerb(Index: Integer): string;
begin
  Result := sabcnpdsgnEdIndexCombo;
end;

function TabcDBIndexComboEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcDBFilterCompEditor }

procedure TabcDBFilterCompEditor.ExecuteVerb(Index: Integer);
begin
  TabcDBFilter(Component).Edit(True, False);
  Designer.Modified;
end;

function TabcDBFilterCompEditor.GetVerb(Index: Integer): string;
begin
  Result := sabcnpdsgnEdFilter;
end;

function TabcDBFilterCompEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcWaveImageProperty - Property Editor for TabcWaveImage }

procedure TabcWaveImageProperty.Edit;
var
  WaveImage: TabcWaveImage;
begin
  WaveImage := TabcWaveImage(GetOrdValue);
  if ExecabcdfWaveEdit(WaveImage) then
    Designer.Modified;
end;

function TabcWaveImageProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcWaveListImagesProperty - Property Editor for stringlist of TabcWaveImage }

procedure TabcWaveListImagesProperty.Edit;
var
  Sounds: TStringList;
begin
  Sounds := TStringList(GetOrdValue);
  if ExecabcdfWaveListEdit(Sounds) then
    Designer.Modified;
end;

function TabcWaveListImagesProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcWaveFileProperty - Property Editor for a Wave filename }

procedure TabcWaveFileProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
  try
    DefaultExt := sabcpropdsgnWavExt;
    Filename := GetValue;
    Filter := sabcpropdsgnWavFiles;
    HelpContext := 0;
    Options := Options + [ofFileMustExist, ofHideReadOnly];
    Title := sabcpropdsgnSelectWaveFile;
    if Execute then begin
      SetValue(Filename);
      Designer.Modified;
    end;
  finally
    Free;
  end;
end;

function TabcWaveFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcComponentExceptSelfProperty }

procedure TabcComponentExceptSelfProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  ThisComp, AComp: TComponent;
  PropClass: TClass;
  Par: TWinControl;

  function IsSelected(AComponent: TComponent): Boolean;
  var
    J: integer;
  CheckComp: TPersistent;
  begin
    Result := False;
    for J := 0 to Designer.GetRoot.ComponentCount - 1 do begin
      CheckComp := GetComponent(J);
      if (CheckComp = AComponent) then begin
        Result := True;
        Break;
      end
      else if CheckComp = nil then Break;
    end;
  end;

begin
  PropClass := GetTypeData(GetPropType)^.ClassType;
  ThisComp := TComponent(GetComponent(0));
  Par := abcParentFormorFrameOf(ThisComp);
  if Par = nil then Exit;
  for I := 0 to Par.ComponentCount - 1 do
  begin
    AComp := Par.Components[I];
    if (AComp is PropClass) and (AComp.Name <> '') and
      not IsSelected(AComp) then
      if Par is TForm then
        Proc(AComp.Name)
      else
        Proc(Par.Name + '.' + AComp.Name);
  end;
end;

{ TabcMCIDataProperty - Property Editor for TabcMCIStreamPlayer.MCIData Property }

procedure TabcMCIDataProperty.Edit;
var
  MCIStreamPlayer: TabcMCIStreamPlayer;
begin
  MCIStreamPlayer := TabcMCIStreamPlayer(GetComponent(0));
  if ExecabcdfMCIStreamEdit(MCIStreamPlayer) then
    Designer.Modified;
end;

function TabcMCIDataProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcLineCompEditor }

procedure TabcLineCompEditor.ExecuteVerb(Index: Integer);
begin
  if ExecabcdfLineEdit(TabcLine(Component)) then Designer.Modified;
end;

function TabcLineCompEditor.GetVerb(Index: Integer): string;
begin
  Result := sabcdsgnEdLine;
end;

function TabcLineCompEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcIniFilenameProperty }

procedure TabcIniFilenameProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
  try
    Filename := GetValue;
    Filter := sabcpropdsgnIniFileFltr;
    Options := Options + [ofPathMustExist, ofFileMustExist];
    if Execute then SetValue(Filename);
  finally
    Free;
  end;
end;

function TabcIniFilenameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcSplitBarWindowAProperty }

procedure TabcSplitBarWindowAProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  SplitBar: TabcSplitBar;
begin
  SplitBar := TabcSplitBar(GetComponent(0));
  with SplitBar.Parent do
    for I := 0 to ControlCount - 1 do
      if (Controls[I] is TWinControl) and
         (Controls[I] <> SplitBar) and
         (Controls[I] <> SplitBar.WindowB) then
        Proc(Controls[I].Name);
end;

{ TabcSplitBarWindowBProperty }

procedure TabcSplitBarWindowBProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  SplitBar: TabcSplitBar;
begin
  SplitBar := TabcSplitBar(GetComponent(0));
  with SplitBar.Parent do
    for I := 0 to ControlCount - 1 do
      if (Controls[I] is TWinControl) and
         (Controls[I] <> SplitBar) and
         (Controls[I] <> SplitBar.WindowA) then
        Proc(Controls[I].Name);
end;

{ TabcSplitPaneEditor }

type
  TSplitAccess = class(TabcCustomSplit);
  TWinAccess = class(TWinControl);

procedure TabcSplitPaneEditor.ExecuteVerb(Index: Integer);
var
  Splitter: TabcCustomSplit;
  i , tmpIndex: Integer;
begin
{$IFDEF DELPHI5}
  if not IsInInlined then
    tmpIndex := Index
  else
    tmpIndex := Index + 1;
{$ELSE}
    tmpIndex := Index;
{$ENDIF}
  if Component is TabcCustomSplit then
    Splitter := TabcCustomSplit(Component)
  else
    Splitter := TabcCustomSplit(TWinControl(Component).Parent);
  case tmpIndex of
    0: with Splitter do
       begin
        CreatePanes;
        for i := 0 to PaneCount - 1 do
          with Pane[i] do
            if Name = '' then
              Name := Designer.UniqueName(ClassName);
       end;
    1: Splitter.Rotate(True);
    2: abcExecPaneExchangeDialog(Splitter);
    3: Splitter.ResizePanes;
    4: with Splitter do
         if SplitHLock and SplitVLock then
         begin
           SplitHLock := False;
           SplitVLock := False;
         end
         else
         begin
           SplitHLock := True;
           SplitVLock := True;
         end;
    5:
      with TSplitAccess(Splitter) do
      begin
        BorderStyle := bsNone;
        BorderWidth := 0;
        BevelInner := bvNone;
        BevelOuter := bvNone;
        SplitBevel := bvNone;
        for i := 0 to PaneCount - 1 do
          with TWinAccess(Pane[i]) do
          begin
            BevelEdges := [beLeft, beTop, beRight, beBottom];
            BevelInner := bvNone;
            BevelKind := bkSoft;
            BevelOuter := bvLowered;
          end;
      end;
  end;
  Designer.Modified;
end;

function TabcSplitPaneEditor.GetVerb(Index: Integer): string;
var
  Splitter: TabcCustomSplit;
  tmpIndex: Integer;
begin
{$IFDEF DELPHI5}
  if not IsInInlined then
    tmpIndex := Index
  else
    tmpIndex := Index + 1;
{$ELSE}
    tmpIndex := Index;
{$ENDIF}
  case tmpIndex of
    0: Result := sabcpropdsgnCreatePanes;
    1: Result := sabcpropdsgnRotatePanes;
    2: Result := sabcpropdsgnExchangePanes;
    3: Result := sabcpropdsgnAlignPanes;
    4:
      begin
        if Component is TabcCustomSplit then
          Splitter := TabcCustomSplit(Component)
        else
          Splitter := TabcCustomSplit(TWinControl(Component).Parent);
        with Splitter do
          if SplitHLock and SplitVLock then
            Result := sabcpropdsgnUnlockSplitBar
          else
            Result := sabcpropdsgnLockSplitBar;
      end;
    5: Result := sabcpropdsgnFlatten;
  end;
end;

function TabcSplitPaneEditor.GetVerbCount: Integer;
begin
{$IFDEF DELPHI5}
  if not IsInInlined then
    Result := 6
  else
    Result := 5;
{$ELSE}
    Result := 6;
{$ENDIF}
end;

{ TabcReadOnlyProperty }

procedure TabcReadOnlyProperty.Edit;
begin
  MessageDlg('Property is read only.', mtInformation, [mbOk], 0);
end;

function TabcReadOnlyProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paReadOnly];
end;

{ TabcFileNameProperty }

procedure TabcFileNameProperty.AfterExecute;
begin
  SetValue(FFileName);
end;

procedure TabcFileNameProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
    try
      Filename := GetDefaultFileName;
      Title := GetTitle;
      Filter := GetFilter;
      HelpContext := GetHelpContext;
      if HelpContext = 0 then
        Options := Options + [ofPathMustExist, ofFileMustExist]
      else
        Options := Options + [ofShowHelp, ofPathMustExist, ofFileMustExist];
      if Execute then
      begin
        FFileName := FileName;
        AfterExecute;
      end;
    finally
      Free;
    end;
end;

function TabcFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

function TabcFileNameProperty.GetTitle: string;
begin
  Result := 'Open File';
end;

function TabcFileNameProperty.GetDefaultFileName: string;
begin
  Result := GetValue;
end;

function TabcFileNameProperty.GetFilter: string;
begin
  Result := 'All Files (*.*)|*.*';
end;

function TabcFileNameProperty.GetHelpContext: THelpContext;
begin
  Result := 0;
end;

{ TabcPersistentMemoryProperty }

function TabcPersistentMemoryProperty.GetValue: string;
begin
  if TabcPersistentMemory(GetOrdValue).Empty then
    Result := '(Empty)'
  else
    Result := inherited GetValue;
end;

procedure TabcPersistentMemoryProperty.AfterExecute;
var
  ThisData: TabcPersistentMemory;
begin
  ThisData := TabcPersistentMemory(GetOrdValue);
  ThisData.LoadFromFile(FFileName);
  Designer.Modified;
end;

function TabcPersistentMemoryProperty.GetTitle: string;
begin
  Result := 'Load File';
end;

function TabcPersistentMemoryProperty.GetDefaultFileName: string;
begin
  Result := '';
end;

function TabcPersistentMemoryProperty.GetFilter: string;
begin
  Result := 'All Files (*.*)|*.*';
end;

procedure TabcPersistentMemoryProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
    try
      Filename := GetDefaultFileName;
      Title := GetTitle;
      Filter := GetFilter;
      HelpContext := GetHelpContext;
      if HelpContext = 0 then
        Options := Options + [ofPathMustExist, ofFileMustExist]
      else
        Options := Options + [ofShowHelp, ofPathMustExist, ofFileMustExist];
      if Execute then
      begin
        FFileName := FileName;
        AfterExecute;
      end;
    finally
      Free;
    end;
end;

function TabcPersistentMemoryProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

function TabcPersistentMemoryProperty.GetHelpContext: THelpContext;
begin
  Result := 0;
end;

{ TabcResTypeStringProperty }

function TabcResTypeStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect, paRevertable];
end;

procedure TabcResTypeStringProperty.GetValues(Proc: TGetStrProc);
var
  tmpList: TStringList;
  i: integer;
begin
  tmpList := TStringList.Create;
  try
    abcParseStringToList(sabcpropResTypes, ',', tmpList, True);
    for i := 0 to tmpList.Count - 1 do
      Proc(tmpList[i]);
  finally
    tmpList.Free;
  end;
end;

{ TabcNotebookFormNameProperty }

function TabcNotebookFormNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TabcNotebookFormNameProperty.GetValues(Proc: TGetStrProc);
var
  i: Integer;
begin
  with GetComponent(0) as TabcFormNotebook do
  for i := 0 to Forms.Count - 1 do
  begin
    Proc(Forms[i]);
  end;
end;

function TabcNotebookFormNameProperty.GetValue: string;
begin
  Result := GetStrValue;
end;

procedure TabcNotebookFormNameProperty.SetValue(const AValue: string);
begin
  SetStrValue(AValue);
end;

{ TabcTabbedNotebookFormNameProperty }

function TabcTabbedNotebookFormNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TabcTabbedNotebookFormNameProperty.GetValues(Proc: TGetStrProc);
var
  i: Integer;
begin
  with GetComponent(0) as TabcFormTabbedNotebook do
  for i := 0 to Forms.Count - 1 do
  begin
    Proc(Forms[i]);
  end;
end;

function TabcTabbedNotebookFormNameProperty.GetValue: string;
begin
  Result := GetStrValue;
end;

procedure TabcTabbedNotebookFormNameProperty.SetValue(const AValue: string);
begin
  SetStrValue(AValue);
end;

{ TabcShellVerbProperty }

function TabcShellVerbProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TabcShellVerbProperty.GetValues(Proc: TGetStrProc);
const
  COMMON_VERBS: array[0..5] of string =
   ('open', 'print', 'edit', 'play', 'properties', 'find');
var
  i: Integer;
begin
  for i := Low(COMMON_VERBS) to High(COMMON_VERBS) do
  begin
    Proc(COMMON_VERBS[i]);
  end;
end;

function TabcShellVerbProperty.GetValue: string;
begin
  Result := GetStrValue;
end;

procedure TabcShellVerbProperty.SetValue(const AValue: string);
begin
  SetStrValue(AValue);
end;

{ TabcnpFilterStringProperty - Property Editor for TabcnpFilterExpression.Filter}

procedure TabcnpFilterStringProperty.Edit;
begin
  TabcnpFilterExpression(GetComponent(0)).Edit;
end;

function TabcnpFilterStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{ TabcTrayIconPopupMenuProperty - property editor for TabcTrayIcon.PopupMenu }

procedure TabcTrayIconPopupMenuProperty.SetValue(const Value: string);
var
  Component: TComponent;
begin
  if Value = '' then Component := nil else
  begin
    Component := Designer.GetComponent(Value);
    if not (Component is GetTypeData(GetPropType)^.ClassType) then
      raise EPropertyError.Create(SInvalidPropertyValue);
  end;
  SetOrdValue(Longint(Component));
  if Component is TabcPopupMenu then
    TabcPopupMenu(Component).TrayIconMenu := True;
end;

initialization
  abcapp.abcDesigning := True;

end.
