unit abcpropb;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

This file contains property editors for BDE components only

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

{$IFDEF VER150}
uses Classes, Contnrs, DesignIntf, DesignEditors, VCLeditors, SysUtils, Graphics, bdeconst, Dbxplor, colnedit,
     GqeDelph, Dsndbcst, DBConsts, DB, DBTables, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbexc, abcdbctl, abcdbgrd, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcdfexq, abcsplit, abcsubfm, abcprop, ExptIntf, abcdbacc;
{$ENDIF}

{$IFDEF VER140}
uses Classes, Contnrs, DesignIntf, DesignEditors, VCLeditors, SysUtils, Graphics, bdeconst, Dbxplor, colnedit,
     GqeDelph, Dsndbcst, DBConsts, DB, DBTables, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbexc, abcdbctl, abcdbgrd, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcdfexq, abcsplit, abcsubfm, abcprop, ExptIntf, abcdbacc;
{$ENDIF}

{$IFDEF VER130}
uses Classes, Contnrs, DsgnIntf, SysUtils, Graphics, bdeconst, Dbxplor, colnedit,
     GqeDelph, Dsndbcst, DBConsts, DB, DBTables, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbexc, abcdbctl, abcdbgrd, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcdfexq, abcsplit, abcsubfm, abcprop, ExptIntf, abcdbacc;
{$ENDIF}

{$IFDEF VER125}
uses Classes, DsgnIntf, SysUtils, Graphics, bdeconst, {Dbxplor,} colnedit,
     {GqeDelph,} DBConsts, DB, DBTables, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbexc, abcdbctl, abcdbgrd, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcdfexq, abcsplit, abcsubfm, abcprop, ExptIntf, abcdbacc;
{$ENDIF}
{$IFDEF VER120}
uses Classes, DsgnIntf, SysUtils, Graphics, bdeconst, Dbxplor, colnedit,
     GqeDelph, DBConsts, DB, DBTables, TypInfo, Forms, Dialogs, Controls,
     abcexcep, abcdbexc, abcdbctl, abcdbgrd, abcexctl, abcbtn, abcutil, abcwtch,
     abcdfstr, abcdfcol,
     abcnp, abcnpbtn, abcnpflt, abcdfnav, abcdfnpb, abcutilf, abcidcbo,
     abcfiltr, abcwav, abcdfwav, abcdfwvl, abcmem, abcmm, abcdfmm, abcshape,
     abcdflin, abcdfexq, abcsplit, abcsubfm, abcprop, ExptIntf, abcdbacc;
{$ENDIF}

type

{ TabcAppExcDBStringProperty }

  TabcAppExcDBStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual; abstract;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

{ TabcAppExcSessionNameProperty  for published property SessionName }

  TabcAppExcSessionNameProperty = class(TabcAppExcDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcAppExcDatabaseNameProperty  for published property DatabaseName }

  TabcAppExcDatabaseNameProperty = class(TabcAppExcDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcMsgTableNameProperty  for published property MsgTableName }

  TabcMsgTableNameProperty = class(TabcAppExcDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcLogTableNameProperty  for published property LogTableName }

  TabcLogTableNameProperty = class(TabcAppExcDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcDBAppExceptionEditor }

  TabcDBAppExceptionEditor = class(TComponentEditor)
  public
    procedure CreateTables(EditComp: TComponent); virtual;
    procedure AutoCreateDBase(LogTable, MsgTable: TTable); virtual;
    procedure AutoCreateParadox(LogTable, MsgTable: TTable); virtual;
    procedure AutoCreateSQL(LogTable, MsgTable: TTable); virtual;
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

{ TabcDBQryAppExceptionEditor }

  TabcDBQryAppExceptionEditor = class(TabcDBAppExceptionEditor)
  public
    procedure CreateTables(EditComp: TComponent); override;
  end;

{ Property Editors for Query & Table Properties }
{ TabcActiveProperty for published property A3Active }

  TabcActiveProperty = class(TEnumProperty)
  public
    function GetName: string; override;
  end;

{ TabcDatabaseNameProperty  for published property A1DatabaseName }

  TabcDatabaseNameProperty = class(TabcDBStringProperty)
  public
    function GetName: string; override;
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcQueryParamsProperty }

  TabcQueryParamsProperty = TCollectionProperty;

{ TQuerySQLProperty for published property A2SQL }

  TabcQuerySQLProperty = class(TabcStringListProperty)
  public
    function GetName: string; override;
  end;

{Property Editors for Table Properties}

{ TabcTableNameProperty  for published property A2TableName }

  TabcTableNameProperty = class(TabcDBStringProperty)
  public
    function GetName: string; override;
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcIndexNameProperty }

  TabcIndexNameProperty = class(TabcDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcIndexFieldNamesProperty }

  TabcIndexFieldNamesProperty = class(TabcDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TabcDBQueryGridEditor }

  TabcDBQueryGridEditor = class(TComponentEditor)
  private
{$IFDEF DELPHI7}
    FParamsEditor: IProperty;
    procedure GetParamsEditor(const Prop: IProperty);
{$ELSE}
    FParamsEditor: TPropertyEditor;
    procedure GetParamsEditor(PropertyEditor: TPropertyEditor);
{$ENDIF}
    procedure ExecSubComponentEditor(ASubComponent: TComponent);
    procedure ExecQueryParamsEditor(Query: TQuery);
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

{ TabcDBTableGridEditor }

  TabcDBTableGridEditor = class(TComponentEditor)
  private
    procedure ExecSubComponentEditor(ASubComponent: TComponent);
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

function abcGetToolServicesProjectName: string;

implementation

uses abcutild, abcdfspl, abcdsncn;

{ TabcDBStringProperty }

function TabcAppExcDBStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TabcAppExcDBStringProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

{ TabcAppExcSessionNameProperty  for published property SessionName }

procedure TabcAppExcSessionNameProperty.GetValueList(List: TStrings);
begin
  Sessions.GetSessionNames(List);
end;

{ TabcAppExcDatabaseNameProperty  for published property DatabaseName }

procedure TabcAppExcDatabaseNameProperty.GetValueList(List: TStrings);
var
  Sess: TSession;
begin
  if GetComponent(0) is TabcDBAppException then
    Sess := (GetComponent(0) as TabcDBAppException).MsgTable.DBSession
  else if GetComponent(0) is TabcDBQryAppException then
    Sess := (GetComponent(0) as TabcDBQryAppException).MsgQuery.DBSession
  else
    Sess := nil;
  if Sess <> nil then Sess.GetDatabaseNames(List);
end;

{ TabcMsgTableNameProperty  for published property MsgTableName }

procedure TabcMsgTableNameProperty.GetValueList(List: TStrings);
var
  Table: TTable;
begin
  Table := (GetComponent(0) as TabcDBAppException).MsgTable;
  Table.DBSession.GetTableNames(Table.DatabaseName, abcGetTableTypeMask(Ord(Table.TableType)),
    Table.TableType = ttDefault, False, List);
end;

{ TabcLogTableNameProperty  for published property LogTableName }

procedure TabcLogTableNameProperty.GetValueList(List: TStrings);
var
  Table: TTable;
begin
  Table := (GetComponent(0) as TabcDBAppException).LogTable;
  Table.DBSession.GetTableNames(Table.DatabaseName, abcGetTableTypeMask(Ord(Table.TableType)),
    Table.TableType = ttDefault, False, List);
end;

{ TabcDBAppExceptionEditor }

procedure TabcDBAppExceptionEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: CreateTables(Component);
  end;
end;

procedure TabcDBAppExceptionEditor.CreateTables(EditComp: TComponent);
var
  DBAppExcep: TabcDBAppException;
  LogTable, MsgTable: TTable;
begin
  DBAppExcep := TabcDBAppException(EditComp);
  with DBAppExcep do
    if (DatabaseName = '') or (LogTableName = '') or (MsgTableName = '') then begin
      ShowMessage(sabcpropdsgnDBAppExcMsg);
      Exit;
    end;
  if MessageDlg(sabcpropdsgnDBAppExcOverwrite + #13#10#13#10 +
    sabcpropdsgnDBAppExcConfirm,
    mtWarning, [mbYes, mbNo], 0) = mrNo then Exit;
  LogTable := TTable.Create(nil);
  MsgTable := TTable.Create(nil);
  try
    try
      LogTable.SessionName := DBAppExcep.SessionName;
      LogTable.DatabaseName := DBAppExcep.DatabaseName;
      LogTable.TableName := DBAppExcep.LogTableName;
      LogTable.FieldDefs.Clear;
      LogTable.IndexDefs.Clear;
      MsgTable.SessionName := DBAppExcep.SessionName;
      MsgTable.DatabaseName := DBAppExcep.DatabaseName;
      MsgTable.TableName := DBAppExcep.MsgTableName;
      MsgTable.FieldDefs.Clear;
      MsgTable.IndexDefs.Clear;
      case DBAppExcep.TableType of
        etDBase: AutoCreateDBase(LogTable, MsgTable);
        etParadox: AutoCreateParadox(LogTable, MsgTable);
        etSQL: AutoCreateSQL(LogTable, MsgTable);
      end;
      ShowMessage(sabcpropdsgnDBAppExcTables);
      LogTable.Close;
      MsgTable.Close;
    except
      on E:Exception do ShowMessage(sabcpropdsgnDBAppExcTablesErr + E.Message);
    end;
  finally
    LogTable.Free;
    MsgTable.Free;
  end;
end;

procedure TabcDBAppExceptionEditor.AutoCreateDBase(LogTable, MsgTable: TTable);
{Note: Strings of 255 characters will be truncated to 254 chars by DBase}
{DBase only supports strings up to 254 chars, without using memo fields}
{DateTime fields as stored as Char(30) by DBase}
{Field and Index Names are restricted to 10 characters by DBase}
begin
  with LogTable do begin
    TableType := ttDBase;
    FieldDefs.Add(sabcpropdsgnERR_TIME,ftDateTime,0,True);
    FieldDefs.Add(sabcpropdsgnUSER_NAME,ftString,254,False);
    FieldDefs.Add(sabcpropdsgnERR_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnERR_MSG,ftString,254,False);
    FieldDefs.Add(sabcpropdsgnEXE_NAME,ftString,254,False);
    FieldDefs.Add(sabcpropdsgnAPP_NAME,ftString,254,False);
    FieldDefs.Add(sabcpropdsgnSNDR_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnSNDR_NAME,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnERR_ADDR,ftString,9,False);
    FieldDefs.Add(sabcpropdsgnSYS_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnSYS_MSG,ftString,254,False);
    FieldDefs.Add(sabcpropdsgnSYS_ADDR,ftString,9,False);
    IndexDefs.Add(sabcpropdsgnPRIMARYKEY,sabcpropdsgnERR_TIME,[ixUnique]);
    CreateTable;
    ShowMessage(sabcpropdsgnLogCreated);
  end;
  with MsgTable do begin
    TableType := ttDBase;
    FieldDefs.Add(sabcpropdsgnERR_CLASS,ftString,63,True);
    FieldDefs.Add(sabcpropdsgnMSG_TYPE,ftSmallint,0,True);
    FieldDefs.Add(sabcpropdsgnLOG,ftBoolean,0,True);
    FieldDefs.Add(sabcpropdsgnTERMINATE,ftBoolean,0,True);
    FieldDefs.Add(sabcpropdsgnERR_MSG,ftMemo,240,True);
    IndexDefs.Add(sabcpropdsgnPRIMARYKEY,sabcpropdsgnERR_CLASS,[ixUnique]);
    CreateTable;
    ShowMessage(sabcpropdsgnMsgCreated);
  end;
end;

procedure TabcDBAppExceptionEditor.AutoCreateParadox(LogTable, MsgTable: TTable);
begin
  with LogTable do begin
    TableType := ttParadox;
    FieldDefs.Add(sabcpropdsgnERR_TIME,ftDateTime,0,True);
    FieldDefs.Add(sabcpropdsgnUSER_NAME,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnERR_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnERR_MSG,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnEXE_NAME,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnAPP_NAME,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnSNDR_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnSNDR_NAME,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnERR_ADDR,ftString,9,False);
    FieldDefs.Add(sabcpropdsgnSYS_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnSYS_MSG,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnSYS_ADDR,ftString,9,False);
    IndexDefs.Add(sabcpropdsgnPRIMARYKEY,sabcpropdsgnERR_TIME,[ixPrimary, ixUnique]);
    CreateTable;
    ShowMessage(sabcpropdsgnLogCreated);
  end;
  with MsgTable do begin
    TableType := ttParadox;
    FieldDefs.Add(sabcpropdsgnERR_CLASS,ftString,63,True);
    FieldDefs.Add(sabcpropdsgnMSG_TYPE,ftSmallint,0,True);
    FieldDefs.Add(sabcpropdsgnLOG,ftBoolean,0,True);
    FieldDefs.Add(sabcpropdsgnTERMINATE,ftBoolean,0,True);
    FieldDefs.Add(sabcpropdsgnERR_MSG,ftMemo,240,True);
    IndexDefs.Add(sabcpropdsgnPRIMARYKEY,sabcpropdsgnERR_CLASS,[ixPrimary, ixUnique]);
    CreateTable;
    ShowMessage(sabcpropdsgnMsgCreated);
  end;
end;

procedure TabcDBAppExceptionEditor.AutoCreateSQL(LogTable, MsgTable: TTable);
{Note: InterBase does not support use of [ixPrimary] in IndexDefs}
{Other SQL servers may also have some limitations here}
{Data type conversion issues are minimised by using Delphi FieldTypes
 as a base and using BDE to do the data type mapping to the database}
{Msg & Log Table primary keys are added after the table creation using an
 SQL query to execute ALTER TABLE}
{Note: Log table fields are set to NOT NULL on some servers, ignoring the False
 option on the table field Add}
var
  AlterQuery: TQuery;
begin
  with LogTable do begin
    TableType := ttDefault;
    FieldDefs.Add(sabcpropdsgnERR_TIME,ftDateTime,0,True);
    FieldDefs.Add(sabcpropdsgnUSER_NAME,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnERR_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnERR_MSG,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnEXE_NAME,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnAPP_NAME,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnSNDR_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnSNDR_NAME,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnERR_ADDR,ftString,9,False);
    FieldDefs.Add(sabcpropdsgnSYS_CLASS,ftString,63,False);
    FieldDefs.Add(sabcpropdsgnSYS_MSG,ftString,255,False);
    FieldDefs.Add(sabcpropdsgnSYS_ADDR,ftString,9,False);
    CreateTable;
    Close;
    ShowMessage(sabcpropdsgnLogCreated);
  end;
  with MsgTable do begin
    TableType := ttDefault;
    FieldDefs.Add(sabcpropdsgnERR_CLASS,ftString,63,True);
    FieldDefs.Add(sabcpropdsgnMSG_TYPE,ftSmallint,0,True);
    FieldDefs.Add(sabcpropdsgnLOG,ftBoolean,0,True);
    FieldDefs.Add(sabcpropdsgnTERMINATE,ftBoolean,0,True);
    FieldDefs.Add(sabcpropdsgnERR_MSG,ftMemo,240,True);
    CreateTable;
    Close;
    ShowMessage(sabcpropdsgnMsgCreated);
  end;
  AlterQuery := TQuery.Create(nil);
  AlterQuery.SessionName := MsgTable.SessionName;
  AlterQuery.DatabaseName := MsgTable.DatabaseName;
  try
    with AlterQuery do begin
      SQL.Add(sabcpropdsgnAlterTable + LogTable.TableName);
      SQL.Add(sabcpropdsgnAddKey1);
      ExecSQL;
      ShowMessage(sabcpropdsgnKey1Added);
      SQL.Clear;
      SQL.Add(sabcpropdsgnAlterTable + MsgTable.TableName);
      SQL.Add(sabcpropdsgnAddKey2);
      ExecSQL;
      ShowMessage(sabcpropdsgnKey2Added);
    end;
  finally
    AlterQuery.Free;
  end;
end;

function TabcDBAppExceptionEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := sabcpropdsgnCreateTables;
  end;
end;

function TabcDBAppExceptionEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ TabcDBQryAppExceptionEditor }

procedure TabcDBQryAppExceptionEditor.CreateTables(EditComp: TComponent);
var
  DBQryAppExcep: TabcDBQryAppException;
  LogTableName, MsgTableName: TFileName;
  LogTable, MsgTable: TTable;
  FileExt, OldLogSQL, OldMsgSQL, ReplaceStr: string;
begin
  DBQryAppExcep := TabcDBQryAppException(EditComp);
  if DBQryAppExcep.DatabaseName = '' then begin
    ShowMessage(sabcpropdsgnDBNameReqd);
    Exit;
  end;
  with TabcdfAppExcepQry.Create(nil) do
  try
    if ShowModal = mrOK then
    begin
      LogTableName := edLog.Text;
      MsgTableName := edMsg.Text;
    end
    else
      Exit;
  finally
    Free;
  end;

  if MessageDlg(sabcpropdsgnDBAppExcOverwrite + #13#10#13#10 +
    sabcpropdsgnDBAppExcConfirm,
    mtWarning, [mbYes, mbNo], 0) = mrNo then Exit;

  LogTable := TTable.Create(nil);
  MsgTable := TTable.Create(nil);
  try
    try
      LogTable.SessionName := DBQryAppExcep.SessionName;
      LogTable.DatabaseName := DBQryAppExcep.DatabaseName;
      LogTable.TableName := LogTableName;
      LogTable.FieldDefs.Clear;
      LogTable.IndexDefs.Clear;
      MsgTable.SessionName := DBQryAppExcep.SessionName;
      MsgTable.DatabaseName := DBQryAppExcep.DatabaseName;
      MsgTable.TableName := MsgTableName;
      MsgTable.FieldDefs.Clear;
      MsgTable.IndexDefs.Clear;
      {determine table types from table names}
      FileExt := ExtractFileExt(UpperCase(LogTableName));
      if FileExt = sabcpropdsgnDBFExt then
        AutoCreateDBase(LogTable, MsgTable)
      else if FileExt = sabcpropdsgnDBExt then
        AutoCreateParadox(LogTable, MsgTable)
      else
        AutoCreateSQL(LogTable, MsgTable);
      ShowMessage(sabcpropdsgnDBAppExcTables);
      LogTable.Close;
      MsgTable.Close;
      {replace table names in SQL}
      with DBQryAppExcep do begin
        OldLogSQL := LogSQL.Strings[0];
        if FileExt = '' then
          ReplaceStr := LogTableName
        else
          ReplaceStr := #34 + LogTableName + #34;
        LogSQL.Strings[0] := abcReplaceStr(sabcpropdsgnERRLOG, ReplaceStr, OldLogSQL, True);
        OldMsgSQL := MsgSQL.Strings[0];
        if FileExt = '' then
          ReplaceStr := MsgTableName
        else
          ReplaceStr := #34 + MsgTableName + #34;
        MsgSQL.Strings[0] := abcReplaceStr(sabcpropdsgnERRMSG, ReplaceStr, OldMsgSQL, True);
      end;
    except
      on E:Exception do ShowMessage(sabcpropdsgnDBAppExcTablesErr + E.Message);
    end;
  finally
    LogTable.Free;
    MsgTable.Free;
  end;
end;

{Property Editors for Query & Table Properties}

{ TabcActiveProperty for published property A3Active }

function TabcActiveProperty.GetName: string;
begin
  Result := sabcpropdsgnActive;
end;

{ TabcDatabaseNameProperty  for published property A1DatabaseName }

function TabcDatabaseNameProperty.GetName: string;
begin
  Result := sabcpropdsgnDatabaseName;
end;

procedure TabcDatabaseNameProperty.GetValueList(List: TStrings);
begin
  Session.GetDatabaseNames(List);
end;

{ TabcQuerySQLProperty for published property A2SQL }

function TabcQuerySQLProperty.GetName: string;
begin
  Result := sabcpropdsgnSQL;
end;

{Property Editors for Table Properties}

{ TabcTableNameProperty  for published property A2TableName }

function TabcTableNameProperty.GetName: string;
begin
  Result := sabcpropdsgnTableName;
end;

procedure TabcTableNameProperty.GetValueList(List: TStrings);
var
  Table: TTable;
begin
  Table := TabcDBTableGrid(GetComponent(0)).Table;
  Session.GetTableNames(Table.DatabaseName, abcGetTableTypeMask(Ord(Table.TableType)),
    Table.TableType = ttDefault, False, List);
end;

{ TabcIndexNameProperty }

procedure TabcIndexNameProperty.GetValueList(List: TStrings);
begin
  TabcDBTableGrid(GetComponent(0)).Table.GetIndexNames(List);
end;

{ TabcIndexFieldNamesProperty }

procedure TabcIndexFieldNamesProperty.GetValueList(List: TStrings);
var
  I: Integer;
begin
  with TabcDBTableGrid(GetComponent(0)).Table do
  begin
    IndexDefs.Update;
    for I := 0 to IndexDefs.Count - 1 do
      with IndexDefs[I] do
        if not (ixExpression in Options) then List.Add(Fields);
  end;
end;

{ TabcDBQueryGridEditor }

{$IFDEF VER150} {TabcDBQueryGridEditor - Delphi 7}
procedure TabcDBQueryGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: IComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBQueryGridEditor.GetParamsEditor(const Prop: IProperty);
var
  PropName: string;
begin
  if FParamsEditor = nil then
  begin
    PropName := Prop.GetName;
    if CompareText(PropName, sabcpropdsgnPARAMS) = 0 then FParamsEditor := Prop;
  end;
end;

procedure TabcDBQueryGridEditor.ExecQueryParamsEditor(Query: TQuery);
{calls the Params property editor of the query
 and executes its Edit method}
var
  Components: IDesignerSelections;
begin
  Components := CreateSelectionList;
  try
    Components.Add(Query);
    FParamsEditor := nil;
    GetComponentProperties(Components, [tkClass], Designer, GetParamsEditor);
  finally
    Components := nil;
  end;
  if Assigned(FParamsEditor) then FParamsEditor.Edit;
end;

procedure TabcDBQueryGridEditor.ExecuteVerb(Index: Integer);
var
  Query: TQuery;
begin
  Query := TabcDBQueryGrid(Component).Query;
  case Index of
    0: ExecSubComponentEditor(TabcDBQueryGrid(Component).Grid);
    1: ExecSubComponentEditor(Query);
    2: ExecQueryParamsEditor(Query);
    3:
      begin
        ExploreDataset(Query);
        if Designer <> nil then Designer.Modified;
      end;
    4: begin
        BuildQuery(Query);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBQueryGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SBindVerb;
    3: Result := SExplore;
    4: Result := SGQEVerb;
  end;
end;

function TabcDBQueryGridEditor.GetVerbCount: Integer;
begin
  if not GQELoadAttempted then LoadGQE;
  if GQELoaded then
    Result := 5
  else
    Result := 4;
end;
{$ENDIF} {TabcDBQueryGridEditor - Delphi 7}

{$IFDEF VER140} {TabcDBQueryGridEditor - Delphi 6}
procedure TabcDBQueryGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: IComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBQueryGridEditor.GetParamsEditor(const Prop: IProperty);
var
  PropName: string;
begin
  if FParamsEditor = nil then
  begin
    PropName := Prop.GetName;
    if CompareText(PropName, sabcpropdsgnPARAMS) = 0 then FParamsEditor := Prop;
  end;
end;

procedure TabcDBQueryGridEditor.ExecQueryParamsEditor(Query: TQuery);
{calls the Params property editor of the query
 and executes its Edit method}
var
  Components: IDesignerSelections;
begin
  Components := CreateSelectionList;
  try
    Components.Add(Query);
    FParamsEditor := nil;
    GetComponentProperties(Components, [tkClass], Designer, GetParamsEditor);
  finally
    Components := nil;
  end;
  if Assigned(FParamsEditor) then FParamsEditor.Edit;
end;

procedure TabcDBQueryGridEditor.ExecuteVerb(Index: Integer);
var
  Query: TQuery;
begin
  Query := TabcDBQueryGrid(Component).Query;
  case Index of
    0: ExecSubComponentEditor(TabcDBQueryGrid(Component).Grid);
    1: ExecSubComponentEditor(Query);
    2: ExecQueryParamsEditor(Query);
    3:
      begin
        ExploreDataset(Query);
        if Designer <> nil then Designer.Modified;
      end;
    4: begin
        BuildQuery(Query);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBQueryGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SBindVerb;
    3: Result := SExplore;
    4: Result := SGQEVerb;
  end;
end;

function TabcDBQueryGridEditor.GetVerbCount: Integer;
begin
  if not GQELoadAttempted then LoadGQE;
  if GQELoaded then
    Result := 5
  else
    Result := 4;
end;
{$ENDIF} {TabcDBQueryGridEditor - Delphi 6}

{$IFDEF VER130} {TabcDBQueryGridEditor - Delphi 5}
procedure TabcDBQueryGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: TComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBQueryGridEditor.GetParamsEditor(PropertyEditor: TPropertyEditor);
var
  PropName: string;
begin
  if FParamsEditor = nil then
  begin
    PropName := PropertyEditor.GetName;
    if CompareText(PropName, sabcpropdsgnPARAMS) = 0 then FParamsEditor := PropertyEditor;
  end;
end;

procedure TabcDBQueryGridEditor.ExecQueryParamsEditor(Query: TQuery);
{calls the Params property editor of the query
 and executes its Edit method}
var
  Components: TDesignerSelectionList;
begin
  Components := TDesignerSelectionList.Create;
  try
    Components.Add(Query);
    FParamsEditor := nil;
    GetComponentProperties(Components, [tkClass], Designer, GetParamsEditor);
    if Assigned(FParamsEditor) then FParamsEditor.Edit;
  finally
    Components.Free;
  end;
end;

procedure TabcDBQueryGridEditor.ExecuteVerb(Index: Integer);
var
  Query: TQuery;
begin
  Query := TabcDBQueryGrid(Component).Query;
  case Index of
    0: ExecSubComponentEditor(TabcDBQueryGrid(Component).Grid);
    1: ExecSubComponentEditor(Query);
    2: ExecQueryParamsEditor(Query);
    3:
      begin
        ExploreDataset(Query);
        if Designer <> nil then Designer.Modified;
      end;
    4: begin
        BuildQuery(Query);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBQueryGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SBindVerb;
    3: Result := SExplore;
    4: Result := SGQEVerb;
  end;
end;

function TabcDBQueryGridEditor.GetVerbCount: Integer;
begin
  if not GQELoadAttempted then LoadGQE;
  if GQELoaded then
    Result := 5
  else
    Result := 4;
end;
{$ENDIF} {TabcDBQueryGridEditor - Delphi 5}

{$IFDEF VER125} {TabcDBQueryGridEditor - C++ Builder 4}
procedure TabcDBQueryGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: TComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBQueryGridEditor.GetParamsEditor(PropertyEditor: TPropertyEditor);
var
  PropName: string;
begin
  if FParamsEditor = nil then
  begin
    PropName := PropertyEditor.GetName;
    if CompareText(PropName, sabcpropdsgnPARAMS) = 0 then FParamsEditor := PropertyEditor;
  end;
end;

procedure TabcDBQueryGridEditor.ExecQueryParamsEditor(Query: TQuery);
{calls the Params property editor of the query
 and executes its Edit method}
var
  Components: TComponentList;
begin
  Components := TComponentList.Create;
  try
    Components.Add(Query);
    FParamsEditor := nil;
    GetComponentProperties(Components, [tkClass], Designer, GetParamsEditor);
    if Assigned(FParamsEditor) then FParamsEditor.Edit;
  finally
    Components.Free;
  end;
end;

procedure TabcDBQueryGridEditor.ExecuteVerb(Index: Integer);
var
  Query: TQuery;
begin
  Query := TabcDBQueryGrid(Component).Query;
  case Index of
    0: ExecSubComponentEditor(TabcDBQueryGrid(Component).Grid);
    1: ExecSubComponentEditor(Query);
    2: ExecQueryParamsEditor(Query);
{    3:
      begin
        ExploreDataset(Query);
        if Designer <> nil then Designer.Modified;
      end;
    4: begin
        BuildQuery(Query);
        if Designer <> nil then Designer.Modified;
      end;  }
  end;
end;

function TabcDBQueryGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SBindVerb;
{    3: Result := SExplore;
    4: Result := SGQEVerb;  }
  end;
end;

function TabcDBQueryGridEditor.GetVerbCount: Integer;
begin
  Result := 3;
{  if not GQELoadAttempted then LoadGQE;
  if GQELoaded then
    Result := 5
  else
    Result := 4;  }
end;
{$ENDIF} {TabcDBQueryGridEditor - C++ Builder 4}

{$IFDEF VER120} {TabcDBQueryGridEditor - Delphi 4}
procedure TabcDBQueryGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: TComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBQueryGridEditor.GetParamsEditor(PropertyEditor: TPropertyEditor);
var
  PropName: string;
begin
  if FParamsEditor = nil then
  begin
    PropName := PropertyEditor.GetName;
    if CompareText(PropName, sabcpropdsgnPARAMS) = 0 then FParamsEditor := PropertyEditor;
  end;
end;

procedure TabcDBQueryGridEditor.ExecQueryParamsEditor(Query: TQuery);
{calls the Params property editor of the query
 and executes its Edit method}
var
  Components: TComponentList;
begin
  Components := TComponentList.Create;
  try
    Components.Add(Query);
    FParamsEditor := nil;
    GetComponentProperties(Components, [tkClass], Designer, GetParamsEditor);
    if Assigned(FParamsEditor) then FParamsEditor.Edit;
  finally
    Components.Free;
  end;
end;

procedure TabcDBQueryGridEditor.ExecuteVerb(Index: Integer);
var
  Query: TQuery;
begin
  Query := TabcDBQueryGrid(Component).Query;
  case Index of
    0: ExecSubComponentEditor(TabcDBQueryGrid(Component).Grid);
    1: ExecSubComponentEditor(Query);
    2: ExecQueryParamsEditor(Query);
    3:
      begin
        ExploreDataset(Query);
        if Designer <> nil then Designer.Modified;
      end;
    4: begin
        BuildQuery(Query);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBQueryGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SBindVerb;
    3: Result := SExplore;
    4: Result := SGQEVerb;
  end;
end;

function TabcDBQueryGridEditor.GetVerbCount: Integer;
begin
  if not GQELoadAttempted then LoadGQE;
  if GQELoaded then
    Result := 5
  else
    Result := 4;
end;
{$ENDIF} {TabcDBQueryGridEditor - Delphi 4}

{ TabcDBTableGridEditor }

{$IFDEF VER150}
procedure TabcDBTableGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: IComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBTableGridEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecSubComponentEditor(TabcDBTableGrid(Component).Grid);
    1: ExecSubComponentEditor(TabcDBTableGrid(Component).Table);
    2:
      begin
        ExploreDataset(TabcDBTableGrid(Component).Table);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBTableGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SExplore;
  end;
end;

function TabcDBTableGridEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;
{$ENDIF} {TabcDBTableGridEditor - Delphi 7 Version}

{$IFDEF VER140}
procedure TabcDBTableGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: IComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBTableGridEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecSubComponentEditor(TabcDBTableGrid(Component).Grid);
    1: ExecSubComponentEditor(TabcDBTableGrid(Component).Table);
    2:
      begin
        ExploreDataset(TabcDBTableGrid(Component).Table);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBTableGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SExplore;
  end;
end;

function TabcDBTableGridEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;
{$ENDIF} {TabcDBTableGridEditor - Delphi 6 Version}

{$IFDEF VER130}
procedure TabcDBTableGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: TComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBTableGridEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecSubComponentEditor(TabcDBTableGrid(Component).Grid);
    1: ExecSubComponentEditor(TabcDBTableGrid(Component).Table);
    2:
      begin
        ExploreDataset(TabcDBTableGrid(Component).Table);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBTableGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SExplore;
  end;
end;

function TabcDBTableGridEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;
{$ENDIF} {TabcDBTableGridEditor - Delphi 5 Version}

{$IFDEF VER125}
procedure TabcDBTableGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: TComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBTableGridEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecSubComponentEditor(TabcDBTableGrid(Component).Grid);
    1: ExecSubComponentEditor(TabcDBTableGrid(Component).Table);
{    2:
      begin
        ExploreDataset(TabcDBTableGrid(Component).Table);
        if Designer <> nil then Designer.Modified;
      end;  }
  end;
end;

function TabcDBTableGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
 {   2: Result := SExplore;  }
  end;
end;

function TabcDBTableGridEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;
{$ENDIF} {TabcDBTableGridEditor - C++Builder 4 Version}

{$IFDEF VER120}
procedure TabcDBTableGridEditor.ExecSubComponentEditor(ASubComponent: TComponent);
{finds the Component Editor of the subcomponent and executes its Edit method}
var
  AComponentEditor: TComponentEditor;
begin
  AComponentEditor := GetComponentEditor(ASubComponent, Designer);
  if AComponentEditor <> nil then AComponentEditor.Edit;
end;

procedure TabcDBTableGridEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecSubComponentEditor(TabcDBTableGrid(Component).Grid);
    1: ExecSubComponentEditor(TabcDBTableGrid(Component).Table);
    2:
      begin
        ExploreDataset(TabcDBTableGrid(Component).Table);
        if Designer <> nil then Designer.Modified;
      end;
  end;
end;

function TabcDBTableGridEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := SDBGridColEditor;
    1: Result := SDatasetDesigner;
    2: Result := SExplore;
  end;
end;

function TabcDBTableGridEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;
{$ENDIF} {TabcDBTableGridEditor - Delphi 4 Version}

function abcGetToolServicesProjectName: string;
begin
  Result := ToolServices.GetProjectName;
end;

initialization
  abcProjectNameFunc := abcGetToolServicesProjectName;

finalization
  abcProjectNameFunc := nil;

end.
