unit abcpropc;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{ Property Categories for ABC }

{$I abcdefs.inc}

interface

uses abcdsncn,
{$IFDEF DELPHI6}
     DesignIntf, PropertyCategories
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type
  TabcCategory = class(TPropertyCategory)
  public
{$IFNDEF DELPHI6}
    class function Name: string; override;
    class function Description: string; override;
{$ENDIF}
  end;

procedure abcRegisterPropertiesInCategory(ComponentClass: TClass; const Filters: array of string);

implementation

{ TabcCategory }

{$IFNDEF DELPHI6}

class function TabcCategory.Name: string;
begin
  Result := sabcPropCategoryName;
end;

class function TabcCategory.Description: string;
begin
  Result := sabcPropCategoryDescription;
end;

{$ENDIF}

procedure abcRegisterPropertiesInCategory(ComponentClass: TClass; const Filters: array of string);
begin
{$IFDEF DELPHI6}
  RegisterPropertiesInCategory(sabcPropCategoryName, ComponentClass, Filters);
{$ELSE}
  RegisterPropertiesInCategory(TabcCategory, ComponentClass, Filters);
{$ENDIF}
end;

end.
