unit abcpshpf;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, Forms, Dialogs, abcshapf,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcShapeFormEditor }

  TabcShapeFormEditor = class(TDefaultEditor)
  private
    procedure Preview;
    procedure AutoSizeForm;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

uses abcdfshp;

{ TabcShapeFormEditor }

function TabcShapeFormEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

function TabcShapeFormEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Preview Form';
    1: Result := '&Size Form to Picture';
  else
    Result := '';
  end;
end;

procedure TabcShapeFormEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Preview;
    1: AutoSizeForm;
  else
  end;
end;

procedure TabcShapeFormEditor.Preview;
begin
  with TabcShapeForm(Component) do
    if (Picture.Graphic = nil) or Picture.Graphic.Empty then
    begin
      MessageDlg(
        Component.Name + '.Picture is empty',
        mtError,
        [mbOk],
        0);
      Exit;
    end;
  with TabcdfShapePreview.Create(nil) do
    try
      abcShapeForm1.Assign(TabcShapeForm(Component));
      abcShapeForm1.DragAnywhere := True;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TabcShapeFormEditor.AutoSizeForm;
begin
  TabcShapeForm(Component).SizeFormToPicture;
end;

end.
