unit abcpspla;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

{property & component editors for splash component}

interface

uses Classes, abcspla,
{$IFDEF DELPHI6}
     DesignIntf, DesignEditors
{$ELSE}
     DsgnIntf
{$ENDIF}
     ;

type

  { TabcSplashEditor }

  TabcSplashEditor = class(TComponentEditor)
  private
    procedure Preview;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

{ TabcSplashEditor }

function TabcSplashEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TabcSplashEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Preview Splash';
  else
    Result := '';
  end;
end;

procedure TabcSplashEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: Preview;
  else
  end;
end;

procedure TabcSplashEditor.Preview;
{make a copy of the component and show it modal}
var
  splash: TabcSplash;
begin
  splash := Tabcsplash.Create(nil);
  try
    splash.Assign(TabcSplash(Component));
    splash.ShowModal := True;
    splash.Show;
  finally
    splash.Free;
  end;
end;
end.
