unit abcreg_b;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC DB Nav Panel - Component Palette Registration

------------------------------------------------------------------------------*)

{Includes $DEFINE settings to compile with InfoPower support}
{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32b.res}

implementation

uses controls, abcprop, abcnp, abcnpbtn, abcnpedt, abcnpflt, abcnpinf
     {$IFDEF DELPHI5}, abcpropc{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC DB Nav', [
    TabcNavToolbar,
    TabcNavPanel,
    TabcNavFormLink,
    TabcnpFirst, TabcnpJumpBack, TabcnpPrev, TabcnpNext, TabcnpJumpFwd, TabcnpLast,
    TabcnpInsert, TabcnpAppend, TabcnpDuplicateRec,
    TabcnpEdit, TabcnpDataSourceEdit, TabcnpBlobEdit, TabcnpFindReplace,
    TabcnpDelete, TabcnpCancel, TabcnpPost, TabcnpRefresh, TabcnpEmptyTable,
    TabcnpBookmark, TabcnpBookmarkMenu, TabcnpFindKey, TabcnpIndexCombo,
    TabcnpRange, TabcnpRangeEdit, TabcnpFilterActive, TabcnpFilterExpression,
    TabcnpSQLStartTrans, TabcnpSQLCommit, TabcnpSQLRollback,
    TabcnpQueryParams, TabcnpDBInfo, TabcnpState, TabcnpRecordCount
    ]);

  RegisterComponentEditor(TabcNavToolbar, TabcNavToolbarEditor);
  RegisterComponentEditor(TabcNavPanel, TabcNavPanelEditor);
  RegisterComponentEditor(TabcnpFirst, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpJumpBack, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpPrev, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpNext, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpJumpFwd, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpLast, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpInsert, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpAppend, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpDuplicateRec, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpEdit, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpDataSourceEdit, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpBlobEdit, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpFindReplace, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpDelete, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpCancel, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpPost, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpRefresh, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpEmptyTable, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpBookmark, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpBookmarkMenu, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpFindKey, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpIndexCombo, TabcnpIndexComboEditor);
  RegisterComponentEditor(TabcnpRange, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpFilterActive, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpFilterExpression, TabcnpFilterExprButtonEditor);
  RegisterPropertyEditor(TypeInfo(string), TabcnpFilterExpression, 'Filter', TabcnpFilterStringProperty);
  RegisterComponentEditor(TabcnpSQLStartTrans, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpSQLCommit, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpSQLRollback, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpQueryParams, TabcnpButtonEditor);
  RegisterComponentEditor(TabcnpDBInfo, TabcnpButtonEditor);


{$IFDEF DELPHI5}

  abcRegisterPropertiesInCategory(TabcNavToolbar,
    ['ActivateParent', 'AutoDataSource', 'AutoField', 'CloseButton', 'DataSource', 'DefaultDock', 'DockableTo', 'DockedTo', 'DockMode', 'DockPos', 'DockRow', 'DragHandle', 'FloatingMode', 'FullSize', 'HideWhenInactive']);

  abcRegisterPropertiesInCategory(TabcNavPanel,
    ['AutoDataSource', 'AutoField', 'DataSource']);

  abcRegisterPropertiesInCategory(TabcnpFirst,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpJumpBack,
    ['Accelerate', 'DisabledShadow', 'Layout', 'Margin', 'MoveBy', 'Picture', 'PictureHighlight', 'RepeatEnabled', 'RepeatInitialPause', 'RepeatPause', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpPrev,
    ['Accelerate', 'DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'RepeatEnabled', 'RepeatInitialPause', 'RepeatPause', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpNext,
    ['Accelerate', 'DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'RepeatEnabled', 'RepeatInitialPause', 'RepeatPause', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpJumpFwd,
    ['Accelerate', 'DisabledShadow', 'Layout', 'Margin', 'MoveBy', 'Picture', 'PictureHighlight', 'RepeatEnabled', 'RepeatInitialPause', 'RepeatPause', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpLast,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpInsert,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpAppend,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpDuplicateRec,
    ['DisabledShadow', 'Insert', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpEdit,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpDataSourceEdit,
    ['AllowAllUp', 'DataSource', 'DataView', 'DisabledShadow', 'FormName', 'Layout', 'Margin', 'ModalAction', 'ModalAutoPost', 'Picture', 'PictureHighlight', 'PopupFormStyle', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpBlobEdit,
    ['AutoEdit', 'DisabledShadow', 'EditBlobAs', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'PopupFormStyle', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpFindReplace,
    ['DisabledShadow', 'FindText', 'Layout', 'Margin', 'OptionsFind', 'OptionsReplace', 'Picture', 'PictureHighlight', 'ReplaceText', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpDelete,
    ['Confirm', 'DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpCancel,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpPost,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpRefresh,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpEmptyTable,
    ['Confirm', 'ConfirmMsg', 'DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpBookmark,
    ['DisabledShadow', 'HintDown', 'HintUp', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpBookmarkMenu,
    ['BreakAtItem', 'DisabledShadow', 'LabelByIndexVals', 'Layout', 'Margin', 'MenuAlign', 'MenuStrings', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpFindKey,
    ['DisabledShadow', 'DlgHelpButton', 'DlgHelpContext', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpIndexCombo,
    ['AutoLoadItems', 'GoToFirst', 'TableIndexItems']);

  abcRegisterPropertiesInCategory(TabcnpRange,
    ['DisabledShadow', 'DlgHelpButton', 'DlgHelpContext', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpRangeEdit,
    ['AutoSelect', 'GoToFirst', 'Separator']);

  abcRegisterPropertiesInCategory(TabcnpFilterActive,
    ['DisabledShadow', 'FilterOptions', 'GoToFirst', 'HintDown', 'HintUp', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpFilterExpression,
    ['AllowEdit', 'DisabledShadow', 'Filter', 'FilterOptions', 'GoToFirst', 'HintDown', 'HintUp', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpSQLStartTrans,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpSQLCommit,
    ['Confirm', 'DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpSQLRollback,
    ['Confirm', 'DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpQueryParams,
    ['DisabledShadow', 'DlgHelpButton', 'DlgHelpContext', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpDBInfo,
    ['DisabledShadow', 'Layout', 'Margin', 'Picture', 'PictureHighlight', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcnpState,
    ['DisabledCaption', 'Mask', 'States']);

  abcRegisterPropertiesInCategory(TabcnpRecordCount,
    ['DisabledCaption', 'Mask']);
{$ENDIF}

end;

{$IFDEF DELPHI6}

initialization
  ActivateClassGroup(TControl);
  RegisterClasses([
    TabcnpFirst, TabcnpJumpBack, TabcnpPrev, TabcnpNext, TabcnpJumpFwd, TabcnpLast,
    TabcnpInsert, TabcnpAppend, TabcnpDuplicateRec,
    TabcnpEdit, TabcnpDataSourceEdit, TabcnpBlobEdit, TabcnpFindReplace,
    TabcnpDelete, TabcnpCancel, TabcnpPost, TabcnpRefresh, TabcnpEmptyTable,
    TabcnpBookmark, TabcnpBookmarkMenu, TabcnpFindKey, TabcnpIndexCombo,
    TabcnpRange, TabcnpRangeEdit, TabcnpFilterActive, TabcnpFilterExpression,
    TabcnpSQLStartTrans, TabcnpSQLCommit, TabcnpSQLRollback,
    TabcnpQueryParams, TabcnpDBInfo, TabcnpState, TabcnpRecordCount
  ]);

finalization
  UnRegisterClasses([
    TabcnpFirst, TabcnpJumpBack, TabcnpPrev, TabcnpNext, TabcnpJumpFwd, TabcnpLast,
    TabcnpInsert, TabcnpAppend, TabcnpDuplicateRec,
    TabcnpEdit, TabcnpDataSourceEdit, TabcnpBlobEdit, TabcnpFindReplace,
    TabcnpDelete, TabcnpCancel, TabcnpPost, TabcnpRefresh, TabcnpEmptyTable,
    TabcnpBookmark, TabcnpBookmarkMenu, TabcnpFindKey, TabcnpIndexCombo,
    TabcnpRange, TabcnpRangeEdit, TabcnpFilterActive, TabcnpFilterExpression,
    TabcnpSQLStartTrans, TabcnpSQLCommit, TabcnpSQLRollback,
    TabcnpQueryParams, TabcnpDBInfo, TabcnpState, TabcnpRecordCount
  ]);

{$ENDIF}

end.
