unit abcreg_c;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Data Controls - Component Palette Registration

------------------------------------------------------------------------------*)

{Includes $DEFINE settings to compile with InfoPower support}
{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32c.res}

implementation

uses
  SysUtils, DB,
  abcprop, abcdbctl, abcedwin, abchgrid, abcdbgrf, abcdbrng,
  abcdbcur, abcdblr, abcdbaut, abcfiltr, abcidcbo,
  abcdbtre, abcpdbt, abcdbrch, abctdbe, abcdbdtp
  {$IFDEF DELPHI5}, abcpropc{$ENDIF}
  ;

procedure Register;
begin
  RegisterComponents ('ABC Toolbars && Menus', [TabcToolbarDBEdit]);

  RegisterComponents('ABC Data Controls', [
    TabcDBTreeView, TabcDBRichEdit, TabcDBSuperNav, TabcDBEditWin,
    TabcHDBGrid, TabcDBIndexCombo, TabcDBFilter, TabcDBRangeEdit,
    TabcDBAutoEdit, TabcDBFixedGrid, TabcDBEditLabel, TabcDBRecordCount,
    TabcDBState, TabcDBCurrencyLabel, TabcLRDBComboBox, 
    TabcDBDateTimePicker, TabcDBMonthCalendar
    ]);

  RegisterComponentEditor(TabcDBFixedGrid, TabcDBGridEditor);
  RegisterComponentEditor(TabcDBIndexCombo, TabcDBIndexComboEditor);
  RegisterComponentEditor(TabcDBFilter, TabcDBFilterCompEditor);

  RegisterPropertyEditor(TypeInfo(string), TabcDBEditLabel, 'DataField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TabcDBEditLabel, 'DataSource', TabcDataSourceProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcDBTreeView, 'DataField', TabcReadOnlyProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TabcDBTreeView, 'DataSource', TabcReadOnlyProperty);

  RegisterPropertyEditor(TypeInfo(TDataSource), TabcDBTreeLevel, 'DataSource', TabcDataSourceProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTreeLevel, 'DataField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTreeLevel, 'ImageField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTreeLevel, 'SelImageField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTreeLevel, 'StateImageField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTreeLevel, 'OverlayImageField', TabcDataFieldProperty);
  RegisterComponentEditor(TabcDBTreeView, TabcDBTreeSourcesEditor);

  RegisterPropertyEditor(TypeInfo(string), TabcDBDateTimePicker, 'DataField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBDateTimePicker, 'DataFieldCheckBox', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TabcDBDateTimePicker, 'DataSource', TabcDataSourceProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcDBMonthCalendar, 'DataField', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBMonthCalendar, 'DataFieldEndDate', TabcDataFieldProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TabcDBMonthCalendar, 'DataSource', TabcDataSourceProperty);

{$IFDEF DELPHI5}

  abcRegisterPropertiesInCategory(TabcDBSuperNav,
    ['Flat', 'GlyphColor', 'Hints', 'MoveBy', 'NavSpeed', 'VisibleButtons']);

  abcRegisterPropertiesInCategory(TabcDBEditWin,
    ['AutoCaption', 'AutoScroll', 'EditAutoSize', 'EditColor', 'EditFont', 'EditHints', 'EditParentColor', 'EditParentFont', 'EditShowHint', 'EditWidth', 'FieldOffsetH', 'FieldOffsetV', 'FieldReadOnly', 'HorzScrollBar', 'LabelAlignment', 'LabelAutoSize', 'LabelCaptions', 'LabelColor', 'LabelFont', 'LabelHeight', 'LabelOffsetH', 'LabelOffsetV', 'LabelParentColor', 'LabelParentFont', 'LabelWidth', 'LabelWordWrap', 'LayoutEdit', 'LayoutLabel', 'MarginLeft', 'MarginTop', 'MaxWidth', 'PopupAutoEdit', 'PopupEditBlobAs', 'PopupFormStyle', 'VertScrollBar']);

  abcRegisterPropertiesInCategory(TabcHDBGrid,
    ['AlignTitles', 'ColSizing', 'ColWidth', 'FixedColor', 'NumCols', 'Options', 'TitleWidth']);

  abcRegisterPropertiesInCategory(TabcDBIndexCombo,
    ['GoToFirst', 'ItemIndex', 'Sorted', 'TableIndexItems']);

  abcRegisterPropertiesInCategory(TabcDBFilter,
    ['AutoActivate', 'Filter', 'FilterOptions', 'GoToFirst']);

  abcRegisterPropertiesInCategory(TabcDBRangeEdit,
    ['ApplyRangeWhen', 'GoToFirst', 'Separator']);

  abcRegisterPropertiesInCategory(TabcDBAutoEdit,
    ['PopupAutoEdit', 'PopupEditBlobAs', 'PopupFormStyle']);

  abcRegisterPropertiesInCategory(TabcDBFixedGrid,
    ['FixedCols']);

  abcRegisterPropertiesInCategory(TabcDBEditLabel,
    ['CaptionAuto', 'EditColor', 'EditFont', 'EditParentColor', 'EditParentFont', 'LabelFont', 'LabelHeight', 'LabelOffsetX', 'LabelOffsetY', 'LabelParentFont', 'LabelWidth', 'Layout']);

  abcRegisterPropertiesInCategory(TabcDBRecordCount,
    ['DisabledCaption', 'Mask']);

  abcRegisterPropertiesInCategory(TabcDBState,
    ['DisabledCaption', 'Mask', 'States']);

  abcRegisterPropertiesInCategory(TabcDBCurrencyLabel,
    ['CurrFractionFormat', 'CurrFractionText', 'CurrText', 'FirstUpperCase', 'HandleException']);

  abcRegisterPropertiesInCategory(TabcDBTreeView,
    ['DataSources', 'Options', 'SyncABCNavPanel', 'OnDeletion', 'OnGetText']);

  abcRegisterPropertiesInCategory(TabcDBRichEdit,
    ['AcceptDroppedFiles', 'EditorOptions', 'EditorWindowState', 'FileTemplate', 'PopupOptions', 'PrintMargins', 'PrintTitle']);

  abcRegisterPropertiesInCategory(TabcDBDateTimePicker,
    ['DataField', 'DataFieldCheckBox', 'DataSource']);

  abcRegisterPropertiesInCategory(TabcDBMonthCalendar,
    ['DataField', 'DataFieldEndDate', 'DataSource']);

{$ENDIF}


end;

end.
