unit abcreg_e;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Containers - Component Palette Registration

------------------------------------------------------------------------------*)

{Includes $DEFINE settings to compile with InfoPower support}
{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32e.res}

implementation

uses Controls, abcprop, abcsplit, abcpanel, abcsubfm,
     abcanfr, abcpanfr, abcbar, abcpbar
     , abcbarlv, abcfx, abcpfx, abctabf
     {$IFDEF DELPHI5}, abcpropc, abcpilst, ImgList{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Containers', [
    TabcFormTabControl,
    TabcAnimationFrame, TabcFormPanel, TabcButtonBar, TabcButtonList, TabcPictureGroup,
    TabcMultiSplit, TabcQuadSplit, TabcTriSplit, TabcBiSplit, TabcSplitBar,
    TabcSMultiSplit, TabcSQuadSplit, TabcSTriSplit, TabcSBiSplit,
    TabcEdgePanel, TabcDragPanel, TabcSpeedPanel, TabcHintBar,
    TabcFormTabbedNoteBook, TabcFormNoteBook, TabcLRNoteBook, TabcLRTabbedNoteBook
    ]);

  RegisterNoIcon([TabcSplitPane, TabcScrollingSplitPane]);

  RegisterPropertyEditor(TypeInfo(TWinControl), TabcSplitBar, 'WindowA', TabcSplitBarWindowAProperty);
  RegisterPropertyEditor(TypeInfo(TWinControl), TabcSplitBar, 'WindowB', TabcSplitBarWindowBProperty);

  RegisterComponentEditor(TabcBiSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcTriSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcQuadSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcMultiSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcSBiSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcSTriSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcSQuadSplit, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcSMultiSplit, TabcSplitPaneEditor);

  RegisterComponentEditor(TabcSplitPane, TabcSplitPaneEditor);
  RegisterComponentEditor(TabcScrollingSplitPane, TabcSplitPaneEditor);

  RegisterPropertyEditor(TypeInfo(TabcPage), TabcCustomPageFrame, 'ActivePage', TabcPageProperty);
  RegisterComponentEditor(TabcCustomPageFrame, TabcPageFrameEditor);
  RegisterComponentEditor(TabcPage, TabcPageFrameEditor);

  RegisterPropertyEditor(TypeInfo(TabcButtonPage), TabcButtonBar, 'ActivePage', TabcButtonPageProperty);
  RegisterComponentEditor(TabcButtonBar, TabcButtonBarEditor);
  RegisterComponentEditor(TabcButtonPage, TabcButtonBarEditor);

  RegisterPropertyEditor(TypeInfo(TList), TabcTransition, 'EffectSelection', TabcEffectSelectionProperty);
  RegisterPropertyEditor(TypeInfo(TabcTransition), nil, '', TabcTransitionProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcFormNotebook, 'ActiveForm', TabcNotebookFormNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcFormTabbedNotebook, 'ActiveForm', TabcTabbedNotebookFormNameProperty);

{$IFDEF DELPHI5}
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcPage, 'ImageIndex', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcButtonPage, 'ImageIndex', TabcImageIndexProperty);

  abcRegisterPropertiesInCategory(TabcSplitBar,
    ['KeyIncrement', 'Layout', 'Max', 'Min', 'MoveImmediate', 'Percent', 'Pos', 'SplitMoveStyle', 'Thickness', 'WindowA', 'WindowB']);

  abcRegisterPropertiesInCategory(TabcBiSplit,
    ['KeyIncrement', 'Layout', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcTriSplit,
    ['KeyIncrement', 'Layout', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcQuadSplit,
    ['KeyIncrement', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcMultiSplit,
    ['KeyIncrement', 'Layout', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcSBiSplit,
    ['KeyIncrement', 'Layout', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'SyncHScroll', 'SyncVScroll', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcSTriSplit,
    ['KeyIncrement', 'Layout', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'SyncHScroll', 'SyncVScroll', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcSQuadSplit,
    ['KeyIncrement', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'SyncHScroll', 'SyncVScroll', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcSMultiSplit,
    ['KeyIncrement', 'Layout', 'MoveImmediate', 'SplitBevel', 'SplitColor', 'SplitHLock', 'SplitHMax', 'SplitHMin', 'SplitHPercent', 'SplitHPos', 'SplitHScaled', 'SplitMoveStyle', 'SplitVLock', 'SplitVMax', 'SplitVMin', 'SplitVPercent', 'SplitVPos', 'SplitVScaled', 'SyncHScroll', 'SyncVScroll', 'Thickness']);

  abcRegisterPropertiesInCategory(TabcHintBar,
    ['AutoHint', 'HintPrefix', 'HintSuffix', 'Panels', 'ShowActiveControl', 'ShowEmpty', 'SimplePanel', 'SimpleText', 'SizeGrip', 'UseSystemFont']);

  abcRegisterPropertiesInCategory(TabcDragPanel,
    ['Locked', 'MoveMaxLeft', 'MoveMaxTop', 'MoveMinLeft', 'MoveMinTop', 'MSLocked', 'Options', 'SizeMaxHeight', 'SizeMaxWidth', 'SizeMinHeight', 'SizeMinWidth']);

  abcRegisterPropertiesInCategory(TabcSpeedPanel,
    ['CtrlCols', 'CtrlHeight', 'CtrlRows', 'CtrlWidth', 'InsertCols', 'MarginCol', 'MarginH', 'MarginRow', 'MarginV', 'SizeVisibleOnly', 'Sorted']);

  abcRegisterPropertiesInCategory(TabcFormPanel,
    ['AutoCreate', 'AutoDestroy', 'FormName', 'HandleException']);

  abcRegisterPropertiesInCategory(TabcAnimationFrame,
    ['Animation', 'AnimationSteps', 'AnimationTime', 'CreatePagesOnLoad']);

  abcRegisterPropertiesInCategory(TabcButtonBar,
    ['ActiveFontColor', 'AnimationSteps', 'AnimationTime', 'ButtonAlign', 'ButtonCursor', 'ButtonHeight', 'ButtonHighlight', 'ButtonStyle', 'Options']);

  abcRegisterPropertiesInCategory(TabcButtonList,
    ['Background', 'DragLineColor', 'FrameBottomColor', 'FrameTopColor', 'HighlightActive', 'HighlightSelected', 'Items', 'LargeImages', 'Options', 'SelectedIndex', 'SmallImages', 'SoundList', 'ViewStyle']);

  abcRegisterPropertiesInCategory(TabcPictureGroup,
    ['AlignPicture', 'LineRaised', 'MarginB', 'MarginL', 'MarginR', 'MarginT', 'Offset', 'Picture', 'Transparent']);

  abcRegisterPropertiesInCategory(TabcFormNoteBook,
    ['ActiveForm', 'ActivePage', 'FormCreateDestroy', 'Forms', 'HandleException', 'PageIndex', 'Pages']);

  abcRegisterPropertiesInCategory(TabcFormTabbedNoteBook,
    ['ActiveForm', 'FormCreateDestroy', 'Forms', 'HandleException']);

{$ENDIF}

end;

initialization
{$IFDEF DELPHI6}
  ActivateClassGroup(TControl);
{$ENDIF}
  RegisterClasses([TabcPage, TabcButtonPage]);

finalization
  UnRegisterClasses([TabcPage, TabcButtonPage]);

end.
