unit abcreg_f;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Controls - Component Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32f.res}

implementation

uses abcprop, abcexctl, abchighl, abckeys, abclist, abcshape, abcsubfm,
     abctimag, abcmemo, abcspin, abccombo, abcedbtn, abcrched, abcprch,
     abcctl32, abcshapf, abcpshpf, abcmdtab
     {$IFDEF DELPHI5}, abcpropc{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Controls', [
    TabcShapeForm, TabcRichEdit,
    TabcCheckListBox, TabcFontComboBox, TabcColorComboBox, TabcLine, TabcMDITabs,
    TabcButtonEdit, TabcCheckBox, TabcRadioButton, TabcPopupSelect,
    TabcBackground, TabcMDIBackground, TabcTiledImage, TabcMDITiledImage,
    TabcKeyState, TabcActiveHighlight, TabcShape, TabcFrame,
    TabcAutoTabSet, TabcLRComboBox, TabcLRListBox,
    TabcROMemo, TabcTabListBox, TabcSyncListBox, TabcTransImage, TabcSpinEdit
    ]);

  RegisterComponentEditor(TabcLine, TabcLineCompEditor);
  RegisterComponentEditor(TabcRichEdit, TabcRichEditComponentEditor);
  RegisterComponentEditor(TabcShapeForm, TabcShapeFormEditor);

  RegisterPropertyEditor(TypeInfo(TabcCustomSyncListBox), TabcCheckListBox, 'SyncControl', TabcComponentExceptSelfProperty);
  RegisterPropertyEditor(TypeInfo(TabcCustomSyncListBox), TabcTabListBox, 'SyncControl', TabcComponentExceptSelfProperty);
  RegisterPropertyEditor(TypeInfo(TabcCustomSyncListBox), TabcSyncListBox, 'SyncControl', TabcComponentExceptSelfProperty);
  RegisterPropertyEditor(TypeInfo(TabcROMemo), TabcROMemo, 'SyncMemo', TabcComponentExceptSelfProperty);

  RegisterPropertyEditor(TypeInfo(TStrings), TabcColorComboBox, 'Items', TabcColorStringsProperty);

  RegisterPropertyEditor(TypeInfo(TStrings), TabcRichEdit, 'Lines', TabcRichEditLinesProperty);

{$IFDEF DELPHI5}

  abcRegisterPropertiesInCategory(TabcPopupSelect,
    ['BarBreak', 'ItemIndex', 'Items', 'ItemsPerCol', 'PopupOffsetX', 'PopupOffsetY', 'PopupYAdjust', 'Sorted']);

  abcRegisterPropertiesInCategory(TabcBackground,
    ['ColorFrom', 'ColorTo', 'DrawDirection', 'DrawSteps']);

  abcRegisterPropertiesInCategory(TabcMDIBackground,
    ['ColorFrom', 'ColorTo', 'DrawDirection', 'DrawSteps']);

  abcRegisterPropertiesInCategory(TabcTiledImage,
    ['ImageStyle', 'Picture']);

  abcRegisterPropertiesInCategory(TabcMDITiledImage,
    ['ImageStyle', 'Picture']);

  abcRegisterPropertiesInCategory(TabcKeyState,
    ['KeyCapsLock', 'KeyInsert', 'KeyNumLock', 'KeyScrollLock', 'KeyStrings', 'ShowINSAsOVR', 'ShowKeyStates', 'ToggleOnClick']);

  abcRegisterPropertiesInCategory(TabcActiveHighlight,
    ['ColorChange', 'HighlightColor', 'MoveCursor']);

  abcRegisterPropertiesInCategory(TabcLine,
    ['Arrows', 'ArrowSize', 'ArrowStyle', 'ClipMouse', 'Direction', 'LineStyle', 'LineWidth']);

  abcRegisterPropertiesInCategory(TabcShape,
    ['AlignVertical', 'ColorHighlight', 'ColorShadow', 'CornerWidth', 'Shape']);

  abcRegisterPropertiesInCategory(TabcFrame,
    ['ColorHighlight', 'ColorShadow', 'CornerWidth']);

  abcRegisterPropertiesInCategory(TabcAutoTabSet,
    ['NoteBook']);

  abcRegisterPropertiesInCategory(TabcROMemo,
    ['MaxEditLines', 'PrintIndent', 'Printing', 'PrintLines']);

  abcRegisterPropertiesInCategory(TabcCheckListBox,
    ['CheckedColor', 'CheckedColorChange', 'CheckedItems', 'DisabledItems', 'DisabledItemsGrayed', 'ExpandTabs', 'Glyph', 'GlyphAlignH', 'GlyphAlignV', 'GlyphForeColor', 'GlyphSpace', 'GlyphStyle', 'Options', 'PrintIndent', 'Printing', 'PrintLines', 'ScrollWidth', 'SyncControl', 'SyncOptions']);

  abcRegisterPropertiesInCategory(TabcTabListBox,
    ['PrintIndent', 'Printing', 'PrintLines', 'ScrollWidth', 'SyncControl', 'SyncOptions', 'TabPositions']);

  abcRegisterPropertiesInCategory(TabcSyncListBox,
    ['PrintIndent', 'Printing', 'PrintLines', 'ScrollWidth', 'SyncControl', 'SyncOptions']);

  abcRegisterPropertiesInCategory(TabcTransImage,
    ['PicAlign', 'PicDrawStyle', 'Picture', 'Transparent', 'TransparentColor']);

  abcRegisterPropertiesInCategory(TabcSpinEdit,
    ['EditorEnabled', 'Increment', 'MaxValue', 'MinValue', 'Value']);

  abcRegisterPropertiesInCategory(TabcColorComboBox,
    ['Items', 'ShowText']);

  abcRegisterPropertiesInCategory(TabcFontComboBox,
    ['FontOptions']);

  abcRegisterPropertiesInCategory(TabcButtonEdit,
    ['AutoClick', 'AutoSelect', 'ButtonDisabled', 'ButtonVisible']);

  abcRegisterPropertiesInCategory(TabcRichEdit,
    ['AcceptDroppedFiles', 'EditorOptions', 'EditorTitle', 'EditorWindowState', 'FileName', 'FileTemplate', 'PopupOptions', 'PrintMargins', 'PrintTitle']);

  abcRegisterPropertiesInCategory(TabcCheckBox,
    ['AlignHorz', 'AlignVert', 'WordWrap']);

  abcRegisterPropertiesInCategory(TabcRadioButton,
    ['AlignHorz', 'AlignVert', 'WordWrap']);

  abcRegisterPropertiesInCategory(TabcShapeForm,
    ['DragAnywhere', 'DragControl', 'Picture', 'Tolerance']);

  abcRegisterPropertiesInCategory(TabcMDITabs,
    ['Options']);


{$ENDIF}

end;

end.
