unit abcreg_g;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Dialogs - Component Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32g.res}

implementation

uses SysUtils, abcprop, abcexctl, abcutil, abcfdir,
     abcedtop, abcpedto, abcedtsv, abcpedts, abcedtdr, abcpedtd,
     abcspla, abcpspla, abctips, abcptips, abcmem, abcpage, abcbusy, abcpbusy,
     abcdlg
     , Filtedit
     {$IFDEF DELPHI5}, abcpropc{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Dialogs', [
    TabcMessageDlg, TabcProgressDlg,
    TabcBusy, TabcSplash, TabcWelcomeTips, TabcPageSetupDialog,
    TabcFileOpenEdit, TabcFileSaveEdit, TabcDirectoryEdit,
    TabcDirectoryDialog
    ]);

  RegisterComponentEditor(TabcFileOpenEdit, TabcFileOpenEditEditor);

  RegisterPropertyEditor(TypeInfo(string), TabcResourceData, 'FileName', TabcFileNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcResourceData, 'ResourceType', TabcResTypeStringProperty);
  RegisterPropertyEditor(TypeInfo(TabcPersistentMemory), TabcResourceData, 'Data', TabcPersistentMemoryProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcAVISource, 'FileName', TabcAVIFilenameProperty);
  RegisterPropertyEditor(TypeInfo(TabcPersistentMemory), TabcAVISource, 'Data', TabcAVIDataProperty);
  RegisterComponentEditor(TabcBusy, TabcBusyEditor);

  RegisterPropertyEditor(TypeInfo(string), TabcOpenDialogWrapper, 'Filter', TFilterProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcOpenDialogWrapper, 'FileName', TabcOpenFilenameProperty);

  RegisterComponentEditor(TabcFileSaveEdit, TabcFileSaveEditEditor);

  RegisterPropertyEditor(TypeInfo(string), TabcSaveDialogWrapper, 'Filter', TFilterProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcSaveDialogWrapper, 'FileName', TabcSaveFilenameProperty);

  RegisterComponentEditor(TabcDirectoryEdit, TabcDirectoryEditEditor);
  RegisterPropertyEditor(TypeInfo(string), TabcDirDialogWrapper, 'Directory', TabcDirectoryProperty);

  RegisterComponentEditor(TabcSplash, TabcSplashEditor);
  RegisterComponentEditor(TabcWelcomeTips, TabcWelcomeTipsEditor);
  RegisterPropertyEditor(TypeInfo(TFilename), TabcWelcomeTips, 'IniFileName', TabcIniFileNameProperty);
  RegisterPropertyEditor(TypeInfo(TFilename), TabcWelcomeTips, 'SharedTipFileName', TabcIniFileNameProperty);

{$IFDEF DELPHI5}

  abcRegisterPropertiesInCategory(TabcPageSetupDialog,
    ['Margins', 'MinMargins', 'Options', 'Units']);

  abcRegisterPropertiesInCategory(TabcDirectoryDialog,
    ['DirButtonStyle', 'DirDialogStyle', 'Directory', 'DirEditStyle', 'DirLabelStyle', 'HistoryList', 'Options', 'Title']);

  abcRegisterPropertiesInCategory(TabcFileOpenEdit,
    ['ButtonDisabled', 'ButtonVisible', 'ClickOnEnterKey', 'OpenDialog']);

  abcRegisterPropertiesInCategory(TabcFileSaveEdit,
    ['ButtonDisabled', 'ButtonVisible', 'ClickOnEnterKey', 'SaveDialog']);

  abcRegisterPropertiesInCategory(TabcDirectoryEdit,
    ['ButtonDisabled', 'ButtonVisible', 'ClickOnEnterKey', 'DirDialog']);

  abcRegisterPropertiesInCategory(TabcSplash,
    ['AllowLocalBmp', 'AutoShow', 'Duration', 'HideOnClick', 'Picture', 'PictureVGA', 'ShowModal', 'StayOnTop']);

  abcRegisterPropertiesInCategory(TabcWelcomeTips,
    ['AutoShow', 'CaptionGreeting', 'CaptionShowNext', 'CaptionTip', 'HelpContents', 'HelpWhatsNew', 'IniFileName', 'IniLocal', 'VisibleButtons']);

  abcRegisterPropertiesInCategory(TabcBusy,
    ['AVIPosition', 'AVISource', 'AVITransparent', 'DlgColor', 'DlgHeight', 'DlgLeft', 'DlgPosition', 'DlgTop', 'DlgWidth', 'Message1', 'Message1Font', 'Message2', 'Message2Font', 'MinDuration', 'Options', 'ProgressMax', 'ProgressMin', 'ProgressPos', 'ProgressStep', 'Sound']);

{$ENDIF}

end;

end.
