unit abcreg_h;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Multimedia - Component Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf, VCLeditors {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32h.res}

implementation

uses SysUtils, abcprop, abcmem, abcmm, abcwav,
     abcfx, abcpfx, abcdbfx, abcfxrch, abcpfxr,
     abcspr, abcsprim, abcsprfx, abcsprfr, abcsprtx, abcpspr, abcppts
     {$IFDEF DELPHI5}, abcpropc, abcpilst, ImgList{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Multimedia', [
    TabcEffectsImage , TabcRichEffectsImage, TabcDBEffectsImage,
    TabcWave, TabcWaveFile, TabcWaveRes, TabcWaveList, TabcWaveFileList, TabcWaveResList,
    TabcMCIFilePlayer, TabcMCIStreamPlayer,
    TabcSpriteSurface, TabcSpriteList, TabcBitmapSpriteFactory
    ]);

  RegisterPropertyEditor(TypeInfo(TabcWaveImage), TabcWave, 'Sound', TabcWaveImageProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TabcWaveFile, 'FileName', TabcWaveFileProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TabcWaveList, 'Items', TabcWaveListImagesProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcMCIFilePlayer, 'FileName', TMPFilenameProperty);
  RegisterPropertyEditor(TypeInfo(TabcPersistentMemory), TabcMCIStreamPlayer, 'MCIData', TabcMCIDataProperty);
  RegisterPropertyEditor(TypeInfo(TList), TabcEffectsImage, 'EffectSelection', TabcEffectSelectionProperty);
  RegisterComponentEditor(TabcEffectsImage, TabcEffectsImageEditor);
  RegisterPropertyEditor(TypeInfo(TList), TabcDBEffectsImage, 'EffectSelection', TabcEffectSelectionProperty);
  RegisterComponentEditor(TabcDBEffectsImage, TabcEffectsImageEditor);

  RegisterPropertyEditor(TypeInfo(TabcRichText), TabcRichEffectsImage, 'RichText', TabcRichTextProperty);

  abcRegisterSpriteClass(TabcBitmapSprite, 'Bitmap Sprite', True);    //true = default item
  abcRegisterSpriteClass(TabcPictureSprite, 'Picture Sprite', False);
  abcRegisterSpriteClass(TabcImageListSprite, 'ImageList Sprite', False);
  abcRegisterSpriteClass(TabcEffectSprite, 'Effect Sprite', False);
  RegisterPropertyEditor(TypeInfo(TList), TabcEffectSprite, 'EffectSelection', TabcEffectSelectionProperty);
  abcRegisterSpriteClass(TabcRichEffectSprite, 'Effect Sprite with Rich Text', False);
  RegisterPropertyEditor(TypeInfo(TabcRichText), TabcRichEffectSprite, 'RichText', TabcRichTextProperty);
  abcRegisterSpriteClass(TabcInputSprite, 'Input Sprite', False);
  abcRegisterSpriteClass(TabcShapeSprite, 'Shape Sprite', False);
  abcRegisterSpriteClass(TabcTextSprite, 'Scrolling Text Sprite', False);
  abcRegisterSpriteClass(TabcRotateTextSprite, 'Rotating Text Sprite', False);
  RegisterComponentEditor(TabcSpriteList, TabcSpriteListComponentEditor);
  RegisterPropertyEditor(TypeInfo(TabcPointList), TabcSpriteMover, 'Points', TabcPointListProperty);

{$IFDEF DELPHI5}

  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcEffectsImage, 'ImageIndex', TabcImageIndexProperty);

  abcRegisterPropertiesInCategory(TabcWave,
    ['PlayOption', 'Sound']);

  abcRegisterPropertiesInCategory(TabcWaveFile,
    ['FileName', 'PlayOption']);

  abcRegisterPropertiesInCategory(TabcWaveRes,
    ['PlayOption', 'ResourceDLL', 'ResourceName']);

  abcRegisterPropertiesInCategory(TabcWaveList,
    ['ItemIndex', 'Items', 'PlayOption']);

  abcRegisterPropertiesInCategory(TabcWaveFileList,
    ['FileExt', 'FilePath', 'ItemIndex', 'Items', 'PlayOption']);

  abcRegisterPropertiesInCategory(TabcWaveResList,
    ['ItemIndex', 'Items', 'PlayOption', 'ResourceDLL']);

  abcRegisterPropertiesInCategory(TabcMCIFilePlayer,
    ['AutoClose', 'AutoOpen', 'AutoRepeat', 'AutoRewind', 'DeviceType', 'Display', 'FileName', 'RaiseExceptions', 'Shareable']);

  abcRegisterPropertiesInCategory(TabcMCIStreamPlayer,
    ['AutoClose', 'AutoOpen', 'AutoRepeat', 'AutoRewind', 'DeviceType', 'Display', 'MCIData', 'RaiseExceptions', 'Shareable']);

  abcRegisterPropertiesInCategory(TabcEffectsImage,
    ['Effect', 'EffectSelection', 'EffectSelIndex', 'EffectSize', 'EffectSpeed', 'Picture', 'PictureSize', 'ProcessMessages', 'Transparent']);

  abcRegisterPropertiesInCategory(TabcDBEffectsImage,
    ['Effect', 'EffectSelection', 'EffectSelIndex', 'EffectSize', 'EffectSpeed', 'PictureSize', 'ProcessMessages']);

{$ENDIF}

end;

end.
