unit abcreg_i;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Buttons - Component Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32i.res}

implementation

uses SysUtils, abcprop, abcbtn, abcwav, abcctl32, abcbtns, abcpbtns
     {$IFDEF DELPHI5}, abcpropc, abcpilst, ImgList{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Buttons', [
    TabcShapeButton, TabcPicBtn, TabcPicSpeedBtn, TabcRepSpeedBtn,
    TabcToggleBtn, TabcMouseRegion, TabcMenuButton, TabcSizeButton, TabcWaveBtn,
    TabcWaveFileBtn, TabcFormButton, TabcFormPicBtn, TabcFormPicSpeedBtn,
    TabcPushButton, TabcButton
    ]);

  RegisterComponentEditor(TabcPicSpeedBtn, TabcnpButtonEditor);
  RegisterComponentEditor(TabcToggleBtn, TabcnpButtonEditor);

  RegisterPropertyEditor(TypeInfo(TabcWaveImage), TabcWaveBtn, 'Sound', TabcWaveImageProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TabcWaveFileBtn, 'FileName', TabcWaveFileProperty);

  RegisterComponentEditor(TabcShapeButton, TabcShapeButtonEditor);

{$IFDEF DELPHI5}
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcShapeButton, 'IndexDisabled', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcShapeButton, 'IndexDown', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcShapeButton, 'IndexFlat', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcShapeButton, 'IndexMouseMask', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcShapeButton, 'IndexUp', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcPicBtn, 'ImageIndex', TabcImageIndexProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcPicSpeedBtn, 'ImageIndex', TabcImageIndexProperty);

  abcRegisterPropertiesInCategory(TabcPicBtn,
    ['DisabledShadow', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle', 'TransparentColor']);

  abcRegisterPropertiesInCategory(TabcPicSpeedBtn,
    ['DisabledShadow', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle', 'TransparentColor']);

  abcRegisterPropertiesInCategory(TabcRepSpeedBtn,
    ['DisabledShadow', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'RepeatEnabled', 'RepeatInitialPause', 'RepeatPause', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle', 'TransparentColor']);

  abcRegisterPropertiesInCategory(TabcToggleBtn,
    ['DisabledShadow', 'HintDown', 'HintUp', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcMouseRegion,
    ['Outline', 'OutlineColor', 'SoundDown', 'SoundLeave', 'SoundList', 'SoundOver']);

  abcRegisterPropertiesInCategory(TabcMenuButton,
    ['Flat', 'Glyph', 'Layout', 'Margin', 'MenuCaption', 'MenuItem', 'NumGlyphs', 'Spacing', 'Transparent']);

  abcRegisterPropertiesInCategory(TabcSizeButton,
    ['MarginH', 'MarginV']);

  abcRegisterPropertiesInCategory(TabcWaveBtn,
    ['DisabledShadow', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'PlaySync', 'Sound', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcWaveFileBtn,
    ['DisabledShadow', 'FileName', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'PlaySync', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcFormButton,
    ['FormName', 'ShowModal']);

  abcRegisterPropertiesInCategory(TabcFormPicBtn,
    ['DisabledShadow', 'FormName', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'ShowModal', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcFormPicSpeedBtn,
    ['DisabledShadow', 'FormName', 'Layout', 'Margin', 'NumGlyphs', 'Picture', 'PictureHighlight', 'ShowModal', 'SoundDown', 'SoundList', 'SoundOver', 'Spacing', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcPushButton,
    ['AlignHorz', 'AlignVert', 'Checked', 'WordWrap']);

  abcRegisterPropertiesInCategory(TabcButton,
    ['AlignHorz', 'AlignVert', 'WordWrap']);

  abcRegisterPropertiesInCategory(TabcShapeButton,
    ['ImageList', 'IndexDisabled', 'IndexDown', 'IndexFlat', 'IndexMouseMask', 'IndexUp', 'OffsetDownX', 'OffsetDownY', 'OffsetUpX', 'OffsetUpY', 'Scaled', 'SoundDown', 'SoundList', 'SoundOver']);

{$ENDIF}

end;

end.
