unit abcreg_j;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Labels - Component Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32j.res}

implementation

uses Graphics, abcprop, abclabel, abccurlb, abcexctl, abcversn, abcpvers
     {$IFDEF DELPHI5}, abcpropc{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Labels', [
    TabcRotLabel, TabcVersionLabel, TabcURLLabel, TabcMailToLabel, TabcMultilineLabel,
    TabcCurrencyLabel, TabcMouseLabel, TabcClockLabel, TabcSuperLabel,
    TabcAutoLabel, TabcEditLabel
    ]);

  RegisterPropertyEditor(TypeInfo(string), TabcClockLabel, 'Format', TabcDateTimeFormatProperty);
  RegisterPropertyEditor(TypeInfo(TFont), TabcRotLabel, 'Font', TabcTrueTypeFontProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcVersionInfoItem, 'Key', TabcVersionInfoKeyProperty);
  RegisterComponentEditor(TabcVersionLabel, TabcVersionInfoLabelEditor);

{$IFDEF DELPHI5}

  abcRegisterPropertiesInCategory(TabcRotLabel,
    ['Angle', 'BorderStyle', 'CaptionStyle', 'FocusControl', 'RotateCenter']);

  abcRegisterPropertiesInCategory(TabcClockLabel,
    ['Format', 'Interval']);

  abcRegisterPropertiesInCategory(TabcSuperLabel,
    ['BorderColor', 'BorderStyle', 'BottomMargin', 'LeftMargin', 'RightMargin', 'TopMargin', 'VerticalAlignment']);

  abcRegisterPropertiesInCategory(TabcAutoLabel,
    ['BorderColor', 'BorderStyle', 'Layout', 'Separator', 'TextStyle']);

  abcRegisterPropertiesInCategory(TabcEditLabel,
    ['EditColor', 'EditFont', 'EditParentColor', 'EditParentFont', 'LabelFont', 'LabelHeight', 'LabelOffsetX', 'LabelOffsetY', 'LabelParentFont', 'LabelWidth', 'Layout']);

  abcRegisterPropertiesInCategory(TabcCurrencyLabel,
    ['CurrFractionFormat', 'CurrFractionText', 'CurrText', 'FirstUpperCase', 'HandleException', 'Value']);

  abcRegisterPropertiesInCategory(TabcMultilineLabel,
    ['Layout', 'Lines']);

  abcRegisterPropertiesInCategory(TabcMouseLabel,
    ['Layout', 'MouseDownColor', 'MouseDownEffects', 'MouseOverColor', 'MouseOverEffects', 'SoundDown', 'SoundList', 'SoundOver']);

  abcRegisterPropertiesInCategory(TabcVersionLabel,
    ['DoubleSpaced', 'VersionInfo']);

  abcRegisterPropertiesInCategory(TabcURLLabel,
    ['Layout', 'MouseDownColor', 'MouseDownEffects', 'MouseOverColor', 'MouseOverEffects', 'ShowBrowser', 'SoundDown', 'SoundList', 'SoundOver', 'URL']);

{$ENDIF}

end;

end.
