unit abcreg_k;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC Utils - Component Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

{$R abcr32k.res}

implementation

uses SysUtils, Menus, abcprop, abcexctl, abcutil, abcwtch, abccompf,
     abcpedto, abctitle, abctray, abcidle
     {$IFDEF DELPHI5}, abcpropc, abcpilst, ImgList{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Utils', [
    TabcIdleTimeout,
    TabcTitleGradient, TabcSingleInstance, TabcLauncher, TabcFormSaver, TabcFormSizer,
    TabcStopWatch, TabcMDIScroll,
    TabcFormMessageHook, TabcTrayIcon
    ]);

  RegisterPropertyEditor(TypeInfo(TFileName), TabcStopWatch, 'LogFile', TabcExcepLogFileNameProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TabcFormSaver, 'IniFileName', TabcIniFilenameProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcShellExecParams, 'FileName', TabcOpenFilenameProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcShellExecParams, 'Verb', TabcShellVerbProperty);

  RegisterPropertyEditor(TypeInfo(TPopupMenu), TabcTrayIcon, 'PopupMenu', TabcTrayIconPopupMenuProperty);

{$IFDEF DELPHI5}

  RegisterPropertyEditor(TypeInfo(TImageIndex), TabcTrayIcon, 'ImageIndex', TabcImageIndexProperty);

  abcRegisterPropertiesInCategory(TabcStopWatch,
    ['LogFile', 'LogFormat', 'LogWhen']);

  abcRegisterPropertiesInCategory(TabcMDIScroll,
   ['Enabled']);

  abcRegisterPropertiesInCategory(TabcSingleInstance,
    ['Activate', 'Enabled', 'StopMsg']);

  abcRegisterPropertiesInCategory(TabcLauncher,
    ['Checks', 'CommandLine', 'Continuous', 'Date', 'Interval', 'LaunchType', 'MonthDay', 'ShellParams', 'Time', 'TimeLapse', 'Wait', 'WeekDay', 'WindowState']);

  abcRegisterPropertiesInCategory(TabcFormSaver,
    ['AutoRestore', 'AutoSave', 'IniFileName', 'Options']);

  abcRegisterPropertiesInCategory(TabcFormSizer,
    ['HeightMax', 'HeightMin', 'InitialFormPos', 'InitialFormSize', 'LeftMax', 'LeftMin', 'TopMax', 'TopMin', 'WidthMax', 'WidthMin']);

  abcRegisterPropertiesInCategory(TabcFormMessageHook,
   ['OnMessage']);

{$ENDIF}

end;

end.
