unit abcregbd;

(*------------------------------------------------------------------------------

Advanced Business Components
ABC for Delphi
Version 6

Copyright  1995, 2001 Objective Software Technology Pty Limited ACN 068 640 353
Functionality derived from Delphi VCL Source Code
is Copyright  1995, 2001 Borland Software Corporation

ABC BDE Components - Palette Registration

------------------------------------------------------------------------------*)

{$I abcdefs.inc}

interface

uses Classes, {$IFDEF DELPHI6} DesignIntf {$ELSE} DsgnIntf {$ENDIF};

procedure Register;

implementation

{$R abcr32bd.res}

uses SysUtils, DB, DBTables, BDE, abcprop, abcpropb, abcdbexc,
     abcdbacc, abcdbgrd, abcdabde
     {$IFDEF DELPHI5}, abcpropc{$ENDIF}
     ;

procedure Register;
begin
  RegisterComponents('ABC Data Access', [TabcBDEAdapterReg]);

  RegisterComponents('ABC BDE', [
    TabcDBAppException, TabcDBQryAppException,
    TabcLocalTable, TabcLocalQuery, TabcLocalDatabase, TabcDBIdleTime
    ]);

  RegisterComponentEditor(TabcDBAppException, TabcDBAppExceptionEditor);
  RegisterComponentEditor(TabcDBQryAppException, TabcDBQryAppExceptionEditor);

  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBAppException, 'DatabaseName', TabcAppExcDatabaseNameProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBAppException, 'MsgTableName', TabcMsgTableNameProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBAppException, 'LogTableName', TabcLogTableNameProperty);

  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBQryAppException, 'DatabaseName', TabcAppExcDatabaseNameProperty);

  RegisterPropertyEditor(TypeInfo(string), TabcDBAppException, 'SessionName', TabcAppExcSessionNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBQryAppException, 'SessionName', TabcAppExcSessionNameProperty);

  RegisterComponents('ABC BDE', [
    TabcLocalTable, TabcLocalQuery, TabcLocalDatabase, TabcDBIdleTime
    ]);

  RegisterNoIcon([TabcSubQuery, TabcSubTable, TabcSubDataSource]);

  RegisterComponents('ABC BDE', [
    TabcDBTableGrid, TabcDBQueryGrid
    ]);

  RegisterComponentEditor(TabcDBQueryGrid, TabcDBQueryGridEditor);
  RegisterComponentEditor(TabcDBTableGrid, TabcDBTableGridEditor);

  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBQueryGrid, 'A1DatabaseName', TabcDatabaseNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TabcDBQueryGrid, 'A2SQL', TabcQuerySQLProperty);
  RegisterPropertyEditor(TypeInfo(Boolean), TabcDBQueryGrid, 'A3Active', TabcActiveProperty);
{$IFNDEF VER125}
{$IFNDEF VER110}
  RegisterPropertyEditor(TypeInfo(TParams), TabcDBQueryGrid, 'Params', TabcQueryParamsProperty);
{$ENDIF}
{$ENDIF}
  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBTableGrid, 'A1DatabaseName', TabcDatabaseNameProperty);
  RegisterPropertyEditor(TypeInfo(TFileName), TabcDBTableGrid, 'A2TableName', TabcTableNameProperty);
  RegisterPropertyEditor(TypeInfo(Boolean), TabcDBTableGrid, 'A3Active', TabcActiveProperty);
  RegisterPropertyEditor(TypeInfo(TDataSource), TabcDBTableGrid, 'MasterSource', TabcDataSourceProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTableGrid, 'IndexName', TabcIndexNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TabcDBTableGrid, 'IndexFieldNames', TabcIndexFieldNamesProperty);

{$IFDEF DELPHI5}
  abcRegisterPropertiesInCategory(TabcDBAppException,
    ['ConfirmTerminate', 'ExcepLog', 'ExcepMsg', 'LogTableName', 'MsgTableName', 'Terminate']);

  abcRegisterPropertiesInCategory(TabcDBQryAppException,
    ['ConfirmTerminate', 'ExcepLog', 'ExcepMsg', 'LogSQL', 'MsgSQL', 'Terminate']);

  abcRegisterPropertiesInCategory(TabcLocalTable,
    ['DatabaseName', 'LocalPath']);

  abcRegisterPropertiesInCategory(TabcLocalQuery,
    ['DatabaseName', 'LocalPath']);

  abcRegisterPropertiesInCategory(TabcLocalDatabase,
    ['DatabaseName', 'LocalPath']);

  abcRegisterPropertiesInCategory(TabcDBIdleTime,
   []);

  abcRegisterPropertiesInCategory(TabcDBTableGrid,
    ['A1DatabaseName', 'A2TableName', 'A3Active', 'FixedCols', 'GlyphColor', 'Hints', 'MoveBy', 'NavAlign', 'NavHeight', 'NavSpeed', 'VisibleButtons']);

  abcRegisterPropertiesInCategory(TabcDBQueryGrid,
    ['A1DatabaseName', 'A2SQL', 'A3Active', 'FixedCols', 'GlyphColor', 'Hints', 'MoveBy', 'NavAlign', 'NavHeight', 'NavSpeed', 'VisibleButtons']);

{$ENDIF}

end;

initialization
  RegisterClasses([TabcSubQuery, TabcSubTable, TabcSubDataSource]);

finalization
  UnRegisterClasses([TabcSubQuery, TabcSubTable, TabcSubDataSource]);

end.
